
#include "Study/SystemConfiguration_StrongFirewallsStud/SystemConfiguration_StrongFirewallsStudRangeStudy.h"

//******************************************************
//Global Variables
//******************************************************

//********************************************************
//SystemConfiguration_StrongFirewallsStudRangeStudy Constructor
//********************************************************
SystemConfiguration_StrongFirewallsStudRangeStudy::SystemConfiguration_StrongFirewallsStudRangeStudy() {

  // add all of the experiment names
  mExperimentNames.emplace_back("Experiment 1");
  // define arrays of global variable names and types
  NumGVs = 0;
  NumExps = 1;

  GVNames = new char*[NumGVs];
  GVTypes = new char*[NumGVs];

  // create the arrays to store the values of each gv

  // call methods to assign values to each gv
  SetDefaultMobiusRoot(MOBIUSROOT);
}


//******************************************************
//SystemConfiguration_StrongFirewallsStudRangeStudy Destructor
//******************************************************
SystemConfiguration_StrongFirewallsStudRangeStudy::~SystemConfiguration_StrongFirewallsStudRangeStudy() {
  delete ThePVModel;
}



//******************************************************
//print values of gv (for debugging)
//******************************************************
void SystemConfiguration_StrongFirewallsStudRangeStudy::PrintGlobalValues(int expNum) {
  if (NumGVs == 0) {
    cout<<"There are no global variables."<<endl;
    return;
  }

  SetGVs(expNum);

  cout<<"The Global Variable values for experiment "<<
    GetExpName(expNum)<<" are:"<<endl;
}


//******************************************************
//retrieve the value of a global variable
//******************************************************
void *SystemConfiguration_StrongFirewallsStudRangeStudy::GetGVValue(char *TheGVName) {
  
    cerr<<"!! SystemConfiguration_StrongFirewallsStudRangeStudy::GetGVValue: Global Variable "<<TheGVName<<" does not exist."<<endl;
  return NULL;
}


//******************************************************
//override the value of a global variable
//******************************************************
void SystemConfiguration_StrongFirewallsStudRangeStudy::OverrideGVValue(char *TheGVName,void *TheGVValue) {
  
    cerr<<"!! SystemConfiguration_StrongFirewallsStudRangeStudy::OverrideGVValue: Global Variable "<<TheGVName<<" does not exist."<<endl;
}


//******************************************************
//set the value of all global variables to the given exp
//******************************************************
void SystemConfiguration_StrongFirewallsStudRangeStudy::SetGVs(int expNum) {
BaseStudyClass::SetGVs(expNum);
}


//******************************************************
//static class method called by solvers to create study 
//(and thus create all of the model)
//******************************************************
BaseStudyClass* GlobalStudyPtr = NULL;
BaseStudyClass * GenerateStudy() {
  if (GlobalStudyPtr == NULL)
    GlobalStudyPtr = new SystemConfiguration_StrongFirewallsStudRangeStudy();
  return GlobalStudyPtr;
}

void DestructStudy() {
  delete GlobalStudyPtr;
  GlobalStudyPtr = NULL;
}
//******************************************************
//get and create the PVModel
//******************************************************
PVModel* SystemConfiguration_StrongFirewallsStudRangeStudy::GetPVModel(bool expandTimeArrays) {
  if (ThePVModel!=NULL)
    delete ThePVModel;
  // create the PV model
  ThePVModel=new SystemConfiguration_StrongFirewallsPVsPVModel(expandTimeArrays);
  return ThePVModel;
}


