#ifndef SystemConfiguration_StrongFirewallsADVISE_H_
#define SystemConfiguration_StrongFirewallsADVISE_H_

#include "Simulator/UserDistributions.h"
#include "BaseClasses/GlobalVariables.h"
#include "BaseClasses/PostselectGroup.h"
#include "BaseClasses/PreselectGroup.h"
#include "BaseClasses/atomic/advise/ADVISEModel.h"
#include "BaseClasses/atomic/advise/Access.h"
#include "BaseClasses/atomic/advise/AdversaryDecision.h"
#include "BaseClasses/atomic/advise/BeginAdversaryDecision.h"
#include "BaseClasses/atomic/advise/Goal.h"
#include "BaseClasses/atomic/advise/Knowledge.h"
#include "BaseClasses/atomic/advise/Skill.h"
#include "BaseClasses/atomic/advise/Step.h"
#include "BaseClasses/atomic/advise/StepChosen.h"
#include "BaseClasses/atomic/advise/StepWeight.h"
#include "BaseClasses/atomic/advise/SystemSV.h"
#include <climits>
#include <cmath>
#include <algorithm>
#include <iostream>
extern UserDistributions* TheDistribution;

/*********************************************************************
               SystemConfiguration_StrongFirewallsADVISE Submodel Definition                   
*********************************************************************/

class SystemConfiguration_StrongFirewallsADVISE : public ADVISEModel {
public:

class CorpLAN_GainNetworkAccessViaNetworkNodeAdversaryDecision : public AdversaryDecision {
public:

  BeginAdversaryDecision* MakeDecision;
  short* MakeDecision_Mobius_Mark;
  StepChosen *CorpLAN_GainNetworkAccessViaNetworkNodeChosen;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeChosen_Mobius_Mark;
  StepWeight *CorpLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  double* TheDistributionParameters;

  CorpLAN_GainNetworkAccessViaNetworkNodeAdversaryDecision();
  ~CorpLAN_GainNetworkAccessViaNetworkNodeAdversaryDecision();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass *Fire();
}; // CorpLAN_GainNetworkAccessViaNetworkNodeAdversaryDecision

class CorpLanScadaLanFW_GainUserCredentialsAdversaryDecision : public AdversaryDecision {
public:

  BeginAdversaryDecision* MakeDecision;
  short* MakeDecision_Mobius_Mark;
  StepChosen *CorpLanScadaLanFW_GainUserCredentialsChosen;
  short* CorpLanScadaLanFW_GainUserCredentialsChosen_Mobius_Mark;
  StepWeight *CorpLanScadaLanFW_GainUserCredentialsWeight;
  short* CorpLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  double* TheDistributionParameters;

  CorpLanScadaLanFW_GainUserCredentialsAdversaryDecision();
  ~CorpLanScadaLanFW_GainUserCredentialsAdversaryDecision();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass *Fire();
}; // CorpLanScadaLanFW_GainUserCredentialsAdversaryDecision

class CorpLanEngrLanFW_GainRemoteUIAccessDeviceAdversaryDecision : public AdversaryDecision {
public:

  BeginAdversaryDecision* MakeDecision;
  short* MakeDecision_Mobius_Mark;
  StepChosen *CorpLanEngrLanFW_GainRemoteUIAccessDeviceChosen;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceChosen_Mobius_Mark;
  StepWeight *CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  double* TheDistributionParameters;

  CorpLanEngrLanFW_GainRemoteUIAccessDeviceAdversaryDecision();
  ~CorpLanEngrLanFW_GainRemoteUIAccessDeviceAdversaryDecision();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass *Fire();
}; // CorpLanEngrLanFW_GainRemoteUIAccessDeviceAdversaryDecision

class LinuxOS_GainUserCredentialsAdversaryDecision : public AdversaryDecision {
public:

  BeginAdversaryDecision* MakeDecision;
  short* MakeDecision_Mobius_Mark;
  StepChosen *LinuxOS_GainUserCredentialsChosen;
  short* LinuxOS_GainUserCredentialsChosen_Mobius_Mark;
  StepWeight *LinuxOS_GainUserCredentialsWeight;
  short* LinuxOS_GainUserCredentialsWeight_Mobius_Mark;
  double* TheDistributionParameters;

  LinuxOS_GainUserCredentialsAdversaryDecision();
  ~LinuxOS_GainUserCredentialsAdversaryDecision();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass *Fire();
}; // LinuxOS_GainUserCredentialsAdversaryDecision

class CorpLanScadaLanFW_AdminModifyFWOpenAdversaryDecision : public AdversaryDecision {
public:

  BeginAdversaryDecision* MakeDecision;
  short* MakeDecision_Mobius_Mark;
  StepChosen *CorpLanScadaLanFW_AdminModifyFWOpenChosen;
  short* CorpLanScadaLanFW_AdminModifyFWOpenChosen_Mobius_Mark;
  StepWeight *CorpLanScadaLanFW_AdminModifyFWOpenWeight;
  short* CorpLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  double* TheDistributionParameters;

  CorpLanScadaLanFW_AdminModifyFWOpenAdversaryDecision();
  ~CorpLanScadaLanFW_AdminModifyFWOpenAdversaryDecision();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass *Fire();
}; // CorpLanScadaLanFW_AdminModifyFWOpenAdversaryDecision

class CorpLAN_GainNetworkAccessViaConnectedNetworkAdversaryDecision : public AdversaryDecision {
public:

  BeginAdversaryDecision* MakeDecision;
  short* MakeDecision_Mobius_Mark;
  StepChosen *CorpLAN_GainNetworkAccessViaConnectedNetworkChosen;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkChosen_Mobius_Mark;
  StepWeight *CorpLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  double* TheDistributionParameters;

  CorpLAN_GainNetworkAccessViaConnectedNetworkAdversaryDecision();
  ~CorpLAN_GainNetworkAccessViaConnectedNetworkAdversaryDecision();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass *Fire();
}; // CorpLAN_GainNetworkAccessViaConnectedNetworkAdversaryDecision

class CorpLanEngrLanFW_GainLocalUIAccessDeviceAdversaryDecision : public AdversaryDecision {
public:

  BeginAdversaryDecision* MakeDecision;
  short* MakeDecision_Mobius_Mark;
  StepChosen *CorpLanEngrLanFW_GainLocalUIAccessDeviceChosen;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceChosen_Mobius_Mark;
  StepWeight *CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  double* TheDistributionParameters;

  CorpLanEngrLanFW_GainLocalUIAccessDeviceAdversaryDecision();
  ~CorpLanEngrLanFW_GainLocalUIAccessDeviceAdversaryDecision();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass *Fire();
}; // CorpLanEngrLanFW_GainLocalUIAccessDeviceAdversaryDecision

class EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkAdversaryDecision : public AdversaryDecision {
public:

  BeginAdversaryDecision* MakeDecision;
  short* MakeDecision_Mobius_Mark;
  StepChosen *EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkChosen;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkChosen_Mobius_Mark;
  StepWeight *EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  double* TheDistributionParameters;

  EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkAdversaryDecision();
  ~EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkAdversaryDecision();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass *Fire();
}; // EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkAdversaryDecision

class LinuxOS_GainRemoteUIAccessOSAdversaryDecision : public AdversaryDecision {
public:

  BeginAdversaryDecision* MakeDecision;
  short* MakeDecision_Mobius_Mark;
  StepChosen *LinuxOS_GainRemoteUIAccessOSChosen;
  short* LinuxOS_GainRemoteUIAccessOSChosen_Mobius_Mark;
  StepWeight *LinuxOS_GainRemoteUIAccessOSWeight;
  short* LinuxOS_GainRemoteUIAccessOSWeight_Mobius_Mark;
  double* TheDistributionParameters;

  LinuxOS_GainRemoteUIAccessOSAdversaryDecision();
  ~LinuxOS_GainRemoteUIAccessOSAdversaryDecision();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass *Fire();
}; // LinuxOS_GainRemoteUIAccessOSAdversaryDecision

class SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkAdversaryDecision : public AdversaryDecision {
public:

  BeginAdversaryDecision* MakeDecision;
  short* MakeDecision_Mobius_Mark;
  StepChosen *SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkChosen;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkChosen_Mobius_Mark;
  StepWeight *SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  double* TheDistributionParameters;

  SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkAdversaryDecision();
  ~SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkAdversaryDecision();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass *Fire();
}; // SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkAdversaryDecision

class LinuxOS_GainLocalUIAccessOSAdversaryDecision : public AdversaryDecision {
public:

  BeginAdversaryDecision* MakeDecision;
  short* MakeDecision_Mobius_Mark;
  StepChosen *LinuxOS_GainLocalUIAccessOSChosen;
  short* LinuxOS_GainLocalUIAccessOSChosen_Mobius_Mark;
  StepWeight *LinuxOS_GainLocalUIAccessOSWeight;
  short* LinuxOS_GainLocalUIAccessOSWeight_Mobius_Mark;
  double* TheDistributionParameters;

  LinuxOS_GainLocalUIAccessOSAdversaryDecision();
  ~LinuxOS_GainLocalUIAccessOSAdversaryDecision();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass *Fire();
}; // LinuxOS_GainLocalUIAccessOSAdversaryDecision

class CorpLanScadaLanFW_GainLogicalAccessAdversaryDecision : public AdversaryDecision {
public:

  BeginAdversaryDecision* MakeDecision;
  short* MakeDecision_Mobius_Mark;
  StepChosen *CorpLanScadaLanFW_GainLogicalAccessChosen;
  short* CorpLanScadaLanFW_GainLogicalAccessChosen_Mobius_Mark;
  StepWeight *CorpLanScadaLanFW_GainLogicalAccessWeight;
  short* CorpLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  double* TheDistributionParameters;

  CorpLanScadaLanFW_GainLogicalAccessAdversaryDecision();
  ~CorpLanScadaLanFW_GainLogicalAccessAdversaryDecision();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass *Fire();
}; // CorpLanScadaLanFW_GainLogicalAccessAdversaryDecision

class HMI_GainLocalUIAccessDeviceAdversaryDecision : public AdversaryDecision {
public:

  BeginAdversaryDecision* MakeDecision;
  short* MakeDecision_Mobius_Mark;
  StepChosen *HMI_GainLocalUIAccessDeviceChosen;
  short* HMI_GainLocalUIAccessDeviceChosen_Mobius_Mark;
  StepWeight *HMI_GainLocalUIAccessDeviceWeight;
  short* HMI_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  double* TheDistributionParameters;

  HMI_GainLocalUIAccessDeviceAdversaryDecision();
  ~HMI_GainLocalUIAccessDeviceAdversaryDecision();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass *Fire();
}; // HMI_GainLocalUIAccessDeviceAdversaryDecision

class EngrLanScadaLanFW_GainRemoteUIAccessDeviceAdversaryDecision : public AdversaryDecision {
public:

  BeginAdversaryDecision* MakeDecision;
  short* MakeDecision_Mobius_Mark;
  StepChosen *EngrLanScadaLanFW_GainRemoteUIAccessDeviceChosen;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceChosen_Mobius_Mark;
  StepWeight *EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  double* TheDistributionParameters;

  EngrLanScadaLanFW_GainRemoteUIAccessDeviceAdversaryDecision();
  ~EngrLanScadaLanFW_GainRemoteUIAccessDeviceAdversaryDecision();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass *Fire();
}; // EngrLanScadaLanFW_GainRemoteUIAccessDeviceAdversaryDecision

class EngrLanScadaLanFW_CircumventFWRulesAdversaryDecision : public AdversaryDecision {
public:

  BeginAdversaryDecision* MakeDecision;
  short* MakeDecision_Mobius_Mark;
  StepChosen *EngrLanScadaLanFW_CircumventFWRulesChosen;
  short* EngrLanScadaLanFW_CircumventFWRulesChosen_Mobius_Mark;
  StepWeight *EngrLanScadaLanFW_CircumventFWRulesWeight;
  short* EngrLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  double* TheDistributionParameters;

  EngrLanScadaLanFW_CircumventFWRulesAdversaryDecision();
  ~EngrLanScadaLanFW_CircumventFWRulesAdversaryDecision();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass *Fire();
}; // EngrLanScadaLanFW_CircumventFWRulesAdversaryDecision

class SCADALAN_GainNetworkAccessViaNetworkNodeAdversaryDecision : public AdversaryDecision {
public:

  BeginAdversaryDecision* MakeDecision;
  short* MakeDecision_Mobius_Mark;
  StepChosen *SCADALAN_GainNetworkAccessViaNetworkNodeChosen;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeChosen_Mobius_Mark;
  StepWeight *SCADALAN_GainNetworkAccessViaNetworkNodeWeight;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  double* TheDistributionParameters;

  SCADALAN_GainNetworkAccessViaNetworkNodeAdversaryDecision();
  ~SCADALAN_GainNetworkAccessViaNetworkNodeAdversaryDecision();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass *Fire();
}; // SCADALAN_GainNetworkAccessViaNetworkNodeAdversaryDecision

class CorpLanEngrLanFW_CircumventFWRulesAdversaryDecision : public AdversaryDecision {
public:

  BeginAdversaryDecision* MakeDecision;
  short* MakeDecision_Mobius_Mark;
  StepChosen *CorpLanEngrLanFW_CircumventFWRulesChosen;
  short* CorpLanEngrLanFW_CircumventFWRulesChosen_Mobius_Mark;
  StepWeight *CorpLanEngrLanFW_CircumventFWRulesWeight;
  short* CorpLanEngrLanFW_CircumventFWRulesWeight_Mobius_Mark;
  double* TheDistributionParameters;

  CorpLanEngrLanFW_CircumventFWRulesAdversaryDecision();
  ~CorpLanEngrLanFW_CircumventFWRulesAdversaryDecision();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass *Fire();
}; // CorpLanEngrLanFW_CircumventFWRulesAdversaryDecision

class EngrLanScadaLanFW_GainUserCredentialsAdversaryDecision : public AdversaryDecision {
public:

  BeginAdversaryDecision* MakeDecision;
  short* MakeDecision_Mobius_Mark;
  StepChosen *EngrLanScadaLanFW_GainUserCredentialsChosen;
  short* EngrLanScadaLanFW_GainUserCredentialsChosen_Mobius_Mark;
  StepWeight *EngrLanScadaLanFW_GainUserCredentialsWeight;
  short* EngrLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  double* TheDistributionParameters;

  EngrLanScadaLanFW_GainUserCredentialsAdversaryDecision();
  ~EngrLanScadaLanFW_GainUserCredentialsAdversaryDecision();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass *Fire();
}; // EngrLanScadaLanFW_GainUserCredentialsAdversaryDecision

class DoNothingAdversaryDecision : public AdversaryDecision {
public:

  BeginAdversaryDecision* MakeDecision;
  short* MakeDecision_Mobius_Mark;
  StepChosen *DoNothingChosen;
  short* DoNothingChosen_Mobius_Mark;
  StepWeight *DoNothingWeight;
  short* DoNothingWeight_Mobius_Mark;
  double* TheDistributionParameters;

  DoNothingAdversaryDecision();
  ~DoNothingAdversaryDecision();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass *Fire();
}; // DoNothingAdversaryDecision

class SSHServer_GainLogicalAccessAdversaryDecision : public AdversaryDecision {
public:

  BeginAdversaryDecision* MakeDecision;
  short* MakeDecision_Mobius_Mark;
  StepChosen *SSHServer_GainLogicalAccessChosen;
  short* SSHServer_GainLogicalAccessChosen_Mobius_Mark;
  StepWeight *SSHServer_GainLogicalAccessWeight;
  short* SSHServer_GainLogicalAccessWeight_Mobius_Mark;
  double* TheDistributionParameters;

  SSHServer_GainLogicalAccessAdversaryDecision();
  ~SSHServer_GainLogicalAccessAdversaryDecision();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass *Fire();
}; // SSHServer_GainLogicalAccessAdversaryDecision

class CorpLanEngrLanFW_GainUserCredentialsAdversaryDecision : public AdversaryDecision {
public:

  BeginAdversaryDecision* MakeDecision;
  short* MakeDecision_Mobius_Mark;
  StepChosen *CorpLanEngrLanFW_GainUserCredentialsChosen;
  short* CorpLanEngrLanFW_GainUserCredentialsChosen_Mobius_Mark;
  StepWeight *CorpLanEngrLanFW_GainUserCredentialsWeight;
  short* CorpLanEngrLanFW_GainUserCredentialsWeight_Mobius_Mark;
  double* TheDistributionParameters;

  CorpLanEngrLanFW_GainUserCredentialsAdversaryDecision();
  ~CorpLanEngrLanFW_GainUserCredentialsAdversaryDecision();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass *Fire();
}; // CorpLanEngrLanFW_GainUserCredentialsAdversaryDecision

class HMI_GainLogicalAccessAdversaryDecision : public AdversaryDecision {
public:

  BeginAdversaryDecision* MakeDecision;
  short* MakeDecision_Mobius_Mark;
  StepChosen *HMI_GainLogicalAccessChosen;
  short* HMI_GainLogicalAccessChosen_Mobius_Mark;
  StepWeight *HMI_GainLogicalAccessWeight;
  short* HMI_GainLogicalAccessWeight_Mobius_Mark;
  double* TheDistributionParameters;

  HMI_GainLogicalAccessAdversaryDecision();
  ~HMI_GainLogicalAccessAdversaryDecision();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass *Fire();
}; // HMI_GainLogicalAccessAdversaryDecision

class EngrWorkstation_GainUserCredentialsAdversaryDecision : public AdversaryDecision {
public:

  BeginAdversaryDecision* MakeDecision;
  short* MakeDecision_Mobius_Mark;
  StepChosen *EngrWorkstation_GainUserCredentialsChosen;
  short* EngrWorkstation_GainUserCredentialsChosen_Mobius_Mark;
  StepWeight *EngrWorkstation_GainUserCredentialsWeight;
  short* EngrWorkstation_GainUserCredentialsWeight_Mobius_Mark;
  double* TheDistributionParameters;

  EngrWorkstation_GainUserCredentialsAdversaryDecision();
  ~EngrWorkstation_GainUserCredentialsAdversaryDecision();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass *Fire();
}; // EngrWorkstation_GainUserCredentialsAdversaryDecision

class EngrLAN_GainNetworkAccessViaConnectedNetworkAdversaryDecision : public AdversaryDecision {
public:

  BeginAdversaryDecision* MakeDecision;
  short* MakeDecision_Mobius_Mark;
  StepChosen *EngrLAN_GainNetworkAccessViaConnectedNetworkChosen;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkChosen_Mobius_Mark;
  StepWeight *EngrLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  double* TheDistributionParameters;

  EngrLAN_GainNetworkAccessViaConnectedNetworkAdversaryDecision();
  ~EngrLAN_GainNetworkAccessViaConnectedNetworkAdversaryDecision();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass *Fire();
}; // EngrLAN_GainNetworkAccessViaConnectedNetworkAdversaryDecision

class EngrWorkstation_GainLogicalAccessAdversaryDecision : public AdversaryDecision {
public:

  BeginAdversaryDecision* MakeDecision;
  short* MakeDecision_Mobius_Mark;
  StepChosen *EngrWorkstation_GainLogicalAccessChosen;
  short* EngrWorkstation_GainLogicalAccessChosen_Mobius_Mark;
  StepWeight *EngrWorkstation_GainLogicalAccessWeight;
  short* EngrWorkstation_GainLogicalAccessWeight_Mobius_Mark;
  double* TheDistributionParameters;

  EngrWorkstation_GainLogicalAccessAdversaryDecision();
  ~EngrWorkstation_GainLogicalAccessAdversaryDecision();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass *Fire();
}; // EngrWorkstation_GainLogicalAccessAdversaryDecision

class CorpLanEngrLanFW_AdminModifyFWOpenAdversaryDecision : public AdversaryDecision {
public:

  BeginAdversaryDecision* MakeDecision;
  short* MakeDecision_Mobius_Mark;
  StepChosen *CorpLanEngrLanFW_AdminModifyFWOpenChosen;
  short* CorpLanEngrLanFW_AdminModifyFWOpenChosen_Mobius_Mark;
  StepWeight *CorpLanEngrLanFW_AdminModifyFWOpenWeight;
  short* CorpLanEngrLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  double* TheDistributionParameters;

  CorpLanEngrLanFW_AdminModifyFWOpenAdversaryDecision();
  ~CorpLanEngrLanFW_AdminModifyFWOpenAdversaryDecision();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass *Fire();
}; // CorpLanEngrLanFW_AdminModifyFWOpenAdversaryDecision

class EngrWorkstation_GainLocalUIAccessDeviceAdversaryDecision : public AdversaryDecision {
public:

  BeginAdversaryDecision* MakeDecision;
  short* MakeDecision_Mobius_Mark;
  StepChosen *EngrWorkstation_GainLocalUIAccessDeviceChosen;
  short* EngrWorkstation_GainLocalUIAccessDeviceChosen_Mobius_Mark;
  StepWeight *EngrWorkstation_GainLocalUIAccessDeviceWeight;
  short* EngrWorkstation_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  double* TheDistributionParameters;

  EngrWorkstation_GainLocalUIAccessDeviceAdversaryDecision();
  ~EngrWorkstation_GainLocalUIAccessDeviceAdversaryDecision();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass *Fire();
}; // EngrWorkstation_GainLocalUIAccessDeviceAdversaryDecision

class SSHServer_GainUserCredentialsAdversaryDecision : public AdversaryDecision {
public:

  BeginAdversaryDecision* MakeDecision;
  short* MakeDecision_Mobius_Mark;
  StepChosen *SSHServer_GainUserCredentialsChosen;
  short* SSHServer_GainUserCredentialsChosen_Mobius_Mark;
  StepWeight *SSHServer_GainUserCredentialsWeight;
  short* SSHServer_GainUserCredentialsWeight_Mobius_Mark;
  double* TheDistributionParameters;

  SSHServer_GainUserCredentialsAdversaryDecision();
  ~SSHServer_GainUserCredentialsAdversaryDecision();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass *Fire();
}; // SSHServer_GainUserCredentialsAdversaryDecision

class HMI_GainUserCredentialsAdversaryDecision : public AdversaryDecision {
public:

  BeginAdversaryDecision* MakeDecision;
  short* MakeDecision_Mobius_Mark;
  StepChosen *HMI_GainUserCredentialsChosen;
  short* HMI_GainUserCredentialsChosen_Mobius_Mark;
  StepWeight *HMI_GainUserCredentialsWeight;
  short* HMI_GainUserCredentialsWeight_Mobius_Mark;
  double* TheDistributionParameters;

  HMI_GainUserCredentialsAdversaryDecision();
  ~HMI_GainUserCredentialsAdversaryDecision();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass *Fire();
}; // HMI_GainUserCredentialsAdversaryDecision

class CorpLAN_PlaceRogueHostOnNetworkAdversaryDecision : public AdversaryDecision {
public:

  BeginAdversaryDecision* MakeDecision;
  short* MakeDecision_Mobius_Mark;
  StepChosen *CorpLAN_PlaceRogueHostOnNetworkChosen;
  short* CorpLAN_PlaceRogueHostOnNetworkChosen_Mobius_Mark;
  StepWeight *CorpLAN_PlaceRogueHostOnNetworkWeight;
  short* CorpLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  double* TheDistributionParameters;

  CorpLAN_PlaceRogueHostOnNetworkAdversaryDecision();
  ~CorpLAN_PlaceRogueHostOnNetworkAdversaryDecision();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass *Fire();
}; // CorpLAN_PlaceRogueHostOnNetworkAdversaryDecision

class CorpLanEngrLanFW_GainLogicalAccessAdversaryDecision : public AdversaryDecision {
public:

  BeginAdversaryDecision* MakeDecision;
  short* MakeDecision_Mobius_Mark;
  StepChosen *CorpLanEngrLanFW_GainLogicalAccessChosen;
  short* CorpLanEngrLanFW_GainLogicalAccessChosen_Mobius_Mark;
  StepWeight *CorpLanEngrLanFW_GainLogicalAccessWeight;
  short* CorpLanEngrLanFW_GainLogicalAccessWeight_Mobius_Mark;
  double* TheDistributionParameters;

  CorpLanEngrLanFW_GainLogicalAccessAdversaryDecision();
  ~CorpLanEngrLanFW_GainLogicalAccessAdversaryDecision();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass *Fire();
}; // CorpLanEngrLanFW_GainLogicalAccessAdversaryDecision

class CorpLanScadaLanFW_GainRemoteUIAccessDeviceAdversaryDecision : public AdversaryDecision {
public:

  BeginAdversaryDecision* MakeDecision;
  short* MakeDecision_Mobius_Mark;
  StepChosen *CorpLanScadaLanFW_GainRemoteUIAccessDeviceChosen;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceChosen_Mobius_Mark;
  StepWeight *CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  double* TheDistributionParameters;

  CorpLanScadaLanFW_GainRemoteUIAccessDeviceAdversaryDecision();
  ~CorpLanScadaLanFW_GainRemoteUIAccessDeviceAdversaryDecision();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass *Fire();
}; // CorpLanScadaLanFW_GainRemoteUIAccessDeviceAdversaryDecision

class EngrLAN_PlaceRogueHostOnNetworkAdversaryDecision : public AdversaryDecision {
public:

  BeginAdversaryDecision* MakeDecision;
  short* MakeDecision_Mobius_Mark;
  StepChosen *EngrLAN_PlaceRogueHostOnNetworkChosen;
  short* EngrLAN_PlaceRogueHostOnNetworkChosen_Mobius_Mark;
  StepWeight *EngrLAN_PlaceRogueHostOnNetworkWeight;
  short* EngrLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  double* TheDistributionParameters;

  EngrLAN_PlaceRogueHostOnNetworkAdversaryDecision();
  ~EngrLAN_PlaceRogueHostOnNetworkAdversaryDecision();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass *Fire();
}; // EngrLAN_PlaceRogueHostOnNetworkAdversaryDecision

class EngrLanScadaLanFW_AdminModifyFWOpenAdversaryDecision : public AdversaryDecision {
public:

  BeginAdversaryDecision* MakeDecision;
  short* MakeDecision_Mobius_Mark;
  StepChosen *EngrLanScadaLanFW_AdminModifyFWOpenChosen;
  short* EngrLanScadaLanFW_AdminModifyFWOpenChosen_Mobius_Mark;
  StepWeight *EngrLanScadaLanFW_AdminModifyFWOpenWeight;
  short* EngrLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  double* TheDistributionParameters;

  EngrLanScadaLanFW_AdminModifyFWOpenAdversaryDecision();
  ~EngrLanScadaLanFW_AdminModifyFWOpenAdversaryDecision();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass *Fire();
}; // EngrLanScadaLanFW_AdminModifyFWOpenAdversaryDecision

class EngrLAN_GainNetworkAccessViaNetworkNodeAdversaryDecision : public AdversaryDecision {
public:

  BeginAdversaryDecision* MakeDecision;
  short* MakeDecision_Mobius_Mark;
  StepChosen *EngrLAN_GainNetworkAccessViaNetworkNodeChosen;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeChosen_Mobius_Mark;
  StepWeight *EngrLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  double* TheDistributionParameters;

  EngrLAN_GainNetworkAccessViaNetworkNodeAdversaryDecision();
  ~EngrLAN_GainNetworkAccessViaNetworkNodeAdversaryDecision();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass *Fire();
}; // EngrLAN_GainNetworkAccessViaNetworkNodeAdversaryDecision

class LinuxOS_GainLogicalAccessAdversaryDecision : public AdversaryDecision {
public:

  BeginAdversaryDecision* MakeDecision;
  short* MakeDecision_Mobius_Mark;
  StepChosen *LinuxOS_GainLogicalAccessChosen;
  short* LinuxOS_GainLogicalAccessChosen_Mobius_Mark;
  StepWeight *LinuxOS_GainLogicalAccessWeight;
  short* LinuxOS_GainLogicalAccessWeight_Mobius_Mark;
  double* TheDistributionParameters;

  LinuxOS_GainLogicalAccessAdversaryDecision();
  ~LinuxOS_GainLogicalAccessAdversaryDecision();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass *Fire();
}; // LinuxOS_GainLogicalAccessAdversaryDecision

class SCADALAN_PlaceRogueHostOnNetworkAdversaryDecision : public AdversaryDecision {
public:

  BeginAdversaryDecision* MakeDecision;
  short* MakeDecision_Mobius_Mark;
  StepChosen *SCADALAN_PlaceRogueHostOnNetworkChosen;
  short* SCADALAN_PlaceRogueHostOnNetworkChosen_Mobius_Mark;
  StepWeight *SCADALAN_PlaceRogueHostOnNetworkWeight;
  short* SCADALAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  double* TheDistributionParameters;

  SCADALAN_PlaceRogueHostOnNetworkAdversaryDecision();
  ~SCADALAN_PlaceRogueHostOnNetworkAdversaryDecision();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass *Fire();
}; // SCADALAN_PlaceRogueHostOnNetworkAdversaryDecision

class EngrLanScadaLanFW_GainLocalUIAccessDeviceAdversaryDecision : public AdversaryDecision {
public:

  BeginAdversaryDecision* MakeDecision;
  short* MakeDecision_Mobius_Mark;
  StepChosen *EngrLanScadaLanFW_GainLocalUIAccessDeviceChosen;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceChosen_Mobius_Mark;
  StepWeight *EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  double* TheDistributionParameters;

  EngrLanScadaLanFW_GainLocalUIAccessDeviceAdversaryDecision();
  ~EngrLanScadaLanFW_GainLocalUIAccessDeviceAdversaryDecision();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass *Fire();
}; // EngrLanScadaLanFW_GainLocalUIAccessDeviceAdversaryDecision

class EngrWorkstation_GainRemoteUIAccessDeviceAdversaryDecision : public AdversaryDecision {
public:

  BeginAdversaryDecision* MakeDecision;
  short* MakeDecision_Mobius_Mark;
  StepChosen *EngrWorkstation_GainRemoteUIAccessDeviceChosen;
  short* EngrWorkstation_GainRemoteUIAccessDeviceChosen_Mobius_Mark;
  StepWeight *EngrWorkstation_GainRemoteUIAccessDeviceWeight;
  short* EngrWorkstation_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  double* TheDistributionParameters;

  EngrWorkstation_GainRemoteUIAccessDeviceAdversaryDecision();
  ~EngrWorkstation_GainRemoteUIAccessDeviceAdversaryDecision();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass *Fire();
}; // EngrWorkstation_GainRemoteUIAccessDeviceAdversaryDecision

class EngrLanScadaLanFW_GainLogicalAccessAdversaryDecision : public AdversaryDecision {
public:

  BeginAdversaryDecision* MakeDecision;
  short* MakeDecision_Mobius_Mark;
  StepChosen *EngrLanScadaLanFW_GainLogicalAccessChosen;
  short* EngrLanScadaLanFW_GainLogicalAccessChosen_Mobius_Mark;
  StepWeight *EngrLanScadaLanFW_GainLogicalAccessWeight;
  short* EngrLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  double* TheDistributionParameters;

  EngrLanScadaLanFW_GainLogicalAccessAdversaryDecision();
  ~EngrLanScadaLanFW_GainLogicalAccessAdversaryDecision();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass *Fire();
}; // EngrLanScadaLanFW_GainLogicalAccessAdversaryDecision

class CorpLanScadaLanFW_CircumventFWRulesAdversaryDecision : public AdversaryDecision {
public:

  BeginAdversaryDecision* MakeDecision;
  short* MakeDecision_Mobius_Mark;
  StepChosen *CorpLanScadaLanFW_CircumventFWRulesChosen;
  short* CorpLanScadaLanFW_CircumventFWRulesChosen_Mobius_Mark;
  StepWeight *CorpLanScadaLanFW_CircumventFWRulesWeight;
  short* CorpLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  double* TheDistributionParameters;

  CorpLanScadaLanFW_CircumventFWRulesAdversaryDecision();
  ~CorpLanScadaLanFW_CircumventFWRulesAdversaryDecision();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass *Fire();
}; // CorpLanScadaLanFW_CircumventFWRulesAdversaryDecision

class HMI_GainRemoteUIAccessDeviceAdversaryDecision : public AdversaryDecision {
public:

  BeginAdversaryDecision* MakeDecision;
  short* MakeDecision_Mobius_Mark;
  StepChosen *HMI_GainRemoteUIAccessDeviceChosen;
  short* HMI_GainRemoteUIAccessDeviceChosen_Mobius_Mark;
  StepWeight *HMI_GainRemoteUIAccessDeviceWeight;
  short* HMI_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  double* TheDistributionParameters;

  HMI_GainRemoteUIAccessDeviceAdversaryDecision();
  ~HMI_GainRemoteUIAccessDeviceAdversaryDecision();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass *Fire();
}; // HMI_GainRemoteUIAccessDeviceAdversaryDecision

class SCADALAN_GainNetworkAccessViaConnectedNetworkAdversaryDecision : public AdversaryDecision {
public:

  BeginAdversaryDecision* MakeDecision;
  short* MakeDecision_Mobius_Mark;
  StepChosen *SCADALAN_GainNetworkAccessViaConnectedNetworkChosen;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkChosen_Mobius_Mark;
  StepWeight *SCADALAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  double* TheDistributionParameters;

  SCADALAN_GainNetworkAccessViaConnectedNetworkAdversaryDecision();
  ~SCADALAN_GainNetworkAccessViaConnectedNetworkAdversaryDecision();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass *Fire();
}; // SCADALAN_GainNetworkAccessViaConnectedNetworkAdversaryDecision

class CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkAdversaryDecision : public AdversaryDecision {
public:

  BeginAdversaryDecision* MakeDecision;
  short* MakeDecision_Mobius_Mark;
  StepChosen *CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkChosen;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkChosen_Mobius_Mark;
  StepWeight *CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  double* TheDistributionParameters;

  CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkAdversaryDecision();
  ~CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkAdversaryDecision();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass *Fire();
}; // CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkAdversaryDecision

class CorpLanScadaLanFW_GainLocalUIAccessDeviceAdversaryDecision : public AdversaryDecision {
public:

  BeginAdversaryDecision* MakeDecision;
  short* MakeDecision_Mobius_Mark;
  StepChosen *CorpLanScadaLanFW_GainLocalUIAccessDeviceChosen;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceChosen_Mobius_Mark;
  StepWeight *CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  double* TheDistributionParameters;

  CorpLanScadaLanFW_GainLocalUIAccessDeviceAdversaryDecision();
  ~CorpLanScadaLanFW_GainLocalUIAccessDeviceAdversaryDecision();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass *Fire();
}; // CorpLanScadaLanFW_GainLocalUIAccessDeviceAdversaryDecision

class CorpLAN_GainNetworkAccessViaNetworkNodeFailureStep : public Step {
public:

  Access* CorpLAN_NetworkAccess;
  short* CorpLAN_NetworkAccess_Mobius_Mark;
  Skill* NetworkPenetration;
  short* NetworkPenetration_Mobius_Mark;
  SystemSV<float>* CorpLAN_networkAnomalyDetectionStrength;
  float* CorpLAN_networkAnomalyDetectionStrength_Mobius_Mark;
  Skill* BasicCyberOffense;
  short* BasicCyberOffense_Mobius_Mark;
  SystemSV<float>* cyberAttackAttribution;
  float* cyberAttackAttribution_Mobius_Mark;
  Access* CorpLanScadaLanFW_LogicalAccess;
  short* CorpLanScadaLanFW_LogicalAccess_Mobius_Mark;
  Access* CorpLanEngrLanFW_LogicalAccess;
  short* CorpLanEngrLanFW_LogicalAccess_Mobius_Mark;
  StepChosen* CorpLAN_GainNetworkAccessViaNetworkNodeChosen;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeChosen_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainUserCredentialsWeight;
  short* CorpLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainUserCredentialsWeight;
  short* LinuxOS_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_AdminModifyFWOpenWeight;
  short* CorpLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainRemoteUIAccessOSWeight;
  short* LinuxOS_GainRemoteUIAccessOSWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLocalUIAccessOSWeight;
  short* LinuxOS_GainLocalUIAccessOSWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLogicalAccessWeight;
  short* CorpLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* HMI_GainLocalUIAccessDeviceWeight;
  short* HMI_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_CircumventFWRulesWeight;
  short* EngrLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNetworkNodeWeight;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_CircumventFWRulesWeight;
  short* CorpLanEngrLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainUserCredentialsWeight;
  short* EngrLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* DoNothingWeight;
  short* DoNothingWeight_Mobius_Mark;
  StepWeight* SSHServer_GainLogicalAccessWeight;
  short* SSHServer_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainUserCredentialsWeight;
  short* CorpLanEngrLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainLogicalAccessWeight;
  short* HMI_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainUserCredentialsWeight;
  short* EngrWorkstation_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLogicalAccessWeight;
  short* EngrWorkstation_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_AdminModifyFWOpenWeight;
  short* CorpLanEngrLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLocalUIAccessDeviceWeight;
  short* EngrWorkstation_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SSHServer_GainUserCredentialsWeight;
  short* SSHServer_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainUserCredentialsWeight;
  short* HMI_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLAN_PlaceRogueHostOnNetworkWeight;
  short* CorpLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLogicalAccessWeight;
  short* CorpLanEngrLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_PlaceRogueHostOnNetworkWeight;
  short* EngrLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_AdminModifyFWOpenWeight;
  short* EngrLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLogicalAccessWeight;
  short* LinuxOS_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* SCADALAN_PlaceRogueHostOnNetworkWeight;
  short* SCADALAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainRemoteUIAccessDeviceWeight;
  short* EngrWorkstation_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLogicalAccessWeight;
  short* EngrLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_CircumventFWRulesWeight;
  short* CorpLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* HMI_GainRemoteUIAccessDeviceWeight;
  short* HMI_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short* MakeDecision_Mobius_Mark;
  double* TheDistributionParameters;

  CorpLAN_GainNetworkAccessViaNetworkNodeFailureStep();
  ~CorpLAN_GainNetworkAccessViaNetworkNodeFailureStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  double timeDistributionParameter1();
  bool preconditionsMet();
  void executeEffects();
}; // CorpLAN_GainNetworkAccessViaNetworkNodeFailureStep

class CorpLAN_GainNetworkAccessViaNetworkNodeSuccessStep : public Step {
public:

  Access* CorpLAN_NetworkAccess;
  short* CorpLAN_NetworkAccess_Mobius_Mark;
  Skill* NetworkPenetration;
  short* NetworkPenetration_Mobius_Mark;
  SystemSV<float>* CorpLAN_networkAnomalyDetectionStrength;
  float* CorpLAN_networkAnomalyDetectionStrength_Mobius_Mark;
  Skill* BasicCyberOffense;
  short* BasicCyberOffense_Mobius_Mark;
  SystemSV<float>* cyberAttackAttribution;
  float* cyberAttackAttribution_Mobius_Mark;
  Access* CorpLanScadaLanFW_LogicalAccess;
  short* CorpLanScadaLanFW_LogicalAccess_Mobius_Mark;
  Access* CorpLanEngrLanFW_LogicalAccess;
  short* CorpLanEngrLanFW_LogicalAccess_Mobius_Mark;
  StepChosen* CorpLAN_GainNetworkAccessViaNetworkNodeChosen;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeChosen_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainUserCredentialsWeight;
  short* CorpLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainUserCredentialsWeight;
  short* LinuxOS_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_AdminModifyFWOpenWeight;
  short* CorpLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainRemoteUIAccessOSWeight;
  short* LinuxOS_GainRemoteUIAccessOSWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLocalUIAccessOSWeight;
  short* LinuxOS_GainLocalUIAccessOSWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLogicalAccessWeight;
  short* CorpLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* HMI_GainLocalUIAccessDeviceWeight;
  short* HMI_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_CircumventFWRulesWeight;
  short* EngrLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNetworkNodeWeight;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_CircumventFWRulesWeight;
  short* CorpLanEngrLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainUserCredentialsWeight;
  short* EngrLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* DoNothingWeight;
  short* DoNothingWeight_Mobius_Mark;
  StepWeight* SSHServer_GainLogicalAccessWeight;
  short* SSHServer_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainUserCredentialsWeight;
  short* CorpLanEngrLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainLogicalAccessWeight;
  short* HMI_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainUserCredentialsWeight;
  short* EngrWorkstation_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLogicalAccessWeight;
  short* EngrWorkstation_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_AdminModifyFWOpenWeight;
  short* CorpLanEngrLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLocalUIAccessDeviceWeight;
  short* EngrWorkstation_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SSHServer_GainUserCredentialsWeight;
  short* SSHServer_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainUserCredentialsWeight;
  short* HMI_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLAN_PlaceRogueHostOnNetworkWeight;
  short* CorpLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLogicalAccessWeight;
  short* CorpLanEngrLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_PlaceRogueHostOnNetworkWeight;
  short* EngrLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_AdminModifyFWOpenWeight;
  short* EngrLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLogicalAccessWeight;
  short* LinuxOS_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* SCADALAN_PlaceRogueHostOnNetworkWeight;
  short* SCADALAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainRemoteUIAccessDeviceWeight;
  short* EngrWorkstation_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLogicalAccessWeight;
  short* EngrLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_CircumventFWRulesWeight;
  short* CorpLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* HMI_GainRemoteUIAccessDeviceWeight;
  short* HMI_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short* MakeDecision_Mobius_Mark;
  double* TheDistributionParameters;

  CorpLAN_GainNetworkAccessViaNetworkNodeSuccessStep();
  ~CorpLAN_GainNetworkAccessViaNetworkNodeSuccessStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  double timeDistributionParameter1();
  bool preconditionsMet();
  void executeEffects();
}; // CorpLAN_GainNetworkAccessViaNetworkNodeSuccessStep

class CorpLanScadaLanFW_GainUserCredentialsFailureStep : public Step {
public:

  Access* CorpLanScadaLanFW_HasUserCredentials;
  short* CorpLanScadaLanFW_HasUserCredentials_Mobius_Mark;
  Skill* BasicCyberOffense;
  short* BasicCyberOffense_Mobius_Mark;
  SystemSV<char>* CorpLanScadaLanFW_userAuthenticationType;
  char* CorpLanScadaLanFW_userAuthenticationType_Mobius_Mark;
  SystemSV<float>* CorpLanScadaLanFW_strengthOfUserAuthentication;
  float* CorpLanScadaLanFW_strengthOfUserAuthentication_Mobius_Mark;
  StepChosen* CorpLanScadaLanFW_GainUserCredentialsChosen;
  short* CorpLanScadaLanFW_GainUserCredentialsChosen_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainUserCredentialsWeight;
  short* CorpLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainUserCredentialsWeight;
  short* LinuxOS_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_AdminModifyFWOpenWeight;
  short* CorpLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainRemoteUIAccessOSWeight;
  short* LinuxOS_GainRemoteUIAccessOSWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLocalUIAccessOSWeight;
  short* LinuxOS_GainLocalUIAccessOSWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLogicalAccessWeight;
  short* CorpLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* HMI_GainLocalUIAccessDeviceWeight;
  short* HMI_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_CircumventFWRulesWeight;
  short* EngrLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNetworkNodeWeight;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_CircumventFWRulesWeight;
  short* CorpLanEngrLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainUserCredentialsWeight;
  short* EngrLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* DoNothingWeight;
  short* DoNothingWeight_Mobius_Mark;
  StepWeight* SSHServer_GainLogicalAccessWeight;
  short* SSHServer_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainUserCredentialsWeight;
  short* CorpLanEngrLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainLogicalAccessWeight;
  short* HMI_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainUserCredentialsWeight;
  short* EngrWorkstation_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLogicalAccessWeight;
  short* EngrWorkstation_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_AdminModifyFWOpenWeight;
  short* CorpLanEngrLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLocalUIAccessDeviceWeight;
  short* EngrWorkstation_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SSHServer_GainUserCredentialsWeight;
  short* SSHServer_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainUserCredentialsWeight;
  short* HMI_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLAN_PlaceRogueHostOnNetworkWeight;
  short* CorpLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLogicalAccessWeight;
  short* CorpLanEngrLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_PlaceRogueHostOnNetworkWeight;
  short* EngrLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_AdminModifyFWOpenWeight;
  short* EngrLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLogicalAccessWeight;
  short* LinuxOS_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* SCADALAN_PlaceRogueHostOnNetworkWeight;
  short* SCADALAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainRemoteUIAccessDeviceWeight;
  short* EngrWorkstation_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLogicalAccessWeight;
  short* EngrLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_CircumventFWRulesWeight;
  short* CorpLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* HMI_GainRemoteUIAccessDeviceWeight;
  short* HMI_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short* MakeDecision_Mobius_Mark;
  double* TheDistributionParameters;

  CorpLanScadaLanFW_GainUserCredentialsFailureStep();
  ~CorpLanScadaLanFW_GainUserCredentialsFailureStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  double timeDistributionParameter1();
  bool preconditionsMet();
  void executeEffects();
}; // CorpLanScadaLanFW_GainUserCredentialsFailureStep

class CorpLanScadaLanFW_GainUserCredentialsSuccessStep : public Step {
public:

  Access* CorpLanScadaLanFW_HasUserCredentials;
  short* CorpLanScadaLanFW_HasUserCredentials_Mobius_Mark;
  Skill* BasicCyberOffense;
  short* BasicCyberOffense_Mobius_Mark;
  SystemSV<char>* CorpLanScadaLanFW_userAuthenticationType;
  char* CorpLanScadaLanFW_userAuthenticationType_Mobius_Mark;
  SystemSV<float>* CorpLanScadaLanFW_strengthOfUserAuthentication;
  float* CorpLanScadaLanFW_strengthOfUserAuthentication_Mobius_Mark;
  StepChosen* CorpLanScadaLanFW_GainUserCredentialsChosen;
  short* CorpLanScadaLanFW_GainUserCredentialsChosen_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainUserCredentialsWeight;
  short* CorpLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainUserCredentialsWeight;
  short* LinuxOS_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_AdminModifyFWOpenWeight;
  short* CorpLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainRemoteUIAccessOSWeight;
  short* LinuxOS_GainRemoteUIAccessOSWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLocalUIAccessOSWeight;
  short* LinuxOS_GainLocalUIAccessOSWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLogicalAccessWeight;
  short* CorpLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* HMI_GainLocalUIAccessDeviceWeight;
  short* HMI_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_CircumventFWRulesWeight;
  short* EngrLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNetworkNodeWeight;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_CircumventFWRulesWeight;
  short* CorpLanEngrLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainUserCredentialsWeight;
  short* EngrLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* DoNothingWeight;
  short* DoNothingWeight_Mobius_Mark;
  StepWeight* SSHServer_GainLogicalAccessWeight;
  short* SSHServer_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainUserCredentialsWeight;
  short* CorpLanEngrLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainLogicalAccessWeight;
  short* HMI_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainUserCredentialsWeight;
  short* EngrWorkstation_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLogicalAccessWeight;
  short* EngrWorkstation_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_AdminModifyFWOpenWeight;
  short* CorpLanEngrLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLocalUIAccessDeviceWeight;
  short* EngrWorkstation_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SSHServer_GainUserCredentialsWeight;
  short* SSHServer_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainUserCredentialsWeight;
  short* HMI_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLAN_PlaceRogueHostOnNetworkWeight;
  short* CorpLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLogicalAccessWeight;
  short* CorpLanEngrLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_PlaceRogueHostOnNetworkWeight;
  short* EngrLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_AdminModifyFWOpenWeight;
  short* EngrLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLogicalAccessWeight;
  short* LinuxOS_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* SCADALAN_PlaceRogueHostOnNetworkWeight;
  short* SCADALAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainRemoteUIAccessDeviceWeight;
  short* EngrWorkstation_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLogicalAccessWeight;
  short* EngrLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_CircumventFWRulesWeight;
  short* CorpLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* HMI_GainRemoteUIAccessDeviceWeight;
  short* HMI_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short* MakeDecision_Mobius_Mark;
  double* TheDistributionParameters;

  CorpLanScadaLanFW_GainUserCredentialsSuccessStep();
  ~CorpLanScadaLanFW_GainUserCredentialsSuccessStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  double timeDistributionParameter1();
  bool preconditionsMet();
  void executeEffects();
}; // CorpLanScadaLanFW_GainUserCredentialsSuccessStep

class CorpLanEngrLanFW_GainRemoteUIAccessDeviceFailureStep : public Step {
public:

  Access* CorpLanEngrLanFW_UIAccess;
  short* CorpLanEngrLanFW_UIAccess_Mobius_Mark;
  Skill* CorpLanEngrLanFW_SpecializedTechnicalHardwareExpertise;
  short* CorpLanEngrLanFW_SpecializedTechnicalHardwareExpertise_Mobius_Mark;
  Skill* BasicCyberOffense;
  short* BasicCyberOffense_Mobius_Mark;
  Skill* NetworkPenetration;
  short* NetworkPenetration_Mobius_Mark;
  SystemSV<float>* cyberAttackAttribution;
  float* cyberAttackAttribution_Mobius_Mark;
  Access* CorpLAN_NetworkAccess;
  short* CorpLAN_NetworkAccess_Mobius_Mark;
  Access* EngrLAN_NetworkAccess;
  short* EngrLAN_NetworkAccess_Mobius_Mark;
  SystemSV<float>* CorpLAN_networkAnomalyDetectionStrength;
  float* CorpLAN_networkAnomalyDetectionStrength_Mobius_Mark;
  SystemSV<float>* EngrLAN_networkAnomalyDetectionStrength;
  float* EngrLAN_networkAnomalyDetectionStrength_Mobius_Mark;
  StepChosen* CorpLanEngrLanFW_GainRemoteUIAccessDeviceChosen;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceChosen_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainUserCredentialsWeight;
  short* CorpLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainUserCredentialsWeight;
  short* LinuxOS_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_AdminModifyFWOpenWeight;
  short* CorpLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainRemoteUIAccessOSWeight;
  short* LinuxOS_GainRemoteUIAccessOSWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLocalUIAccessOSWeight;
  short* LinuxOS_GainLocalUIAccessOSWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLogicalAccessWeight;
  short* CorpLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* HMI_GainLocalUIAccessDeviceWeight;
  short* HMI_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_CircumventFWRulesWeight;
  short* EngrLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNetworkNodeWeight;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_CircumventFWRulesWeight;
  short* CorpLanEngrLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainUserCredentialsWeight;
  short* EngrLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* DoNothingWeight;
  short* DoNothingWeight_Mobius_Mark;
  StepWeight* SSHServer_GainLogicalAccessWeight;
  short* SSHServer_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainUserCredentialsWeight;
  short* CorpLanEngrLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainLogicalAccessWeight;
  short* HMI_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainUserCredentialsWeight;
  short* EngrWorkstation_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLogicalAccessWeight;
  short* EngrWorkstation_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_AdminModifyFWOpenWeight;
  short* CorpLanEngrLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLocalUIAccessDeviceWeight;
  short* EngrWorkstation_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SSHServer_GainUserCredentialsWeight;
  short* SSHServer_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainUserCredentialsWeight;
  short* HMI_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLAN_PlaceRogueHostOnNetworkWeight;
  short* CorpLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLogicalAccessWeight;
  short* CorpLanEngrLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_PlaceRogueHostOnNetworkWeight;
  short* EngrLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_AdminModifyFWOpenWeight;
  short* EngrLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLogicalAccessWeight;
  short* LinuxOS_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* SCADALAN_PlaceRogueHostOnNetworkWeight;
  short* SCADALAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainRemoteUIAccessDeviceWeight;
  short* EngrWorkstation_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLogicalAccessWeight;
  short* EngrLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_CircumventFWRulesWeight;
  short* CorpLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* HMI_GainRemoteUIAccessDeviceWeight;
  short* HMI_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short* MakeDecision_Mobius_Mark;
  double* TheDistributionParameters;

  CorpLanEngrLanFW_GainRemoteUIAccessDeviceFailureStep();
  ~CorpLanEngrLanFW_GainRemoteUIAccessDeviceFailureStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  double timeDistributionParameter1();
  bool preconditionsMet();
  void executeEffects();
}; // CorpLanEngrLanFW_GainRemoteUIAccessDeviceFailureStep

class CorpLanEngrLanFW_GainRemoteUIAccessDeviceSuccessStep : public Step {
public:

  Access* CorpLanEngrLanFW_UIAccess;
  short* CorpLanEngrLanFW_UIAccess_Mobius_Mark;
  Skill* CorpLanEngrLanFW_SpecializedTechnicalHardwareExpertise;
  short* CorpLanEngrLanFW_SpecializedTechnicalHardwareExpertise_Mobius_Mark;
  Skill* BasicCyberOffense;
  short* BasicCyberOffense_Mobius_Mark;
  Skill* NetworkPenetration;
  short* NetworkPenetration_Mobius_Mark;
  SystemSV<float>* cyberAttackAttribution;
  float* cyberAttackAttribution_Mobius_Mark;
  Access* CorpLAN_NetworkAccess;
  short* CorpLAN_NetworkAccess_Mobius_Mark;
  Access* EngrLAN_NetworkAccess;
  short* EngrLAN_NetworkAccess_Mobius_Mark;
  SystemSV<float>* CorpLAN_networkAnomalyDetectionStrength;
  float* CorpLAN_networkAnomalyDetectionStrength_Mobius_Mark;
  SystemSV<float>* EngrLAN_networkAnomalyDetectionStrength;
  float* EngrLAN_networkAnomalyDetectionStrength_Mobius_Mark;
  StepChosen* CorpLanEngrLanFW_GainRemoteUIAccessDeviceChosen;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceChosen_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainUserCredentialsWeight;
  short* CorpLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainUserCredentialsWeight;
  short* LinuxOS_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_AdminModifyFWOpenWeight;
  short* CorpLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainRemoteUIAccessOSWeight;
  short* LinuxOS_GainRemoteUIAccessOSWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLocalUIAccessOSWeight;
  short* LinuxOS_GainLocalUIAccessOSWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLogicalAccessWeight;
  short* CorpLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* HMI_GainLocalUIAccessDeviceWeight;
  short* HMI_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_CircumventFWRulesWeight;
  short* EngrLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNetworkNodeWeight;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_CircumventFWRulesWeight;
  short* CorpLanEngrLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainUserCredentialsWeight;
  short* EngrLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* DoNothingWeight;
  short* DoNothingWeight_Mobius_Mark;
  StepWeight* SSHServer_GainLogicalAccessWeight;
  short* SSHServer_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainUserCredentialsWeight;
  short* CorpLanEngrLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainLogicalAccessWeight;
  short* HMI_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainUserCredentialsWeight;
  short* EngrWorkstation_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLogicalAccessWeight;
  short* EngrWorkstation_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_AdminModifyFWOpenWeight;
  short* CorpLanEngrLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLocalUIAccessDeviceWeight;
  short* EngrWorkstation_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SSHServer_GainUserCredentialsWeight;
  short* SSHServer_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainUserCredentialsWeight;
  short* HMI_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLAN_PlaceRogueHostOnNetworkWeight;
  short* CorpLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLogicalAccessWeight;
  short* CorpLanEngrLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_PlaceRogueHostOnNetworkWeight;
  short* EngrLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_AdminModifyFWOpenWeight;
  short* EngrLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLogicalAccessWeight;
  short* LinuxOS_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* SCADALAN_PlaceRogueHostOnNetworkWeight;
  short* SCADALAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainRemoteUIAccessDeviceWeight;
  short* EngrWorkstation_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLogicalAccessWeight;
  short* EngrLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_CircumventFWRulesWeight;
  short* CorpLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* HMI_GainRemoteUIAccessDeviceWeight;
  short* HMI_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short* MakeDecision_Mobius_Mark;
  double* TheDistributionParameters;

  CorpLanEngrLanFW_GainRemoteUIAccessDeviceSuccessStep();
  ~CorpLanEngrLanFW_GainRemoteUIAccessDeviceSuccessStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  double timeDistributionParameter1();
  bool preconditionsMet();
  void executeEffects();
}; // CorpLanEngrLanFW_GainRemoteUIAccessDeviceSuccessStep

class LinuxOS_GainUserCredentialsFailureStep : public Step {
public:

  Access* LinuxOS_HasUserCredentials;
  short* LinuxOS_HasUserCredentials_Mobius_Mark;
  Skill* BasicCyberOffense;
  short* BasicCyberOffense_Mobius_Mark;
  SystemSV<char>* LinuxOS_userAuthenticationType;
  char* LinuxOS_userAuthenticationType_Mobius_Mark;
  SystemSV<float>* LinuxOS_strengthOfUserAuthentication;
  float* LinuxOS_strengthOfUserAuthentication_Mobius_Mark;
  StepChosen* LinuxOS_GainUserCredentialsChosen;
  short* LinuxOS_GainUserCredentialsChosen_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainUserCredentialsWeight;
  short* CorpLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainUserCredentialsWeight;
  short* LinuxOS_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_AdminModifyFWOpenWeight;
  short* CorpLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainRemoteUIAccessOSWeight;
  short* LinuxOS_GainRemoteUIAccessOSWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLocalUIAccessOSWeight;
  short* LinuxOS_GainLocalUIAccessOSWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLogicalAccessWeight;
  short* CorpLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* HMI_GainLocalUIAccessDeviceWeight;
  short* HMI_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_CircumventFWRulesWeight;
  short* EngrLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNetworkNodeWeight;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_CircumventFWRulesWeight;
  short* CorpLanEngrLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainUserCredentialsWeight;
  short* EngrLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* DoNothingWeight;
  short* DoNothingWeight_Mobius_Mark;
  StepWeight* SSHServer_GainLogicalAccessWeight;
  short* SSHServer_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainUserCredentialsWeight;
  short* CorpLanEngrLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainLogicalAccessWeight;
  short* HMI_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainUserCredentialsWeight;
  short* EngrWorkstation_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLogicalAccessWeight;
  short* EngrWorkstation_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_AdminModifyFWOpenWeight;
  short* CorpLanEngrLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLocalUIAccessDeviceWeight;
  short* EngrWorkstation_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SSHServer_GainUserCredentialsWeight;
  short* SSHServer_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainUserCredentialsWeight;
  short* HMI_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLAN_PlaceRogueHostOnNetworkWeight;
  short* CorpLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLogicalAccessWeight;
  short* CorpLanEngrLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_PlaceRogueHostOnNetworkWeight;
  short* EngrLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_AdminModifyFWOpenWeight;
  short* EngrLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLogicalAccessWeight;
  short* LinuxOS_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* SCADALAN_PlaceRogueHostOnNetworkWeight;
  short* SCADALAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainRemoteUIAccessDeviceWeight;
  short* EngrWorkstation_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLogicalAccessWeight;
  short* EngrLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_CircumventFWRulesWeight;
  short* CorpLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* HMI_GainRemoteUIAccessDeviceWeight;
  short* HMI_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short* MakeDecision_Mobius_Mark;
  double* TheDistributionParameters;

  LinuxOS_GainUserCredentialsFailureStep();
  ~LinuxOS_GainUserCredentialsFailureStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  double timeDistributionParameter1();
  bool preconditionsMet();
  void executeEffects();
}; // LinuxOS_GainUserCredentialsFailureStep

class LinuxOS_GainUserCredentialsSuccessStep : public Step {
public:

  Access* LinuxOS_HasUserCredentials;
  short* LinuxOS_HasUserCredentials_Mobius_Mark;
  Skill* BasicCyberOffense;
  short* BasicCyberOffense_Mobius_Mark;
  SystemSV<char>* LinuxOS_userAuthenticationType;
  char* LinuxOS_userAuthenticationType_Mobius_Mark;
  SystemSV<float>* LinuxOS_strengthOfUserAuthentication;
  float* LinuxOS_strengthOfUserAuthentication_Mobius_Mark;
  StepChosen* LinuxOS_GainUserCredentialsChosen;
  short* LinuxOS_GainUserCredentialsChosen_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainUserCredentialsWeight;
  short* CorpLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainUserCredentialsWeight;
  short* LinuxOS_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_AdminModifyFWOpenWeight;
  short* CorpLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainRemoteUIAccessOSWeight;
  short* LinuxOS_GainRemoteUIAccessOSWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLocalUIAccessOSWeight;
  short* LinuxOS_GainLocalUIAccessOSWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLogicalAccessWeight;
  short* CorpLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* HMI_GainLocalUIAccessDeviceWeight;
  short* HMI_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_CircumventFWRulesWeight;
  short* EngrLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNetworkNodeWeight;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_CircumventFWRulesWeight;
  short* CorpLanEngrLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainUserCredentialsWeight;
  short* EngrLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* DoNothingWeight;
  short* DoNothingWeight_Mobius_Mark;
  StepWeight* SSHServer_GainLogicalAccessWeight;
  short* SSHServer_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainUserCredentialsWeight;
  short* CorpLanEngrLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainLogicalAccessWeight;
  short* HMI_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainUserCredentialsWeight;
  short* EngrWorkstation_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLogicalAccessWeight;
  short* EngrWorkstation_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_AdminModifyFWOpenWeight;
  short* CorpLanEngrLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLocalUIAccessDeviceWeight;
  short* EngrWorkstation_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SSHServer_GainUserCredentialsWeight;
  short* SSHServer_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainUserCredentialsWeight;
  short* HMI_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLAN_PlaceRogueHostOnNetworkWeight;
  short* CorpLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLogicalAccessWeight;
  short* CorpLanEngrLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_PlaceRogueHostOnNetworkWeight;
  short* EngrLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_AdminModifyFWOpenWeight;
  short* EngrLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLogicalAccessWeight;
  short* LinuxOS_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* SCADALAN_PlaceRogueHostOnNetworkWeight;
  short* SCADALAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainRemoteUIAccessDeviceWeight;
  short* EngrWorkstation_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLogicalAccessWeight;
  short* EngrLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_CircumventFWRulesWeight;
  short* CorpLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* HMI_GainRemoteUIAccessDeviceWeight;
  short* HMI_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short* MakeDecision_Mobius_Mark;
  double* TheDistributionParameters;

  LinuxOS_GainUserCredentialsSuccessStep();
  ~LinuxOS_GainUserCredentialsSuccessStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  double timeDistributionParameter1();
  bool preconditionsMet();
  void executeEffects();
}; // LinuxOS_GainUserCredentialsSuccessStep

class CorpLanScadaLanFW_AdminModifyFWOpenFailureStep : public Step {
public:

  Access* SCADALAN_NetworkAccess;
  short* SCADALAN_NetworkAccess_Mobius_Mark;
  Access* CorpLAN_NetworkAccess;
  short* CorpLAN_NetworkAccess_Mobius_Mark;
  Goal* Goal_GainNetworkAccessOnScadaNetwork;
  short* Goal_GainNetworkAccessOnScadaNetwork_Mobius_Mark;
  Access* CorpLanScadaLanFW_LogicalAccess;
  short* CorpLanScadaLanFW_LogicalAccess_Mobius_Mark;
  Skill* NetworkPenetration;
  short* NetworkPenetration_Mobius_Mark;
  SystemSV<float>* cyberAttackAttribution;
  float* cyberAttackAttribution_Mobius_Mark;
  SystemSV<float>* CorpLanScadaLanFW_firewallConfigControl;
  float* CorpLanScadaLanFW_firewallConfigControl_Mobius_Mark;
  SystemSV<float>* CorpLanScadaLanFW_firewallConfigDetection;
  float* CorpLanScadaLanFW_firewallConfigDetection_Mobius_Mark;
  Knowledge* CorpLanScadaLanFW_FirewallConfigKnowledge;
  short* CorpLanScadaLanFW_FirewallConfigKnowledge_Mobius_Mark;
  Skill* CorpLanScadaLanFW_SpecializedTechnicalExpertise;
  short* CorpLanScadaLanFW_SpecializedTechnicalExpertise_Mobius_Mark;
  StepChosen* CorpLanScadaLanFW_AdminModifyFWOpenChosen;
  short* CorpLanScadaLanFW_AdminModifyFWOpenChosen_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainUserCredentialsWeight;
  short* CorpLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainUserCredentialsWeight;
  short* LinuxOS_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_AdminModifyFWOpenWeight;
  short* CorpLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainRemoteUIAccessOSWeight;
  short* LinuxOS_GainRemoteUIAccessOSWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLocalUIAccessOSWeight;
  short* LinuxOS_GainLocalUIAccessOSWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLogicalAccessWeight;
  short* CorpLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* HMI_GainLocalUIAccessDeviceWeight;
  short* HMI_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_CircumventFWRulesWeight;
  short* EngrLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNetworkNodeWeight;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_CircumventFWRulesWeight;
  short* CorpLanEngrLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainUserCredentialsWeight;
  short* EngrLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* DoNothingWeight;
  short* DoNothingWeight_Mobius_Mark;
  StepWeight* SSHServer_GainLogicalAccessWeight;
  short* SSHServer_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainUserCredentialsWeight;
  short* CorpLanEngrLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainLogicalAccessWeight;
  short* HMI_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainUserCredentialsWeight;
  short* EngrWorkstation_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLogicalAccessWeight;
  short* EngrWorkstation_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_AdminModifyFWOpenWeight;
  short* CorpLanEngrLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLocalUIAccessDeviceWeight;
  short* EngrWorkstation_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SSHServer_GainUserCredentialsWeight;
  short* SSHServer_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainUserCredentialsWeight;
  short* HMI_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLAN_PlaceRogueHostOnNetworkWeight;
  short* CorpLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLogicalAccessWeight;
  short* CorpLanEngrLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_PlaceRogueHostOnNetworkWeight;
  short* EngrLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_AdminModifyFWOpenWeight;
  short* EngrLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLogicalAccessWeight;
  short* LinuxOS_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* SCADALAN_PlaceRogueHostOnNetworkWeight;
  short* SCADALAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainRemoteUIAccessDeviceWeight;
  short* EngrWorkstation_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLogicalAccessWeight;
  short* EngrLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_CircumventFWRulesWeight;
  short* CorpLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* HMI_GainRemoteUIAccessDeviceWeight;
  short* HMI_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short* MakeDecision_Mobius_Mark;
  double* TheDistributionParameters;

  CorpLanScadaLanFW_AdminModifyFWOpenFailureStep();
  ~CorpLanScadaLanFW_AdminModifyFWOpenFailureStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  bool preconditionsMet();
  void executeEffects();
}; // CorpLanScadaLanFW_AdminModifyFWOpenFailureStep

class CorpLanScadaLanFW_AdminModifyFWOpenSuccessStep : public Step {
public:

  Access* SCADALAN_NetworkAccess;
  short* SCADALAN_NetworkAccess_Mobius_Mark;
  Access* CorpLAN_NetworkAccess;
  short* CorpLAN_NetworkAccess_Mobius_Mark;
  Goal* Goal_GainNetworkAccessOnScadaNetwork;
  short* Goal_GainNetworkAccessOnScadaNetwork_Mobius_Mark;
  Access* CorpLanScadaLanFW_LogicalAccess;
  short* CorpLanScadaLanFW_LogicalAccess_Mobius_Mark;
  Skill* NetworkPenetration;
  short* NetworkPenetration_Mobius_Mark;
  SystemSV<float>* cyberAttackAttribution;
  float* cyberAttackAttribution_Mobius_Mark;
  SystemSV<float>* CorpLanScadaLanFW_firewallConfigControl;
  float* CorpLanScadaLanFW_firewallConfigControl_Mobius_Mark;
  SystemSV<float>* CorpLanScadaLanFW_firewallConfigDetection;
  float* CorpLanScadaLanFW_firewallConfigDetection_Mobius_Mark;
  Knowledge* CorpLanScadaLanFW_FirewallConfigKnowledge;
  short* CorpLanScadaLanFW_FirewallConfigKnowledge_Mobius_Mark;
  Skill* CorpLanScadaLanFW_SpecializedTechnicalExpertise;
  short* CorpLanScadaLanFW_SpecializedTechnicalExpertise_Mobius_Mark;
  StepChosen* CorpLanScadaLanFW_AdminModifyFWOpenChosen;
  short* CorpLanScadaLanFW_AdminModifyFWOpenChosen_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainUserCredentialsWeight;
  short* CorpLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainUserCredentialsWeight;
  short* LinuxOS_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_AdminModifyFWOpenWeight;
  short* CorpLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainRemoteUIAccessOSWeight;
  short* LinuxOS_GainRemoteUIAccessOSWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLocalUIAccessOSWeight;
  short* LinuxOS_GainLocalUIAccessOSWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLogicalAccessWeight;
  short* CorpLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* HMI_GainLocalUIAccessDeviceWeight;
  short* HMI_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_CircumventFWRulesWeight;
  short* EngrLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNetworkNodeWeight;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_CircumventFWRulesWeight;
  short* CorpLanEngrLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainUserCredentialsWeight;
  short* EngrLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* DoNothingWeight;
  short* DoNothingWeight_Mobius_Mark;
  StepWeight* SSHServer_GainLogicalAccessWeight;
  short* SSHServer_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainUserCredentialsWeight;
  short* CorpLanEngrLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainLogicalAccessWeight;
  short* HMI_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainUserCredentialsWeight;
  short* EngrWorkstation_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLogicalAccessWeight;
  short* EngrWorkstation_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_AdminModifyFWOpenWeight;
  short* CorpLanEngrLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLocalUIAccessDeviceWeight;
  short* EngrWorkstation_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SSHServer_GainUserCredentialsWeight;
  short* SSHServer_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainUserCredentialsWeight;
  short* HMI_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLAN_PlaceRogueHostOnNetworkWeight;
  short* CorpLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLogicalAccessWeight;
  short* CorpLanEngrLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_PlaceRogueHostOnNetworkWeight;
  short* EngrLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_AdminModifyFWOpenWeight;
  short* EngrLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLogicalAccessWeight;
  short* LinuxOS_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* SCADALAN_PlaceRogueHostOnNetworkWeight;
  short* SCADALAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainRemoteUIAccessDeviceWeight;
  short* EngrWorkstation_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLogicalAccessWeight;
  short* EngrLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_CircumventFWRulesWeight;
  short* CorpLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* HMI_GainRemoteUIAccessDeviceWeight;
  short* HMI_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short* MakeDecision_Mobius_Mark;
  double* TheDistributionParameters;

  CorpLanScadaLanFW_AdminModifyFWOpenSuccessStep();
  ~CorpLanScadaLanFW_AdminModifyFWOpenSuccessStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  bool preconditionsMet();
  void executeEffects();
}; // CorpLanScadaLanFW_AdminModifyFWOpenSuccessStep

class CorpLAN_GainNetworkAccessViaConnectedNetworkFailureStep : public Step {
public:

  Access* CorpLAN_NetworkAccess;
  short* CorpLAN_NetworkAccess_Mobius_Mark;
  Skill* NetworkPenetration;
  short* NetworkPenetration_Mobius_Mark;
  SystemSV<float>* CorpLAN_networkAnomalyDetectionStrength;
  float* CorpLAN_networkAnomalyDetectionStrength_Mobius_Mark;
  SystemSV<float>* cyberAttackAttribution;
  float* cyberAttackAttribution_Mobius_Mark;
  StepChosen* CorpLAN_GainNetworkAccessViaConnectedNetworkChosen;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkChosen_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainUserCredentialsWeight;
  short* CorpLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainUserCredentialsWeight;
  short* LinuxOS_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_AdminModifyFWOpenWeight;
  short* CorpLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainRemoteUIAccessOSWeight;
  short* LinuxOS_GainRemoteUIAccessOSWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLocalUIAccessOSWeight;
  short* LinuxOS_GainLocalUIAccessOSWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLogicalAccessWeight;
  short* CorpLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* HMI_GainLocalUIAccessDeviceWeight;
  short* HMI_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_CircumventFWRulesWeight;
  short* EngrLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNetworkNodeWeight;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_CircumventFWRulesWeight;
  short* CorpLanEngrLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainUserCredentialsWeight;
  short* EngrLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* DoNothingWeight;
  short* DoNothingWeight_Mobius_Mark;
  StepWeight* SSHServer_GainLogicalAccessWeight;
  short* SSHServer_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainUserCredentialsWeight;
  short* CorpLanEngrLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainLogicalAccessWeight;
  short* HMI_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainUserCredentialsWeight;
  short* EngrWorkstation_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLogicalAccessWeight;
  short* EngrWorkstation_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_AdminModifyFWOpenWeight;
  short* CorpLanEngrLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLocalUIAccessDeviceWeight;
  short* EngrWorkstation_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SSHServer_GainUserCredentialsWeight;
  short* SSHServer_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainUserCredentialsWeight;
  short* HMI_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLAN_PlaceRogueHostOnNetworkWeight;
  short* CorpLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLogicalAccessWeight;
  short* CorpLanEngrLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_PlaceRogueHostOnNetworkWeight;
  short* EngrLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_AdminModifyFWOpenWeight;
  short* EngrLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLogicalAccessWeight;
  short* LinuxOS_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* SCADALAN_PlaceRogueHostOnNetworkWeight;
  short* SCADALAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainRemoteUIAccessDeviceWeight;
  short* EngrWorkstation_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLogicalAccessWeight;
  short* EngrLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_CircumventFWRulesWeight;
  short* CorpLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* HMI_GainRemoteUIAccessDeviceWeight;
  short* HMI_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short* MakeDecision_Mobius_Mark;
  double* TheDistributionParameters;

  CorpLAN_GainNetworkAccessViaConnectedNetworkFailureStep();
  ~CorpLAN_GainNetworkAccessViaConnectedNetworkFailureStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  double timeDistributionParameter1();
  bool preconditionsMet();
  void executeEffects();
}; // CorpLAN_GainNetworkAccessViaConnectedNetworkFailureStep

class CorpLAN_GainNetworkAccessViaConnectedNetworkSuccessStep : public Step {
public:

  Access* CorpLAN_NetworkAccess;
  short* CorpLAN_NetworkAccess_Mobius_Mark;
  Skill* NetworkPenetration;
  short* NetworkPenetration_Mobius_Mark;
  SystemSV<float>* CorpLAN_networkAnomalyDetectionStrength;
  float* CorpLAN_networkAnomalyDetectionStrength_Mobius_Mark;
  SystemSV<float>* cyberAttackAttribution;
  float* cyberAttackAttribution_Mobius_Mark;
  StepChosen* CorpLAN_GainNetworkAccessViaConnectedNetworkChosen;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkChosen_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainUserCredentialsWeight;
  short* CorpLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainUserCredentialsWeight;
  short* LinuxOS_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_AdminModifyFWOpenWeight;
  short* CorpLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainRemoteUIAccessOSWeight;
  short* LinuxOS_GainRemoteUIAccessOSWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLocalUIAccessOSWeight;
  short* LinuxOS_GainLocalUIAccessOSWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLogicalAccessWeight;
  short* CorpLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* HMI_GainLocalUIAccessDeviceWeight;
  short* HMI_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_CircumventFWRulesWeight;
  short* EngrLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNetworkNodeWeight;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_CircumventFWRulesWeight;
  short* CorpLanEngrLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainUserCredentialsWeight;
  short* EngrLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* DoNothingWeight;
  short* DoNothingWeight_Mobius_Mark;
  StepWeight* SSHServer_GainLogicalAccessWeight;
  short* SSHServer_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainUserCredentialsWeight;
  short* CorpLanEngrLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainLogicalAccessWeight;
  short* HMI_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainUserCredentialsWeight;
  short* EngrWorkstation_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLogicalAccessWeight;
  short* EngrWorkstation_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_AdminModifyFWOpenWeight;
  short* CorpLanEngrLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLocalUIAccessDeviceWeight;
  short* EngrWorkstation_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SSHServer_GainUserCredentialsWeight;
  short* SSHServer_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainUserCredentialsWeight;
  short* HMI_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLAN_PlaceRogueHostOnNetworkWeight;
  short* CorpLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLogicalAccessWeight;
  short* CorpLanEngrLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_PlaceRogueHostOnNetworkWeight;
  short* EngrLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_AdminModifyFWOpenWeight;
  short* EngrLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLogicalAccessWeight;
  short* LinuxOS_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* SCADALAN_PlaceRogueHostOnNetworkWeight;
  short* SCADALAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainRemoteUIAccessDeviceWeight;
  short* EngrWorkstation_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLogicalAccessWeight;
  short* EngrLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_CircumventFWRulesWeight;
  short* CorpLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* HMI_GainRemoteUIAccessDeviceWeight;
  short* HMI_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short* MakeDecision_Mobius_Mark;
  double* TheDistributionParameters;

  CorpLAN_GainNetworkAccessViaConnectedNetworkSuccessStep();
  ~CorpLAN_GainNetworkAccessViaConnectedNetworkSuccessStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  double timeDistributionParameter1();
  bool preconditionsMet();
  void executeEffects();
}; // CorpLAN_GainNetworkAccessViaConnectedNetworkSuccessStep

class CorpLanEngrLanFW_GainLocalUIAccessDeviceFailureStep : public Step {
public:

  Access* CorpLanEngrLanFW_UIAccess;
  short* CorpLanEngrLanFW_UIAccess_Mobius_Mark;
  Access* CorpLanEngrLanFW_LogicalAccess;
  short* CorpLanEngrLanFW_LogicalAccess_Mobius_Mark;
  Access* CorpLanEngrLanFW_PhysicalAccess;
  short* CorpLanEngrLanFW_PhysicalAccess_Mobius_Mark;
  SystemSV<char>* CorpLanEngrLanFW_userAuthenticationType;
  char* CorpLanEngrLanFW_userAuthenticationType_Mobius_Mark;
  Skill* KineticEquipmentAttack;
  short* KineticEquipmentAttack_Mobius_Mark;
  SystemSV<float>* CorpLanEngrLanFW_physicalAttackAttribution;
  float* CorpLanEngrLanFW_physicalAttackAttribution_Mobius_Mark;
  StepChosen* CorpLanEngrLanFW_GainLocalUIAccessDeviceChosen;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceChosen_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainUserCredentialsWeight;
  short* CorpLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainUserCredentialsWeight;
  short* LinuxOS_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_AdminModifyFWOpenWeight;
  short* CorpLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainRemoteUIAccessOSWeight;
  short* LinuxOS_GainRemoteUIAccessOSWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLocalUIAccessOSWeight;
  short* LinuxOS_GainLocalUIAccessOSWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLogicalAccessWeight;
  short* CorpLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* HMI_GainLocalUIAccessDeviceWeight;
  short* HMI_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_CircumventFWRulesWeight;
  short* EngrLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNetworkNodeWeight;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_CircumventFWRulesWeight;
  short* CorpLanEngrLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainUserCredentialsWeight;
  short* EngrLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* DoNothingWeight;
  short* DoNothingWeight_Mobius_Mark;
  StepWeight* SSHServer_GainLogicalAccessWeight;
  short* SSHServer_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainUserCredentialsWeight;
  short* CorpLanEngrLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainLogicalAccessWeight;
  short* HMI_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainUserCredentialsWeight;
  short* EngrWorkstation_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLogicalAccessWeight;
  short* EngrWorkstation_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_AdminModifyFWOpenWeight;
  short* CorpLanEngrLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLocalUIAccessDeviceWeight;
  short* EngrWorkstation_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SSHServer_GainUserCredentialsWeight;
  short* SSHServer_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainUserCredentialsWeight;
  short* HMI_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLAN_PlaceRogueHostOnNetworkWeight;
  short* CorpLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLogicalAccessWeight;
  short* CorpLanEngrLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_PlaceRogueHostOnNetworkWeight;
  short* EngrLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_AdminModifyFWOpenWeight;
  short* EngrLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLogicalAccessWeight;
  short* LinuxOS_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* SCADALAN_PlaceRogueHostOnNetworkWeight;
  short* SCADALAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainRemoteUIAccessDeviceWeight;
  short* EngrWorkstation_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLogicalAccessWeight;
  short* EngrLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_CircumventFWRulesWeight;
  short* CorpLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* HMI_GainRemoteUIAccessDeviceWeight;
  short* HMI_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short* MakeDecision_Mobius_Mark;
  double* TheDistributionParameters;

  CorpLanEngrLanFW_GainLocalUIAccessDeviceFailureStep();
  ~CorpLanEngrLanFW_GainLocalUIAccessDeviceFailureStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  double timeDistributionParameter1();
  bool preconditionsMet();
  void executeEffects();
}; // CorpLanEngrLanFW_GainLocalUIAccessDeviceFailureStep

class CorpLanEngrLanFW_GainLocalUIAccessDeviceSuccessStep : public Step {
public:

  Access* CorpLanEngrLanFW_UIAccess;
  short* CorpLanEngrLanFW_UIAccess_Mobius_Mark;
  Access* CorpLanEngrLanFW_LogicalAccess;
  short* CorpLanEngrLanFW_LogicalAccess_Mobius_Mark;
  Access* CorpLanEngrLanFW_PhysicalAccess;
  short* CorpLanEngrLanFW_PhysicalAccess_Mobius_Mark;
  SystemSV<char>* CorpLanEngrLanFW_userAuthenticationType;
  char* CorpLanEngrLanFW_userAuthenticationType_Mobius_Mark;
  Skill* KineticEquipmentAttack;
  short* KineticEquipmentAttack_Mobius_Mark;
  SystemSV<float>* CorpLanEngrLanFW_physicalAttackAttribution;
  float* CorpLanEngrLanFW_physicalAttackAttribution_Mobius_Mark;
  StepChosen* CorpLanEngrLanFW_GainLocalUIAccessDeviceChosen;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceChosen_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainUserCredentialsWeight;
  short* CorpLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainUserCredentialsWeight;
  short* LinuxOS_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_AdminModifyFWOpenWeight;
  short* CorpLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainRemoteUIAccessOSWeight;
  short* LinuxOS_GainRemoteUIAccessOSWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLocalUIAccessOSWeight;
  short* LinuxOS_GainLocalUIAccessOSWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLogicalAccessWeight;
  short* CorpLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* HMI_GainLocalUIAccessDeviceWeight;
  short* HMI_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_CircumventFWRulesWeight;
  short* EngrLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNetworkNodeWeight;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_CircumventFWRulesWeight;
  short* CorpLanEngrLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainUserCredentialsWeight;
  short* EngrLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* DoNothingWeight;
  short* DoNothingWeight_Mobius_Mark;
  StepWeight* SSHServer_GainLogicalAccessWeight;
  short* SSHServer_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainUserCredentialsWeight;
  short* CorpLanEngrLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainLogicalAccessWeight;
  short* HMI_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainUserCredentialsWeight;
  short* EngrWorkstation_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLogicalAccessWeight;
  short* EngrWorkstation_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_AdminModifyFWOpenWeight;
  short* CorpLanEngrLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLocalUIAccessDeviceWeight;
  short* EngrWorkstation_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SSHServer_GainUserCredentialsWeight;
  short* SSHServer_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainUserCredentialsWeight;
  short* HMI_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLAN_PlaceRogueHostOnNetworkWeight;
  short* CorpLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLogicalAccessWeight;
  short* CorpLanEngrLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_PlaceRogueHostOnNetworkWeight;
  short* EngrLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_AdminModifyFWOpenWeight;
  short* EngrLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLogicalAccessWeight;
  short* LinuxOS_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* SCADALAN_PlaceRogueHostOnNetworkWeight;
  short* SCADALAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainRemoteUIAccessDeviceWeight;
  short* EngrWorkstation_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLogicalAccessWeight;
  short* EngrLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_CircumventFWRulesWeight;
  short* CorpLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* HMI_GainRemoteUIAccessDeviceWeight;
  short* HMI_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short* MakeDecision_Mobius_Mark;
  double* TheDistributionParameters;

  CorpLanEngrLanFW_GainLocalUIAccessDeviceSuccessStep();
  ~CorpLanEngrLanFW_GainLocalUIAccessDeviceSuccessStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  double timeDistributionParameter1();
  bool preconditionsMet();
  void executeEffects();
}; // CorpLanEngrLanFW_GainLocalUIAccessDeviceSuccessStep

class EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkFailureStep : public Step {
public:

  Access* EngrLAN_NetworkAccess;
  short* EngrLAN_NetworkAccess_Mobius_Mark;
  Skill* NetworkPenetration;
  short* NetworkPenetration_Mobius_Mark;
  SystemSV<float>* EngrLAN_networkAnomalyDetectionStrength;
  float* EngrLAN_networkAnomalyDetectionStrength_Mobius_Mark;
  SystemSV<float>* cyberAttackAttribution;
  float* cyberAttackAttribution_Mobius_Mark;
  StepChosen* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkChosen;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkChosen_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainUserCredentialsWeight;
  short* CorpLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainUserCredentialsWeight;
  short* LinuxOS_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_AdminModifyFWOpenWeight;
  short* CorpLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainRemoteUIAccessOSWeight;
  short* LinuxOS_GainRemoteUIAccessOSWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLocalUIAccessOSWeight;
  short* LinuxOS_GainLocalUIAccessOSWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLogicalAccessWeight;
  short* CorpLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* HMI_GainLocalUIAccessDeviceWeight;
  short* HMI_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_CircumventFWRulesWeight;
  short* EngrLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNetworkNodeWeight;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_CircumventFWRulesWeight;
  short* CorpLanEngrLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainUserCredentialsWeight;
  short* EngrLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* DoNothingWeight;
  short* DoNothingWeight_Mobius_Mark;
  StepWeight* SSHServer_GainLogicalAccessWeight;
  short* SSHServer_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainUserCredentialsWeight;
  short* CorpLanEngrLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainLogicalAccessWeight;
  short* HMI_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainUserCredentialsWeight;
  short* EngrWorkstation_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLogicalAccessWeight;
  short* EngrWorkstation_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_AdminModifyFWOpenWeight;
  short* CorpLanEngrLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLocalUIAccessDeviceWeight;
  short* EngrWorkstation_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SSHServer_GainUserCredentialsWeight;
  short* SSHServer_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainUserCredentialsWeight;
  short* HMI_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLAN_PlaceRogueHostOnNetworkWeight;
  short* CorpLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLogicalAccessWeight;
  short* CorpLanEngrLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_PlaceRogueHostOnNetworkWeight;
  short* EngrLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_AdminModifyFWOpenWeight;
  short* EngrLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLogicalAccessWeight;
  short* LinuxOS_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* SCADALAN_PlaceRogueHostOnNetworkWeight;
  short* SCADALAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainRemoteUIAccessDeviceWeight;
  short* EngrWorkstation_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLogicalAccessWeight;
  short* EngrLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_CircumventFWRulesWeight;
  short* CorpLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* HMI_GainRemoteUIAccessDeviceWeight;
  short* HMI_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short* MakeDecision_Mobius_Mark;
  double* TheDistributionParameters;

  EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkFailureStep();
  ~EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkFailureStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  double timeDistributionParameter1();
  bool preconditionsMet();
  void executeEffects();
}; // EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkFailureStep

class EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkSuccessStep : public Step {
public:

  Access* EngrLAN_NetworkAccess;
  short* EngrLAN_NetworkAccess_Mobius_Mark;
  Skill* NetworkPenetration;
  short* NetworkPenetration_Mobius_Mark;
  SystemSV<float>* EngrLAN_networkAnomalyDetectionStrength;
  float* EngrLAN_networkAnomalyDetectionStrength_Mobius_Mark;
  SystemSV<float>* cyberAttackAttribution;
  float* cyberAttackAttribution_Mobius_Mark;
  StepChosen* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkChosen;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkChosen_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainUserCredentialsWeight;
  short* CorpLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainUserCredentialsWeight;
  short* LinuxOS_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_AdminModifyFWOpenWeight;
  short* CorpLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainRemoteUIAccessOSWeight;
  short* LinuxOS_GainRemoteUIAccessOSWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLocalUIAccessOSWeight;
  short* LinuxOS_GainLocalUIAccessOSWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLogicalAccessWeight;
  short* CorpLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* HMI_GainLocalUIAccessDeviceWeight;
  short* HMI_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_CircumventFWRulesWeight;
  short* EngrLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNetworkNodeWeight;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_CircumventFWRulesWeight;
  short* CorpLanEngrLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainUserCredentialsWeight;
  short* EngrLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* DoNothingWeight;
  short* DoNothingWeight_Mobius_Mark;
  StepWeight* SSHServer_GainLogicalAccessWeight;
  short* SSHServer_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainUserCredentialsWeight;
  short* CorpLanEngrLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainLogicalAccessWeight;
  short* HMI_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainUserCredentialsWeight;
  short* EngrWorkstation_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLogicalAccessWeight;
  short* EngrWorkstation_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_AdminModifyFWOpenWeight;
  short* CorpLanEngrLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLocalUIAccessDeviceWeight;
  short* EngrWorkstation_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SSHServer_GainUserCredentialsWeight;
  short* SSHServer_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainUserCredentialsWeight;
  short* HMI_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLAN_PlaceRogueHostOnNetworkWeight;
  short* CorpLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLogicalAccessWeight;
  short* CorpLanEngrLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_PlaceRogueHostOnNetworkWeight;
  short* EngrLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_AdminModifyFWOpenWeight;
  short* EngrLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLogicalAccessWeight;
  short* LinuxOS_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* SCADALAN_PlaceRogueHostOnNetworkWeight;
  short* SCADALAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainRemoteUIAccessDeviceWeight;
  short* EngrWorkstation_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLogicalAccessWeight;
  short* EngrLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_CircumventFWRulesWeight;
  short* CorpLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* HMI_GainRemoteUIAccessDeviceWeight;
  short* HMI_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short* MakeDecision_Mobius_Mark;
  double* TheDistributionParameters;

  EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkSuccessStep();
  ~EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkSuccessStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  double timeDistributionParameter1();
  bool preconditionsMet();
  void executeEffects();
}; // EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkSuccessStep

class LinuxOS_GainRemoteUIAccessOSFailureStep : public Step {
public:

  Access* LinuxOS_UIAccess;
  short* LinuxOS_UIAccess_Mobius_Mark;
  Skill* BasicCyberOffense;
  short* BasicCyberOffense_Mobius_Mark;
  SystemSV<float>* LinuxOS_remoteAccessHardening;
  float* LinuxOS_remoteAccessHardening_Mobius_Mark;
  Skill* NetworkPenetration;
  short* NetworkPenetration_Mobius_Mark;
  SystemSV<float>* cyberAttackAttribution;
  float* cyberAttackAttribution_Mobius_Mark;
  Access* EngrLAN_NetworkAccess;
  short* EngrLAN_NetworkAccess_Mobius_Mark;
  StepChosen* LinuxOS_GainRemoteUIAccessOSChosen;
  short* LinuxOS_GainRemoteUIAccessOSChosen_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainUserCredentialsWeight;
  short* CorpLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainUserCredentialsWeight;
  short* LinuxOS_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_AdminModifyFWOpenWeight;
  short* CorpLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainRemoteUIAccessOSWeight;
  short* LinuxOS_GainRemoteUIAccessOSWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLocalUIAccessOSWeight;
  short* LinuxOS_GainLocalUIAccessOSWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLogicalAccessWeight;
  short* CorpLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* HMI_GainLocalUIAccessDeviceWeight;
  short* HMI_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_CircumventFWRulesWeight;
  short* EngrLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNetworkNodeWeight;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_CircumventFWRulesWeight;
  short* CorpLanEngrLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainUserCredentialsWeight;
  short* EngrLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* DoNothingWeight;
  short* DoNothingWeight_Mobius_Mark;
  StepWeight* SSHServer_GainLogicalAccessWeight;
  short* SSHServer_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainUserCredentialsWeight;
  short* CorpLanEngrLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainLogicalAccessWeight;
  short* HMI_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainUserCredentialsWeight;
  short* EngrWorkstation_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLogicalAccessWeight;
  short* EngrWorkstation_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_AdminModifyFWOpenWeight;
  short* CorpLanEngrLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLocalUIAccessDeviceWeight;
  short* EngrWorkstation_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SSHServer_GainUserCredentialsWeight;
  short* SSHServer_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainUserCredentialsWeight;
  short* HMI_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLAN_PlaceRogueHostOnNetworkWeight;
  short* CorpLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLogicalAccessWeight;
  short* CorpLanEngrLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_PlaceRogueHostOnNetworkWeight;
  short* EngrLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_AdminModifyFWOpenWeight;
  short* EngrLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLogicalAccessWeight;
  short* LinuxOS_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* SCADALAN_PlaceRogueHostOnNetworkWeight;
  short* SCADALAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainRemoteUIAccessDeviceWeight;
  short* EngrWorkstation_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLogicalAccessWeight;
  short* EngrLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_CircumventFWRulesWeight;
  short* CorpLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* HMI_GainRemoteUIAccessDeviceWeight;
  short* HMI_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short* MakeDecision_Mobius_Mark;
  double* TheDistributionParameters;

  LinuxOS_GainRemoteUIAccessOSFailureStep();
  ~LinuxOS_GainRemoteUIAccessOSFailureStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  double timeDistributionParameter1();
  bool preconditionsMet();
  void executeEffects();
}; // LinuxOS_GainRemoteUIAccessOSFailureStep

class LinuxOS_GainRemoteUIAccessOSSuccessStep : public Step {
public:

  Access* LinuxOS_UIAccess;
  short* LinuxOS_UIAccess_Mobius_Mark;
  Skill* BasicCyberOffense;
  short* BasicCyberOffense_Mobius_Mark;
  SystemSV<float>* LinuxOS_remoteAccessHardening;
  float* LinuxOS_remoteAccessHardening_Mobius_Mark;
  Skill* NetworkPenetration;
  short* NetworkPenetration_Mobius_Mark;
  SystemSV<float>* cyberAttackAttribution;
  float* cyberAttackAttribution_Mobius_Mark;
  Access* EngrLAN_NetworkAccess;
  short* EngrLAN_NetworkAccess_Mobius_Mark;
  StepChosen* LinuxOS_GainRemoteUIAccessOSChosen;
  short* LinuxOS_GainRemoteUIAccessOSChosen_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainUserCredentialsWeight;
  short* CorpLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainUserCredentialsWeight;
  short* LinuxOS_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_AdminModifyFWOpenWeight;
  short* CorpLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainRemoteUIAccessOSWeight;
  short* LinuxOS_GainRemoteUIAccessOSWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLocalUIAccessOSWeight;
  short* LinuxOS_GainLocalUIAccessOSWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLogicalAccessWeight;
  short* CorpLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* HMI_GainLocalUIAccessDeviceWeight;
  short* HMI_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_CircumventFWRulesWeight;
  short* EngrLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNetworkNodeWeight;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_CircumventFWRulesWeight;
  short* CorpLanEngrLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainUserCredentialsWeight;
  short* EngrLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* DoNothingWeight;
  short* DoNothingWeight_Mobius_Mark;
  StepWeight* SSHServer_GainLogicalAccessWeight;
  short* SSHServer_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainUserCredentialsWeight;
  short* CorpLanEngrLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainLogicalAccessWeight;
  short* HMI_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainUserCredentialsWeight;
  short* EngrWorkstation_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLogicalAccessWeight;
  short* EngrWorkstation_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_AdminModifyFWOpenWeight;
  short* CorpLanEngrLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLocalUIAccessDeviceWeight;
  short* EngrWorkstation_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SSHServer_GainUserCredentialsWeight;
  short* SSHServer_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainUserCredentialsWeight;
  short* HMI_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLAN_PlaceRogueHostOnNetworkWeight;
  short* CorpLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLogicalAccessWeight;
  short* CorpLanEngrLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_PlaceRogueHostOnNetworkWeight;
  short* EngrLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_AdminModifyFWOpenWeight;
  short* EngrLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLogicalAccessWeight;
  short* LinuxOS_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* SCADALAN_PlaceRogueHostOnNetworkWeight;
  short* SCADALAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainRemoteUIAccessDeviceWeight;
  short* EngrWorkstation_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLogicalAccessWeight;
  short* EngrLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_CircumventFWRulesWeight;
  short* CorpLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* HMI_GainRemoteUIAccessDeviceWeight;
  short* HMI_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short* MakeDecision_Mobius_Mark;
  double* TheDistributionParameters;

  LinuxOS_GainRemoteUIAccessOSSuccessStep();
  ~LinuxOS_GainRemoteUIAccessOSSuccessStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  double timeDistributionParameter1();
  bool preconditionsMet();
  void executeEffects();
}; // LinuxOS_GainRemoteUIAccessOSSuccessStep

class SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkFailureStep : public Step {
public:

  Access* SCADALAN_NetworkAccess;
  short* SCADALAN_NetworkAccess_Mobius_Mark;
  Goal* Goal_GainNetworkAccessOnScadaNetwork;
  short* Goal_GainNetworkAccessOnScadaNetwork_Mobius_Mark;
  Skill* NetworkPenetration;
  short* NetworkPenetration_Mobius_Mark;
  SystemSV<float>* SCADALAN_networkAnomalyDetectionStrength;
  float* SCADALAN_networkAnomalyDetectionStrength_Mobius_Mark;
  SystemSV<float>* cyberAttackAttribution;
  float* cyberAttackAttribution_Mobius_Mark;
  StepChosen* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkChosen;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkChosen_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainUserCredentialsWeight;
  short* CorpLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainUserCredentialsWeight;
  short* LinuxOS_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_AdminModifyFWOpenWeight;
  short* CorpLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainRemoteUIAccessOSWeight;
  short* LinuxOS_GainRemoteUIAccessOSWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLocalUIAccessOSWeight;
  short* LinuxOS_GainLocalUIAccessOSWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLogicalAccessWeight;
  short* CorpLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* HMI_GainLocalUIAccessDeviceWeight;
  short* HMI_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_CircumventFWRulesWeight;
  short* EngrLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNetworkNodeWeight;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_CircumventFWRulesWeight;
  short* CorpLanEngrLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainUserCredentialsWeight;
  short* EngrLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* DoNothingWeight;
  short* DoNothingWeight_Mobius_Mark;
  StepWeight* SSHServer_GainLogicalAccessWeight;
  short* SSHServer_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainUserCredentialsWeight;
  short* CorpLanEngrLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainLogicalAccessWeight;
  short* HMI_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainUserCredentialsWeight;
  short* EngrWorkstation_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLogicalAccessWeight;
  short* EngrWorkstation_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_AdminModifyFWOpenWeight;
  short* CorpLanEngrLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLocalUIAccessDeviceWeight;
  short* EngrWorkstation_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SSHServer_GainUserCredentialsWeight;
  short* SSHServer_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainUserCredentialsWeight;
  short* HMI_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLAN_PlaceRogueHostOnNetworkWeight;
  short* CorpLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLogicalAccessWeight;
  short* CorpLanEngrLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_PlaceRogueHostOnNetworkWeight;
  short* EngrLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_AdminModifyFWOpenWeight;
  short* EngrLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLogicalAccessWeight;
  short* LinuxOS_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* SCADALAN_PlaceRogueHostOnNetworkWeight;
  short* SCADALAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainRemoteUIAccessDeviceWeight;
  short* EngrWorkstation_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLogicalAccessWeight;
  short* EngrLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_CircumventFWRulesWeight;
  short* CorpLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* HMI_GainRemoteUIAccessDeviceWeight;
  short* HMI_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short* MakeDecision_Mobius_Mark;
  double* TheDistributionParameters;

  SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkFailureStep();
  ~SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkFailureStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  double timeDistributionParameter1();
  bool preconditionsMet();
  void executeEffects();
}; // SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkFailureStep

class SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkSuccessStep : public Step {
public:

  Access* SCADALAN_NetworkAccess;
  short* SCADALAN_NetworkAccess_Mobius_Mark;
  Goal* Goal_GainNetworkAccessOnScadaNetwork;
  short* Goal_GainNetworkAccessOnScadaNetwork_Mobius_Mark;
  Skill* NetworkPenetration;
  short* NetworkPenetration_Mobius_Mark;
  SystemSV<float>* SCADALAN_networkAnomalyDetectionStrength;
  float* SCADALAN_networkAnomalyDetectionStrength_Mobius_Mark;
  SystemSV<float>* cyberAttackAttribution;
  float* cyberAttackAttribution_Mobius_Mark;
  StepChosen* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkChosen;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkChosen_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainUserCredentialsWeight;
  short* CorpLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainUserCredentialsWeight;
  short* LinuxOS_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_AdminModifyFWOpenWeight;
  short* CorpLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainRemoteUIAccessOSWeight;
  short* LinuxOS_GainRemoteUIAccessOSWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLocalUIAccessOSWeight;
  short* LinuxOS_GainLocalUIAccessOSWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLogicalAccessWeight;
  short* CorpLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* HMI_GainLocalUIAccessDeviceWeight;
  short* HMI_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_CircumventFWRulesWeight;
  short* EngrLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNetworkNodeWeight;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_CircumventFWRulesWeight;
  short* CorpLanEngrLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainUserCredentialsWeight;
  short* EngrLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* DoNothingWeight;
  short* DoNothingWeight_Mobius_Mark;
  StepWeight* SSHServer_GainLogicalAccessWeight;
  short* SSHServer_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainUserCredentialsWeight;
  short* CorpLanEngrLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainLogicalAccessWeight;
  short* HMI_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainUserCredentialsWeight;
  short* EngrWorkstation_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLogicalAccessWeight;
  short* EngrWorkstation_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_AdminModifyFWOpenWeight;
  short* CorpLanEngrLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLocalUIAccessDeviceWeight;
  short* EngrWorkstation_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SSHServer_GainUserCredentialsWeight;
  short* SSHServer_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainUserCredentialsWeight;
  short* HMI_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLAN_PlaceRogueHostOnNetworkWeight;
  short* CorpLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLogicalAccessWeight;
  short* CorpLanEngrLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_PlaceRogueHostOnNetworkWeight;
  short* EngrLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_AdminModifyFWOpenWeight;
  short* EngrLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLogicalAccessWeight;
  short* LinuxOS_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* SCADALAN_PlaceRogueHostOnNetworkWeight;
  short* SCADALAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainRemoteUIAccessDeviceWeight;
  short* EngrWorkstation_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLogicalAccessWeight;
  short* EngrLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_CircumventFWRulesWeight;
  short* CorpLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* HMI_GainRemoteUIAccessDeviceWeight;
  short* HMI_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short* MakeDecision_Mobius_Mark;
  double* TheDistributionParameters;

  SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkSuccessStep();
  ~SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkSuccessStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  double timeDistributionParameter1();
  bool preconditionsMet();
  void executeEffects();
}; // SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkSuccessStep

class LinuxOS_GainLocalUIAccessOSFailureStep : public Step {
public:

  Access* LinuxOS_UIAccess;
  short* LinuxOS_UIAccess_Mobius_Mark;
  Access* EngrWorkstation_PhysicalAccess;
  short* EngrWorkstation_PhysicalAccess_Mobius_Mark;
  Access* EngrWorkstation_LogicalAccess;
  short* EngrWorkstation_LogicalAccess_Mobius_Mark;
  Skill* KineticEquipmentAttack;
  short* KineticEquipmentAttack_Mobius_Mark;
  SystemSV<float>* EngrWorkstation_physicalAttackAttribution;
  float* EngrWorkstation_physicalAttackAttribution_Mobius_Mark;
  StepChosen* LinuxOS_GainLocalUIAccessOSChosen;
  short* LinuxOS_GainLocalUIAccessOSChosen_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainUserCredentialsWeight;
  short* CorpLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainUserCredentialsWeight;
  short* LinuxOS_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_AdminModifyFWOpenWeight;
  short* CorpLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainRemoteUIAccessOSWeight;
  short* LinuxOS_GainRemoteUIAccessOSWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLocalUIAccessOSWeight;
  short* LinuxOS_GainLocalUIAccessOSWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLogicalAccessWeight;
  short* CorpLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* HMI_GainLocalUIAccessDeviceWeight;
  short* HMI_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_CircumventFWRulesWeight;
  short* EngrLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNetworkNodeWeight;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_CircumventFWRulesWeight;
  short* CorpLanEngrLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainUserCredentialsWeight;
  short* EngrLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* DoNothingWeight;
  short* DoNothingWeight_Mobius_Mark;
  StepWeight* SSHServer_GainLogicalAccessWeight;
  short* SSHServer_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainUserCredentialsWeight;
  short* CorpLanEngrLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainLogicalAccessWeight;
  short* HMI_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainUserCredentialsWeight;
  short* EngrWorkstation_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLogicalAccessWeight;
  short* EngrWorkstation_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_AdminModifyFWOpenWeight;
  short* CorpLanEngrLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLocalUIAccessDeviceWeight;
  short* EngrWorkstation_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SSHServer_GainUserCredentialsWeight;
  short* SSHServer_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainUserCredentialsWeight;
  short* HMI_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLAN_PlaceRogueHostOnNetworkWeight;
  short* CorpLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLogicalAccessWeight;
  short* CorpLanEngrLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_PlaceRogueHostOnNetworkWeight;
  short* EngrLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_AdminModifyFWOpenWeight;
  short* EngrLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLogicalAccessWeight;
  short* LinuxOS_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* SCADALAN_PlaceRogueHostOnNetworkWeight;
  short* SCADALAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainRemoteUIAccessDeviceWeight;
  short* EngrWorkstation_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLogicalAccessWeight;
  short* EngrLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_CircumventFWRulesWeight;
  short* CorpLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* HMI_GainRemoteUIAccessDeviceWeight;
  short* HMI_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short* MakeDecision_Mobius_Mark;
  double* TheDistributionParameters;

  LinuxOS_GainLocalUIAccessOSFailureStep();
  ~LinuxOS_GainLocalUIAccessOSFailureStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  double timeDistributionParameter1();
  bool preconditionsMet();
  void executeEffects();
}; // LinuxOS_GainLocalUIAccessOSFailureStep

class LinuxOS_GainLocalUIAccessOSSuccessStep : public Step {
public:

  Access* LinuxOS_UIAccess;
  short* LinuxOS_UIAccess_Mobius_Mark;
  Access* EngrWorkstation_PhysicalAccess;
  short* EngrWorkstation_PhysicalAccess_Mobius_Mark;
  Access* EngrWorkstation_LogicalAccess;
  short* EngrWorkstation_LogicalAccess_Mobius_Mark;
  Skill* KineticEquipmentAttack;
  short* KineticEquipmentAttack_Mobius_Mark;
  SystemSV<float>* EngrWorkstation_physicalAttackAttribution;
  float* EngrWorkstation_physicalAttackAttribution_Mobius_Mark;
  StepChosen* LinuxOS_GainLocalUIAccessOSChosen;
  short* LinuxOS_GainLocalUIAccessOSChosen_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainUserCredentialsWeight;
  short* CorpLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainUserCredentialsWeight;
  short* LinuxOS_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_AdminModifyFWOpenWeight;
  short* CorpLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainRemoteUIAccessOSWeight;
  short* LinuxOS_GainRemoteUIAccessOSWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLocalUIAccessOSWeight;
  short* LinuxOS_GainLocalUIAccessOSWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLogicalAccessWeight;
  short* CorpLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* HMI_GainLocalUIAccessDeviceWeight;
  short* HMI_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_CircumventFWRulesWeight;
  short* EngrLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNetworkNodeWeight;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_CircumventFWRulesWeight;
  short* CorpLanEngrLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainUserCredentialsWeight;
  short* EngrLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* DoNothingWeight;
  short* DoNothingWeight_Mobius_Mark;
  StepWeight* SSHServer_GainLogicalAccessWeight;
  short* SSHServer_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainUserCredentialsWeight;
  short* CorpLanEngrLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainLogicalAccessWeight;
  short* HMI_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainUserCredentialsWeight;
  short* EngrWorkstation_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLogicalAccessWeight;
  short* EngrWorkstation_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_AdminModifyFWOpenWeight;
  short* CorpLanEngrLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLocalUIAccessDeviceWeight;
  short* EngrWorkstation_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SSHServer_GainUserCredentialsWeight;
  short* SSHServer_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainUserCredentialsWeight;
  short* HMI_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLAN_PlaceRogueHostOnNetworkWeight;
  short* CorpLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLogicalAccessWeight;
  short* CorpLanEngrLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_PlaceRogueHostOnNetworkWeight;
  short* EngrLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_AdminModifyFWOpenWeight;
  short* EngrLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLogicalAccessWeight;
  short* LinuxOS_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* SCADALAN_PlaceRogueHostOnNetworkWeight;
  short* SCADALAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainRemoteUIAccessDeviceWeight;
  short* EngrWorkstation_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLogicalAccessWeight;
  short* EngrLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_CircumventFWRulesWeight;
  short* CorpLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* HMI_GainRemoteUIAccessDeviceWeight;
  short* HMI_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short* MakeDecision_Mobius_Mark;
  double* TheDistributionParameters;

  LinuxOS_GainLocalUIAccessOSSuccessStep();
  ~LinuxOS_GainLocalUIAccessOSSuccessStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  double timeDistributionParameter1();
  bool preconditionsMet();
  void executeEffects();
}; // LinuxOS_GainLocalUIAccessOSSuccessStep

class CorpLanScadaLanFW_GainLogicalAccessFailureStep : public Step {
public:

  Access* CorpLanScadaLanFW_LogicalAccess;
  short* CorpLanScadaLanFW_LogicalAccess_Mobius_Mark;
  Access* CorpLanScadaLanFW_HasUserCredentials;
  short* CorpLanScadaLanFW_HasUserCredentials_Mobius_Mark;
  Access* CorpLanScadaLanFW_UIAccess;
  short* CorpLanScadaLanFW_UIAccess_Mobius_Mark;
  SystemSV<float>* CorpLanScadaLanFW_credentialMonitoring;
  float* CorpLanScadaLanFW_credentialMonitoring_Mobius_Mark;
  Skill* BasicCyberOffense;
  short* BasicCyberOffense_Mobius_Mark;
  SystemSV<float>* cyberAttackAttribution;
  float* cyberAttackAttribution_Mobius_Mark;
  SystemSV<char>* CorpLanScadaLanFW_userAuthenticationType;
  char* CorpLanScadaLanFW_userAuthenticationType_Mobius_Mark;
  StepChosen* CorpLanScadaLanFW_GainLogicalAccessChosen;
  short* CorpLanScadaLanFW_GainLogicalAccessChosen_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainUserCredentialsWeight;
  short* CorpLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainUserCredentialsWeight;
  short* LinuxOS_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_AdminModifyFWOpenWeight;
  short* CorpLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainRemoteUIAccessOSWeight;
  short* LinuxOS_GainRemoteUIAccessOSWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLocalUIAccessOSWeight;
  short* LinuxOS_GainLocalUIAccessOSWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLogicalAccessWeight;
  short* CorpLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* HMI_GainLocalUIAccessDeviceWeight;
  short* HMI_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_CircumventFWRulesWeight;
  short* EngrLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNetworkNodeWeight;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_CircumventFWRulesWeight;
  short* CorpLanEngrLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainUserCredentialsWeight;
  short* EngrLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* DoNothingWeight;
  short* DoNothingWeight_Mobius_Mark;
  StepWeight* SSHServer_GainLogicalAccessWeight;
  short* SSHServer_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainUserCredentialsWeight;
  short* CorpLanEngrLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainLogicalAccessWeight;
  short* HMI_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainUserCredentialsWeight;
  short* EngrWorkstation_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLogicalAccessWeight;
  short* EngrWorkstation_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_AdminModifyFWOpenWeight;
  short* CorpLanEngrLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLocalUIAccessDeviceWeight;
  short* EngrWorkstation_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SSHServer_GainUserCredentialsWeight;
  short* SSHServer_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainUserCredentialsWeight;
  short* HMI_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLAN_PlaceRogueHostOnNetworkWeight;
  short* CorpLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLogicalAccessWeight;
  short* CorpLanEngrLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_PlaceRogueHostOnNetworkWeight;
  short* EngrLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_AdminModifyFWOpenWeight;
  short* EngrLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLogicalAccessWeight;
  short* LinuxOS_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* SCADALAN_PlaceRogueHostOnNetworkWeight;
  short* SCADALAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainRemoteUIAccessDeviceWeight;
  short* EngrWorkstation_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLogicalAccessWeight;
  short* EngrLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_CircumventFWRulesWeight;
  short* CorpLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* HMI_GainRemoteUIAccessDeviceWeight;
  short* HMI_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short* MakeDecision_Mobius_Mark;
  double* TheDistributionParameters;

  CorpLanScadaLanFW_GainLogicalAccessFailureStep();
  ~CorpLanScadaLanFW_GainLogicalAccessFailureStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  double timeDistributionParameter1();
  bool preconditionsMet();
  void executeEffects();
}; // CorpLanScadaLanFW_GainLogicalAccessFailureStep

class CorpLanScadaLanFW_GainLogicalAccessSuccessStep : public Step {
public:

  Access* CorpLanScadaLanFW_LogicalAccess;
  short* CorpLanScadaLanFW_LogicalAccess_Mobius_Mark;
  Access* CorpLanScadaLanFW_HasUserCredentials;
  short* CorpLanScadaLanFW_HasUserCredentials_Mobius_Mark;
  Access* CorpLanScadaLanFW_UIAccess;
  short* CorpLanScadaLanFW_UIAccess_Mobius_Mark;
  SystemSV<float>* CorpLanScadaLanFW_credentialMonitoring;
  float* CorpLanScadaLanFW_credentialMonitoring_Mobius_Mark;
  Skill* BasicCyberOffense;
  short* BasicCyberOffense_Mobius_Mark;
  SystemSV<float>* cyberAttackAttribution;
  float* cyberAttackAttribution_Mobius_Mark;
  SystemSV<char>* CorpLanScadaLanFW_userAuthenticationType;
  char* CorpLanScadaLanFW_userAuthenticationType_Mobius_Mark;
  StepChosen* CorpLanScadaLanFW_GainLogicalAccessChosen;
  short* CorpLanScadaLanFW_GainLogicalAccessChosen_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainUserCredentialsWeight;
  short* CorpLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainUserCredentialsWeight;
  short* LinuxOS_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_AdminModifyFWOpenWeight;
  short* CorpLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainRemoteUIAccessOSWeight;
  short* LinuxOS_GainRemoteUIAccessOSWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLocalUIAccessOSWeight;
  short* LinuxOS_GainLocalUIAccessOSWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLogicalAccessWeight;
  short* CorpLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* HMI_GainLocalUIAccessDeviceWeight;
  short* HMI_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_CircumventFWRulesWeight;
  short* EngrLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNetworkNodeWeight;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_CircumventFWRulesWeight;
  short* CorpLanEngrLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainUserCredentialsWeight;
  short* EngrLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* DoNothingWeight;
  short* DoNothingWeight_Mobius_Mark;
  StepWeight* SSHServer_GainLogicalAccessWeight;
  short* SSHServer_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainUserCredentialsWeight;
  short* CorpLanEngrLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainLogicalAccessWeight;
  short* HMI_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainUserCredentialsWeight;
  short* EngrWorkstation_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLogicalAccessWeight;
  short* EngrWorkstation_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_AdminModifyFWOpenWeight;
  short* CorpLanEngrLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLocalUIAccessDeviceWeight;
  short* EngrWorkstation_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SSHServer_GainUserCredentialsWeight;
  short* SSHServer_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainUserCredentialsWeight;
  short* HMI_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLAN_PlaceRogueHostOnNetworkWeight;
  short* CorpLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLogicalAccessWeight;
  short* CorpLanEngrLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_PlaceRogueHostOnNetworkWeight;
  short* EngrLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_AdminModifyFWOpenWeight;
  short* EngrLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLogicalAccessWeight;
  short* LinuxOS_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* SCADALAN_PlaceRogueHostOnNetworkWeight;
  short* SCADALAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainRemoteUIAccessDeviceWeight;
  short* EngrWorkstation_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLogicalAccessWeight;
  short* EngrLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_CircumventFWRulesWeight;
  short* CorpLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* HMI_GainRemoteUIAccessDeviceWeight;
  short* HMI_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short* MakeDecision_Mobius_Mark;
  double* TheDistributionParameters;

  CorpLanScadaLanFW_GainLogicalAccessSuccessStep();
  ~CorpLanScadaLanFW_GainLogicalAccessSuccessStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  double timeDistributionParameter1();
  bool preconditionsMet();
  void executeEffects();
}; // CorpLanScadaLanFW_GainLogicalAccessSuccessStep

class HMI_GainLocalUIAccessDeviceFailureStep : public Step {
public:

  Access* HMI_UIAccess;
  short* HMI_UIAccess_Mobius_Mark;
  Access* HMI_LogicalAccess;
  short* HMI_LogicalAccess_Mobius_Mark;
  Access* HMI_PhysicalAccess;
  short* HMI_PhysicalAccess_Mobius_Mark;
  SystemSV<char>* HMI_userAuthenticationType;
  char* HMI_userAuthenticationType_Mobius_Mark;
  Skill* KineticEquipmentAttack;
  short* KineticEquipmentAttack_Mobius_Mark;
  SystemSV<float>* HMI_physicalAttackAttribution;
  float* HMI_physicalAttackAttribution_Mobius_Mark;
  StepChosen* HMI_GainLocalUIAccessDeviceChosen;
  short* HMI_GainLocalUIAccessDeviceChosen_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainUserCredentialsWeight;
  short* CorpLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainUserCredentialsWeight;
  short* LinuxOS_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_AdminModifyFWOpenWeight;
  short* CorpLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainRemoteUIAccessOSWeight;
  short* LinuxOS_GainRemoteUIAccessOSWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLocalUIAccessOSWeight;
  short* LinuxOS_GainLocalUIAccessOSWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLogicalAccessWeight;
  short* CorpLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* HMI_GainLocalUIAccessDeviceWeight;
  short* HMI_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_CircumventFWRulesWeight;
  short* EngrLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNetworkNodeWeight;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_CircumventFWRulesWeight;
  short* CorpLanEngrLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainUserCredentialsWeight;
  short* EngrLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* DoNothingWeight;
  short* DoNothingWeight_Mobius_Mark;
  StepWeight* SSHServer_GainLogicalAccessWeight;
  short* SSHServer_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainUserCredentialsWeight;
  short* CorpLanEngrLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainLogicalAccessWeight;
  short* HMI_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainUserCredentialsWeight;
  short* EngrWorkstation_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLogicalAccessWeight;
  short* EngrWorkstation_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_AdminModifyFWOpenWeight;
  short* CorpLanEngrLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLocalUIAccessDeviceWeight;
  short* EngrWorkstation_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SSHServer_GainUserCredentialsWeight;
  short* SSHServer_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainUserCredentialsWeight;
  short* HMI_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLAN_PlaceRogueHostOnNetworkWeight;
  short* CorpLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLogicalAccessWeight;
  short* CorpLanEngrLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_PlaceRogueHostOnNetworkWeight;
  short* EngrLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_AdminModifyFWOpenWeight;
  short* EngrLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLogicalAccessWeight;
  short* LinuxOS_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* SCADALAN_PlaceRogueHostOnNetworkWeight;
  short* SCADALAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainRemoteUIAccessDeviceWeight;
  short* EngrWorkstation_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLogicalAccessWeight;
  short* EngrLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_CircumventFWRulesWeight;
  short* CorpLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* HMI_GainRemoteUIAccessDeviceWeight;
  short* HMI_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short* MakeDecision_Mobius_Mark;
  double* TheDistributionParameters;

  HMI_GainLocalUIAccessDeviceFailureStep();
  ~HMI_GainLocalUIAccessDeviceFailureStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  double timeDistributionParameter1();
  bool preconditionsMet();
  void executeEffects();
}; // HMI_GainLocalUIAccessDeviceFailureStep

class HMI_GainLocalUIAccessDeviceSuccessStep : public Step {
public:

  Access* HMI_UIAccess;
  short* HMI_UIAccess_Mobius_Mark;
  Access* HMI_LogicalAccess;
  short* HMI_LogicalAccess_Mobius_Mark;
  Access* HMI_PhysicalAccess;
  short* HMI_PhysicalAccess_Mobius_Mark;
  SystemSV<char>* HMI_userAuthenticationType;
  char* HMI_userAuthenticationType_Mobius_Mark;
  Skill* KineticEquipmentAttack;
  short* KineticEquipmentAttack_Mobius_Mark;
  SystemSV<float>* HMI_physicalAttackAttribution;
  float* HMI_physicalAttackAttribution_Mobius_Mark;
  StepChosen* HMI_GainLocalUIAccessDeviceChosen;
  short* HMI_GainLocalUIAccessDeviceChosen_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainUserCredentialsWeight;
  short* CorpLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainUserCredentialsWeight;
  short* LinuxOS_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_AdminModifyFWOpenWeight;
  short* CorpLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainRemoteUIAccessOSWeight;
  short* LinuxOS_GainRemoteUIAccessOSWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLocalUIAccessOSWeight;
  short* LinuxOS_GainLocalUIAccessOSWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLogicalAccessWeight;
  short* CorpLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* HMI_GainLocalUIAccessDeviceWeight;
  short* HMI_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_CircumventFWRulesWeight;
  short* EngrLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNetworkNodeWeight;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_CircumventFWRulesWeight;
  short* CorpLanEngrLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainUserCredentialsWeight;
  short* EngrLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* DoNothingWeight;
  short* DoNothingWeight_Mobius_Mark;
  StepWeight* SSHServer_GainLogicalAccessWeight;
  short* SSHServer_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainUserCredentialsWeight;
  short* CorpLanEngrLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainLogicalAccessWeight;
  short* HMI_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainUserCredentialsWeight;
  short* EngrWorkstation_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLogicalAccessWeight;
  short* EngrWorkstation_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_AdminModifyFWOpenWeight;
  short* CorpLanEngrLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLocalUIAccessDeviceWeight;
  short* EngrWorkstation_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SSHServer_GainUserCredentialsWeight;
  short* SSHServer_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainUserCredentialsWeight;
  short* HMI_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLAN_PlaceRogueHostOnNetworkWeight;
  short* CorpLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLogicalAccessWeight;
  short* CorpLanEngrLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_PlaceRogueHostOnNetworkWeight;
  short* EngrLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_AdminModifyFWOpenWeight;
  short* EngrLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLogicalAccessWeight;
  short* LinuxOS_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* SCADALAN_PlaceRogueHostOnNetworkWeight;
  short* SCADALAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainRemoteUIAccessDeviceWeight;
  short* EngrWorkstation_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLogicalAccessWeight;
  short* EngrLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_CircumventFWRulesWeight;
  short* CorpLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* HMI_GainRemoteUIAccessDeviceWeight;
  short* HMI_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short* MakeDecision_Mobius_Mark;
  double* TheDistributionParameters;

  HMI_GainLocalUIAccessDeviceSuccessStep();
  ~HMI_GainLocalUIAccessDeviceSuccessStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  double timeDistributionParameter1();
  bool preconditionsMet();
  void executeEffects();
}; // HMI_GainLocalUIAccessDeviceSuccessStep

class EngrLanScadaLanFW_GainRemoteUIAccessDeviceFailureStep : public Step {
public:

  Access* EngrLanScadaLanFW_UIAccess;
  short* EngrLanScadaLanFW_UIAccess_Mobius_Mark;
  Skill* EngrLanScadaLanFW_SpecializedTechnicalHardwareExpertise;
  short* EngrLanScadaLanFW_SpecializedTechnicalHardwareExpertise_Mobius_Mark;
  Skill* BasicCyberOffense;
  short* BasicCyberOffense_Mobius_Mark;
  Skill* NetworkPenetration;
  short* NetworkPenetration_Mobius_Mark;
  SystemSV<float>* cyberAttackAttribution;
  float* cyberAttackAttribution_Mobius_Mark;
  Access* EngrLAN_NetworkAccess;
  short* EngrLAN_NetworkAccess_Mobius_Mark;
  Access* SCADALAN_NetworkAccess;
  short* SCADALAN_NetworkAccess_Mobius_Mark;
  SystemSV<float>* EngrLAN_networkAnomalyDetectionStrength;
  float* EngrLAN_networkAnomalyDetectionStrength_Mobius_Mark;
  SystemSV<float>* SCADALAN_networkAnomalyDetectionStrength;
  float* SCADALAN_networkAnomalyDetectionStrength_Mobius_Mark;
  StepChosen* EngrLanScadaLanFW_GainRemoteUIAccessDeviceChosen;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceChosen_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainUserCredentialsWeight;
  short* CorpLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainUserCredentialsWeight;
  short* LinuxOS_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_AdminModifyFWOpenWeight;
  short* CorpLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainRemoteUIAccessOSWeight;
  short* LinuxOS_GainRemoteUIAccessOSWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLocalUIAccessOSWeight;
  short* LinuxOS_GainLocalUIAccessOSWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLogicalAccessWeight;
  short* CorpLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* HMI_GainLocalUIAccessDeviceWeight;
  short* HMI_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_CircumventFWRulesWeight;
  short* EngrLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNetworkNodeWeight;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_CircumventFWRulesWeight;
  short* CorpLanEngrLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainUserCredentialsWeight;
  short* EngrLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* DoNothingWeight;
  short* DoNothingWeight_Mobius_Mark;
  StepWeight* SSHServer_GainLogicalAccessWeight;
  short* SSHServer_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainUserCredentialsWeight;
  short* CorpLanEngrLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainLogicalAccessWeight;
  short* HMI_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainUserCredentialsWeight;
  short* EngrWorkstation_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLogicalAccessWeight;
  short* EngrWorkstation_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_AdminModifyFWOpenWeight;
  short* CorpLanEngrLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLocalUIAccessDeviceWeight;
  short* EngrWorkstation_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SSHServer_GainUserCredentialsWeight;
  short* SSHServer_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainUserCredentialsWeight;
  short* HMI_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLAN_PlaceRogueHostOnNetworkWeight;
  short* CorpLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLogicalAccessWeight;
  short* CorpLanEngrLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_PlaceRogueHostOnNetworkWeight;
  short* EngrLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_AdminModifyFWOpenWeight;
  short* EngrLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLogicalAccessWeight;
  short* LinuxOS_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* SCADALAN_PlaceRogueHostOnNetworkWeight;
  short* SCADALAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainRemoteUIAccessDeviceWeight;
  short* EngrWorkstation_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLogicalAccessWeight;
  short* EngrLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_CircumventFWRulesWeight;
  short* CorpLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* HMI_GainRemoteUIAccessDeviceWeight;
  short* HMI_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short* MakeDecision_Mobius_Mark;
  double* TheDistributionParameters;

  EngrLanScadaLanFW_GainRemoteUIAccessDeviceFailureStep();
  ~EngrLanScadaLanFW_GainRemoteUIAccessDeviceFailureStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  double timeDistributionParameter1();
  bool preconditionsMet();
  void executeEffects();
}; // EngrLanScadaLanFW_GainRemoteUIAccessDeviceFailureStep

class EngrLanScadaLanFW_GainRemoteUIAccessDeviceSuccessStep : public Step {
public:

  Access* EngrLanScadaLanFW_UIAccess;
  short* EngrLanScadaLanFW_UIAccess_Mobius_Mark;
  Skill* EngrLanScadaLanFW_SpecializedTechnicalHardwareExpertise;
  short* EngrLanScadaLanFW_SpecializedTechnicalHardwareExpertise_Mobius_Mark;
  Skill* BasicCyberOffense;
  short* BasicCyberOffense_Mobius_Mark;
  Skill* NetworkPenetration;
  short* NetworkPenetration_Mobius_Mark;
  SystemSV<float>* cyberAttackAttribution;
  float* cyberAttackAttribution_Mobius_Mark;
  Access* EngrLAN_NetworkAccess;
  short* EngrLAN_NetworkAccess_Mobius_Mark;
  Access* SCADALAN_NetworkAccess;
  short* SCADALAN_NetworkAccess_Mobius_Mark;
  SystemSV<float>* EngrLAN_networkAnomalyDetectionStrength;
  float* EngrLAN_networkAnomalyDetectionStrength_Mobius_Mark;
  SystemSV<float>* SCADALAN_networkAnomalyDetectionStrength;
  float* SCADALAN_networkAnomalyDetectionStrength_Mobius_Mark;
  StepChosen* EngrLanScadaLanFW_GainRemoteUIAccessDeviceChosen;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceChosen_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainUserCredentialsWeight;
  short* CorpLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainUserCredentialsWeight;
  short* LinuxOS_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_AdminModifyFWOpenWeight;
  short* CorpLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainRemoteUIAccessOSWeight;
  short* LinuxOS_GainRemoteUIAccessOSWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLocalUIAccessOSWeight;
  short* LinuxOS_GainLocalUIAccessOSWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLogicalAccessWeight;
  short* CorpLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* HMI_GainLocalUIAccessDeviceWeight;
  short* HMI_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_CircumventFWRulesWeight;
  short* EngrLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNetworkNodeWeight;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_CircumventFWRulesWeight;
  short* CorpLanEngrLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainUserCredentialsWeight;
  short* EngrLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* DoNothingWeight;
  short* DoNothingWeight_Mobius_Mark;
  StepWeight* SSHServer_GainLogicalAccessWeight;
  short* SSHServer_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainUserCredentialsWeight;
  short* CorpLanEngrLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainLogicalAccessWeight;
  short* HMI_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainUserCredentialsWeight;
  short* EngrWorkstation_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLogicalAccessWeight;
  short* EngrWorkstation_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_AdminModifyFWOpenWeight;
  short* CorpLanEngrLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLocalUIAccessDeviceWeight;
  short* EngrWorkstation_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SSHServer_GainUserCredentialsWeight;
  short* SSHServer_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainUserCredentialsWeight;
  short* HMI_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLAN_PlaceRogueHostOnNetworkWeight;
  short* CorpLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLogicalAccessWeight;
  short* CorpLanEngrLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_PlaceRogueHostOnNetworkWeight;
  short* EngrLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_AdminModifyFWOpenWeight;
  short* EngrLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLogicalAccessWeight;
  short* LinuxOS_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* SCADALAN_PlaceRogueHostOnNetworkWeight;
  short* SCADALAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainRemoteUIAccessDeviceWeight;
  short* EngrWorkstation_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLogicalAccessWeight;
  short* EngrLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_CircumventFWRulesWeight;
  short* CorpLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* HMI_GainRemoteUIAccessDeviceWeight;
  short* HMI_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short* MakeDecision_Mobius_Mark;
  double* TheDistributionParameters;

  EngrLanScadaLanFW_GainRemoteUIAccessDeviceSuccessStep();
  ~EngrLanScadaLanFW_GainRemoteUIAccessDeviceSuccessStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  double timeDistributionParameter1();
  bool preconditionsMet();
  void executeEffects();
}; // EngrLanScadaLanFW_GainRemoteUIAccessDeviceSuccessStep

class EngrLanScadaLanFW_CircumventFWRulesFailureStep : public Step {
public:

  Access* EngrLAN_NetworkAccess;
  short* EngrLAN_NetworkAccess_Mobius_Mark;
  Access* SCADALAN_NetworkAccess;
  short* SCADALAN_NetworkAccess_Mobius_Mark;
  Goal* Goal_GainNetworkAccessOnScadaNetwork;
  short* Goal_GainNetworkAccessOnScadaNetwork_Mobius_Mark;
  Knowledge* FirewallConfigKnowledge;
  short* FirewallConfigKnowledge_Mobius_Mark;
  SystemSV<float>* EngrLanScadaLanFW_firewallConfigControl;
  float* EngrLanScadaLanFW_firewallConfigControl_Mobius_Mark;
  SystemSV<float>* hourlyRateAdversary;
  float* hourlyRateAdversary_Mobius_Mark;
  Skill* NetworkPenetration;
  short* NetworkPenetration_Mobius_Mark;
  SystemSV<float>* cyberAttackAttribution;
  float* cyberAttackAttribution_Mobius_Mark;
  SystemSV<float>* EngrLAN_networkAnomalyResponseStrength;
  float* EngrLAN_networkAnomalyResponseStrength_Mobius_Mark;
  StepChosen* EngrLanScadaLanFW_CircumventFWRulesChosen;
  short* EngrLanScadaLanFW_CircumventFWRulesChosen_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainUserCredentialsWeight;
  short* CorpLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainUserCredentialsWeight;
  short* LinuxOS_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_AdminModifyFWOpenWeight;
  short* CorpLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainRemoteUIAccessOSWeight;
  short* LinuxOS_GainRemoteUIAccessOSWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLocalUIAccessOSWeight;
  short* LinuxOS_GainLocalUIAccessOSWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLogicalAccessWeight;
  short* CorpLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* HMI_GainLocalUIAccessDeviceWeight;
  short* HMI_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_CircumventFWRulesWeight;
  short* EngrLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNetworkNodeWeight;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_CircumventFWRulesWeight;
  short* CorpLanEngrLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainUserCredentialsWeight;
  short* EngrLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* DoNothingWeight;
  short* DoNothingWeight_Mobius_Mark;
  StepWeight* SSHServer_GainLogicalAccessWeight;
  short* SSHServer_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainUserCredentialsWeight;
  short* CorpLanEngrLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainLogicalAccessWeight;
  short* HMI_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainUserCredentialsWeight;
  short* EngrWorkstation_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLogicalAccessWeight;
  short* EngrWorkstation_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_AdminModifyFWOpenWeight;
  short* CorpLanEngrLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLocalUIAccessDeviceWeight;
  short* EngrWorkstation_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SSHServer_GainUserCredentialsWeight;
  short* SSHServer_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainUserCredentialsWeight;
  short* HMI_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLAN_PlaceRogueHostOnNetworkWeight;
  short* CorpLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLogicalAccessWeight;
  short* CorpLanEngrLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_PlaceRogueHostOnNetworkWeight;
  short* EngrLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_AdminModifyFWOpenWeight;
  short* EngrLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLogicalAccessWeight;
  short* LinuxOS_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* SCADALAN_PlaceRogueHostOnNetworkWeight;
  short* SCADALAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainRemoteUIAccessDeviceWeight;
  short* EngrWorkstation_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLogicalAccessWeight;
  short* EngrLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_CircumventFWRulesWeight;
  short* CorpLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* HMI_GainRemoteUIAccessDeviceWeight;
  short* HMI_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short* MakeDecision_Mobius_Mark;
  double* TheDistributionParameters;

  EngrLanScadaLanFW_CircumventFWRulesFailureStep();
  ~EngrLanScadaLanFW_CircumventFWRulesFailureStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  double timeDistributionParameter1();
  bool preconditionsMet();
  void executeEffects();
}; // EngrLanScadaLanFW_CircumventFWRulesFailureStep

class EngrLanScadaLanFW_CircumventFWRulesSuccessStep : public Step {
public:

  Access* EngrLAN_NetworkAccess;
  short* EngrLAN_NetworkAccess_Mobius_Mark;
  Access* SCADALAN_NetworkAccess;
  short* SCADALAN_NetworkAccess_Mobius_Mark;
  Goal* Goal_GainNetworkAccessOnScadaNetwork;
  short* Goal_GainNetworkAccessOnScadaNetwork_Mobius_Mark;
  Knowledge* FirewallConfigKnowledge;
  short* FirewallConfigKnowledge_Mobius_Mark;
  SystemSV<float>* EngrLanScadaLanFW_firewallConfigControl;
  float* EngrLanScadaLanFW_firewallConfigControl_Mobius_Mark;
  SystemSV<float>* hourlyRateAdversary;
  float* hourlyRateAdversary_Mobius_Mark;
  Skill* NetworkPenetration;
  short* NetworkPenetration_Mobius_Mark;
  SystemSV<float>* cyberAttackAttribution;
  float* cyberAttackAttribution_Mobius_Mark;
  SystemSV<float>* EngrLAN_networkAnomalyResponseStrength;
  float* EngrLAN_networkAnomalyResponseStrength_Mobius_Mark;
  StepChosen* EngrLanScadaLanFW_CircumventFWRulesChosen;
  short* EngrLanScadaLanFW_CircumventFWRulesChosen_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainUserCredentialsWeight;
  short* CorpLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainUserCredentialsWeight;
  short* LinuxOS_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_AdminModifyFWOpenWeight;
  short* CorpLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainRemoteUIAccessOSWeight;
  short* LinuxOS_GainRemoteUIAccessOSWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLocalUIAccessOSWeight;
  short* LinuxOS_GainLocalUIAccessOSWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLogicalAccessWeight;
  short* CorpLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* HMI_GainLocalUIAccessDeviceWeight;
  short* HMI_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_CircumventFWRulesWeight;
  short* EngrLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNetworkNodeWeight;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_CircumventFWRulesWeight;
  short* CorpLanEngrLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainUserCredentialsWeight;
  short* EngrLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* DoNothingWeight;
  short* DoNothingWeight_Mobius_Mark;
  StepWeight* SSHServer_GainLogicalAccessWeight;
  short* SSHServer_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainUserCredentialsWeight;
  short* CorpLanEngrLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainLogicalAccessWeight;
  short* HMI_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainUserCredentialsWeight;
  short* EngrWorkstation_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLogicalAccessWeight;
  short* EngrWorkstation_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_AdminModifyFWOpenWeight;
  short* CorpLanEngrLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLocalUIAccessDeviceWeight;
  short* EngrWorkstation_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SSHServer_GainUserCredentialsWeight;
  short* SSHServer_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainUserCredentialsWeight;
  short* HMI_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLAN_PlaceRogueHostOnNetworkWeight;
  short* CorpLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLogicalAccessWeight;
  short* CorpLanEngrLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_PlaceRogueHostOnNetworkWeight;
  short* EngrLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_AdminModifyFWOpenWeight;
  short* EngrLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLogicalAccessWeight;
  short* LinuxOS_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* SCADALAN_PlaceRogueHostOnNetworkWeight;
  short* SCADALAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainRemoteUIAccessDeviceWeight;
  short* EngrWorkstation_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLogicalAccessWeight;
  short* EngrLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_CircumventFWRulesWeight;
  short* CorpLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* HMI_GainRemoteUIAccessDeviceWeight;
  short* HMI_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short* MakeDecision_Mobius_Mark;
  double* TheDistributionParameters;

  EngrLanScadaLanFW_CircumventFWRulesSuccessStep();
  ~EngrLanScadaLanFW_CircumventFWRulesSuccessStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  double timeDistributionParameter1();
  bool preconditionsMet();
  void executeEffects();
}; // EngrLanScadaLanFW_CircumventFWRulesSuccessStep

class SCADALAN_GainNetworkAccessViaNetworkNodeFailureStep : public Step {
public:

  Access* SCADALAN_NetworkAccess;
  short* SCADALAN_NetworkAccess_Mobius_Mark;
  Goal* Goal_GainNetworkAccessOnScadaNetwork;
  short* Goal_GainNetworkAccessOnScadaNetwork_Mobius_Mark;
  Skill* NetworkPenetration;
  short* NetworkPenetration_Mobius_Mark;
  SystemSV<float>* SCADALAN_networkAnomalyDetectionStrength;
  float* SCADALAN_networkAnomalyDetectionStrength_Mobius_Mark;
  Skill* BasicCyberOffense;
  short* BasicCyberOffense_Mobius_Mark;
  SystemSV<float>* cyberAttackAttribution;
  float* cyberAttackAttribution_Mobius_Mark;
  Access* EngrLanScadaLanFW_LogicalAccess;
  short* EngrLanScadaLanFW_LogicalAccess_Mobius_Mark;
  Access* CorpLanScadaLanFW_LogicalAccess;
  short* CorpLanScadaLanFW_LogicalAccess_Mobius_Mark;
  Access* HMI_LogicalAccess;
  short* HMI_LogicalAccess_Mobius_Mark;
  StepChosen* SCADALAN_GainNetworkAccessViaNetworkNodeChosen;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeChosen_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainUserCredentialsWeight;
  short* CorpLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainUserCredentialsWeight;
  short* LinuxOS_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_AdminModifyFWOpenWeight;
  short* CorpLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainRemoteUIAccessOSWeight;
  short* LinuxOS_GainRemoteUIAccessOSWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLocalUIAccessOSWeight;
  short* LinuxOS_GainLocalUIAccessOSWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLogicalAccessWeight;
  short* CorpLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* HMI_GainLocalUIAccessDeviceWeight;
  short* HMI_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_CircumventFWRulesWeight;
  short* EngrLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNetworkNodeWeight;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_CircumventFWRulesWeight;
  short* CorpLanEngrLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainUserCredentialsWeight;
  short* EngrLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* DoNothingWeight;
  short* DoNothingWeight_Mobius_Mark;
  StepWeight* SSHServer_GainLogicalAccessWeight;
  short* SSHServer_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainUserCredentialsWeight;
  short* CorpLanEngrLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainLogicalAccessWeight;
  short* HMI_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainUserCredentialsWeight;
  short* EngrWorkstation_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLogicalAccessWeight;
  short* EngrWorkstation_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_AdminModifyFWOpenWeight;
  short* CorpLanEngrLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLocalUIAccessDeviceWeight;
  short* EngrWorkstation_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SSHServer_GainUserCredentialsWeight;
  short* SSHServer_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainUserCredentialsWeight;
  short* HMI_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLAN_PlaceRogueHostOnNetworkWeight;
  short* CorpLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLogicalAccessWeight;
  short* CorpLanEngrLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_PlaceRogueHostOnNetworkWeight;
  short* EngrLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_AdminModifyFWOpenWeight;
  short* EngrLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLogicalAccessWeight;
  short* LinuxOS_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* SCADALAN_PlaceRogueHostOnNetworkWeight;
  short* SCADALAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainRemoteUIAccessDeviceWeight;
  short* EngrWorkstation_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLogicalAccessWeight;
  short* EngrLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_CircumventFWRulesWeight;
  short* CorpLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* HMI_GainRemoteUIAccessDeviceWeight;
  short* HMI_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short* MakeDecision_Mobius_Mark;
  double* TheDistributionParameters;

  SCADALAN_GainNetworkAccessViaNetworkNodeFailureStep();
  ~SCADALAN_GainNetworkAccessViaNetworkNodeFailureStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  double timeDistributionParameter1();
  bool preconditionsMet();
  void executeEffects();
}; // SCADALAN_GainNetworkAccessViaNetworkNodeFailureStep

class SCADALAN_GainNetworkAccessViaNetworkNodeSuccessStep : public Step {
public:

  Access* SCADALAN_NetworkAccess;
  short* SCADALAN_NetworkAccess_Mobius_Mark;
  Goal* Goal_GainNetworkAccessOnScadaNetwork;
  short* Goal_GainNetworkAccessOnScadaNetwork_Mobius_Mark;
  Skill* NetworkPenetration;
  short* NetworkPenetration_Mobius_Mark;
  SystemSV<float>* SCADALAN_networkAnomalyDetectionStrength;
  float* SCADALAN_networkAnomalyDetectionStrength_Mobius_Mark;
  Skill* BasicCyberOffense;
  short* BasicCyberOffense_Mobius_Mark;
  SystemSV<float>* cyberAttackAttribution;
  float* cyberAttackAttribution_Mobius_Mark;
  Access* EngrLanScadaLanFW_LogicalAccess;
  short* EngrLanScadaLanFW_LogicalAccess_Mobius_Mark;
  Access* CorpLanScadaLanFW_LogicalAccess;
  short* CorpLanScadaLanFW_LogicalAccess_Mobius_Mark;
  Access* HMI_LogicalAccess;
  short* HMI_LogicalAccess_Mobius_Mark;
  StepChosen* SCADALAN_GainNetworkAccessViaNetworkNodeChosen;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeChosen_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainUserCredentialsWeight;
  short* CorpLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainUserCredentialsWeight;
  short* LinuxOS_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_AdminModifyFWOpenWeight;
  short* CorpLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainRemoteUIAccessOSWeight;
  short* LinuxOS_GainRemoteUIAccessOSWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLocalUIAccessOSWeight;
  short* LinuxOS_GainLocalUIAccessOSWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLogicalAccessWeight;
  short* CorpLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* HMI_GainLocalUIAccessDeviceWeight;
  short* HMI_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_CircumventFWRulesWeight;
  short* EngrLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNetworkNodeWeight;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_CircumventFWRulesWeight;
  short* CorpLanEngrLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainUserCredentialsWeight;
  short* EngrLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* DoNothingWeight;
  short* DoNothingWeight_Mobius_Mark;
  StepWeight* SSHServer_GainLogicalAccessWeight;
  short* SSHServer_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainUserCredentialsWeight;
  short* CorpLanEngrLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainLogicalAccessWeight;
  short* HMI_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainUserCredentialsWeight;
  short* EngrWorkstation_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLogicalAccessWeight;
  short* EngrWorkstation_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_AdminModifyFWOpenWeight;
  short* CorpLanEngrLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLocalUIAccessDeviceWeight;
  short* EngrWorkstation_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SSHServer_GainUserCredentialsWeight;
  short* SSHServer_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainUserCredentialsWeight;
  short* HMI_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLAN_PlaceRogueHostOnNetworkWeight;
  short* CorpLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLogicalAccessWeight;
  short* CorpLanEngrLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_PlaceRogueHostOnNetworkWeight;
  short* EngrLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_AdminModifyFWOpenWeight;
  short* EngrLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLogicalAccessWeight;
  short* LinuxOS_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* SCADALAN_PlaceRogueHostOnNetworkWeight;
  short* SCADALAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainRemoteUIAccessDeviceWeight;
  short* EngrWorkstation_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLogicalAccessWeight;
  short* EngrLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_CircumventFWRulesWeight;
  short* CorpLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* HMI_GainRemoteUIAccessDeviceWeight;
  short* HMI_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short* MakeDecision_Mobius_Mark;
  double* TheDistributionParameters;

  SCADALAN_GainNetworkAccessViaNetworkNodeSuccessStep();
  ~SCADALAN_GainNetworkAccessViaNetworkNodeSuccessStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  double timeDistributionParameter1();
  bool preconditionsMet();
  void executeEffects();
}; // SCADALAN_GainNetworkAccessViaNetworkNodeSuccessStep

class CorpLanEngrLanFW_CircumventFWRulesFailureStep : public Step {
public:

  Access* CorpLAN_NetworkAccess;
  short* CorpLAN_NetworkAccess_Mobius_Mark;
  Access* EngrLAN_NetworkAccess;
  short* EngrLAN_NetworkAccess_Mobius_Mark;
  Knowledge* FirewallConfigKnowledge;
  short* FirewallConfigKnowledge_Mobius_Mark;
  SystemSV<float>* CorpLanEngrLanFW_firewallConfigControl;
  float* CorpLanEngrLanFW_firewallConfigControl_Mobius_Mark;
  SystemSV<float>* hourlyRateAdversary;
  float* hourlyRateAdversary_Mobius_Mark;
  Skill* NetworkPenetration;
  short* NetworkPenetration_Mobius_Mark;
  SystemSV<float>* cyberAttackAttribution;
  float* cyberAttackAttribution_Mobius_Mark;
  SystemSV<float>* CorpLAN_networkAnomalyResponseStrength;
  float* CorpLAN_networkAnomalyResponseStrength_Mobius_Mark;
  StepChosen* CorpLanEngrLanFW_CircumventFWRulesChosen;
  short* CorpLanEngrLanFW_CircumventFWRulesChosen_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainUserCredentialsWeight;
  short* CorpLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainUserCredentialsWeight;
  short* LinuxOS_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_AdminModifyFWOpenWeight;
  short* CorpLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainRemoteUIAccessOSWeight;
  short* LinuxOS_GainRemoteUIAccessOSWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLocalUIAccessOSWeight;
  short* LinuxOS_GainLocalUIAccessOSWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLogicalAccessWeight;
  short* CorpLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* HMI_GainLocalUIAccessDeviceWeight;
  short* HMI_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_CircumventFWRulesWeight;
  short* EngrLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNetworkNodeWeight;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_CircumventFWRulesWeight;
  short* CorpLanEngrLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainUserCredentialsWeight;
  short* EngrLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* DoNothingWeight;
  short* DoNothingWeight_Mobius_Mark;
  StepWeight* SSHServer_GainLogicalAccessWeight;
  short* SSHServer_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainUserCredentialsWeight;
  short* CorpLanEngrLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainLogicalAccessWeight;
  short* HMI_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainUserCredentialsWeight;
  short* EngrWorkstation_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLogicalAccessWeight;
  short* EngrWorkstation_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_AdminModifyFWOpenWeight;
  short* CorpLanEngrLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLocalUIAccessDeviceWeight;
  short* EngrWorkstation_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SSHServer_GainUserCredentialsWeight;
  short* SSHServer_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainUserCredentialsWeight;
  short* HMI_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLAN_PlaceRogueHostOnNetworkWeight;
  short* CorpLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLogicalAccessWeight;
  short* CorpLanEngrLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_PlaceRogueHostOnNetworkWeight;
  short* EngrLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_AdminModifyFWOpenWeight;
  short* EngrLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLogicalAccessWeight;
  short* LinuxOS_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* SCADALAN_PlaceRogueHostOnNetworkWeight;
  short* SCADALAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainRemoteUIAccessDeviceWeight;
  short* EngrWorkstation_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLogicalAccessWeight;
  short* EngrLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_CircumventFWRulesWeight;
  short* CorpLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* HMI_GainRemoteUIAccessDeviceWeight;
  short* HMI_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short* MakeDecision_Mobius_Mark;
  double* TheDistributionParameters;

  CorpLanEngrLanFW_CircumventFWRulesFailureStep();
  ~CorpLanEngrLanFW_CircumventFWRulesFailureStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  double timeDistributionParameter1();
  bool preconditionsMet();
  void executeEffects();
}; // CorpLanEngrLanFW_CircumventFWRulesFailureStep

class CorpLanEngrLanFW_CircumventFWRulesSuccessStep : public Step {
public:

  Access* CorpLAN_NetworkAccess;
  short* CorpLAN_NetworkAccess_Mobius_Mark;
  Access* EngrLAN_NetworkAccess;
  short* EngrLAN_NetworkAccess_Mobius_Mark;
  Knowledge* FirewallConfigKnowledge;
  short* FirewallConfigKnowledge_Mobius_Mark;
  SystemSV<float>* CorpLanEngrLanFW_firewallConfigControl;
  float* CorpLanEngrLanFW_firewallConfigControl_Mobius_Mark;
  SystemSV<float>* hourlyRateAdversary;
  float* hourlyRateAdversary_Mobius_Mark;
  Skill* NetworkPenetration;
  short* NetworkPenetration_Mobius_Mark;
  SystemSV<float>* cyberAttackAttribution;
  float* cyberAttackAttribution_Mobius_Mark;
  SystemSV<float>* CorpLAN_networkAnomalyResponseStrength;
  float* CorpLAN_networkAnomalyResponseStrength_Mobius_Mark;
  StepChosen* CorpLanEngrLanFW_CircumventFWRulesChosen;
  short* CorpLanEngrLanFW_CircumventFWRulesChosen_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainUserCredentialsWeight;
  short* CorpLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainUserCredentialsWeight;
  short* LinuxOS_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_AdminModifyFWOpenWeight;
  short* CorpLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainRemoteUIAccessOSWeight;
  short* LinuxOS_GainRemoteUIAccessOSWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLocalUIAccessOSWeight;
  short* LinuxOS_GainLocalUIAccessOSWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLogicalAccessWeight;
  short* CorpLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* HMI_GainLocalUIAccessDeviceWeight;
  short* HMI_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_CircumventFWRulesWeight;
  short* EngrLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNetworkNodeWeight;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_CircumventFWRulesWeight;
  short* CorpLanEngrLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainUserCredentialsWeight;
  short* EngrLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* DoNothingWeight;
  short* DoNothingWeight_Mobius_Mark;
  StepWeight* SSHServer_GainLogicalAccessWeight;
  short* SSHServer_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainUserCredentialsWeight;
  short* CorpLanEngrLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainLogicalAccessWeight;
  short* HMI_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainUserCredentialsWeight;
  short* EngrWorkstation_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLogicalAccessWeight;
  short* EngrWorkstation_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_AdminModifyFWOpenWeight;
  short* CorpLanEngrLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLocalUIAccessDeviceWeight;
  short* EngrWorkstation_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SSHServer_GainUserCredentialsWeight;
  short* SSHServer_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainUserCredentialsWeight;
  short* HMI_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLAN_PlaceRogueHostOnNetworkWeight;
  short* CorpLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLogicalAccessWeight;
  short* CorpLanEngrLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_PlaceRogueHostOnNetworkWeight;
  short* EngrLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_AdminModifyFWOpenWeight;
  short* EngrLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLogicalAccessWeight;
  short* LinuxOS_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* SCADALAN_PlaceRogueHostOnNetworkWeight;
  short* SCADALAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainRemoteUIAccessDeviceWeight;
  short* EngrWorkstation_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLogicalAccessWeight;
  short* EngrLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_CircumventFWRulesWeight;
  short* CorpLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* HMI_GainRemoteUIAccessDeviceWeight;
  short* HMI_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short* MakeDecision_Mobius_Mark;
  double* TheDistributionParameters;

  CorpLanEngrLanFW_CircumventFWRulesSuccessStep();
  ~CorpLanEngrLanFW_CircumventFWRulesSuccessStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  double timeDistributionParameter1();
  bool preconditionsMet();
  void executeEffects();
}; // CorpLanEngrLanFW_CircumventFWRulesSuccessStep

class EngrLanScadaLanFW_GainUserCredentialsFailureStep : public Step {
public:

  Access* EngrLanScadaLanFW_HasUserCredentials;
  short* EngrLanScadaLanFW_HasUserCredentials_Mobius_Mark;
  Skill* BasicCyberOffense;
  short* BasicCyberOffense_Mobius_Mark;
  SystemSV<char>* EngrLanScadaLanFW_userAuthenticationType;
  char* EngrLanScadaLanFW_userAuthenticationType_Mobius_Mark;
  SystemSV<float>* EngrLanScadaLanFW_strengthOfUserAuthentication;
  float* EngrLanScadaLanFW_strengthOfUserAuthentication_Mobius_Mark;
  StepChosen* EngrLanScadaLanFW_GainUserCredentialsChosen;
  short* EngrLanScadaLanFW_GainUserCredentialsChosen_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainUserCredentialsWeight;
  short* CorpLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainUserCredentialsWeight;
  short* LinuxOS_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_AdminModifyFWOpenWeight;
  short* CorpLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainRemoteUIAccessOSWeight;
  short* LinuxOS_GainRemoteUIAccessOSWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLocalUIAccessOSWeight;
  short* LinuxOS_GainLocalUIAccessOSWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLogicalAccessWeight;
  short* CorpLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* HMI_GainLocalUIAccessDeviceWeight;
  short* HMI_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_CircumventFWRulesWeight;
  short* EngrLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNetworkNodeWeight;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_CircumventFWRulesWeight;
  short* CorpLanEngrLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainUserCredentialsWeight;
  short* EngrLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* DoNothingWeight;
  short* DoNothingWeight_Mobius_Mark;
  StepWeight* SSHServer_GainLogicalAccessWeight;
  short* SSHServer_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainUserCredentialsWeight;
  short* CorpLanEngrLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainLogicalAccessWeight;
  short* HMI_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainUserCredentialsWeight;
  short* EngrWorkstation_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLogicalAccessWeight;
  short* EngrWorkstation_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_AdminModifyFWOpenWeight;
  short* CorpLanEngrLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLocalUIAccessDeviceWeight;
  short* EngrWorkstation_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SSHServer_GainUserCredentialsWeight;
  short* SSHServer_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainUserCredentialsWeight;
  short* HMI_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLAN_PlaceRogueHostOnNetworkWeight;
  short* CorpLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLogicalAccessWeight;
  short* CorpLanEngrLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_PlaceRogueHostOnNetworkWeight;
  short* EngrLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_AdminModifyFWOpenWeight;
  short* EngrLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLogicalAccessWeight;
  short* LinuxOS_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* SCADALAN_PlaceRogueHostOnNetworkWeight;
  short* SCADALAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainRemoteUIAccessDeviceWeight;
  short* EngrWorkstation_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLogicalAccessWeight;
  short* EngrLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_CircumventFWRulesWeight;
  short* CorpLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* HMI_GainRemoteUIAccessDeviceWeight;
  short* HMI_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short* MakeDecision_Mobius_Mark;
  double* TheDistributionParameters;

  EngrLanScadaLanFW_GainUserCredentialsFailureStep();
  ~EngrLanScadaLanFW_GainUserCredentialsFailureStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  double timeDistributionParameter1();
  bool preconditionsMet();
  void executeEffects();
}; // EngrLanScadaLanFW_GainUserCredentialsFailureStep

class EngrLanScadaLanFW_GainUserCredentialsSuccessStep : public Step {
public:

  Access* EngrLanScadaLanFW_HasUserCredentials;
  short* EngrLanScadaLanFW_HasUserCredentials_Mobius_Mark;
  Skill* BasicCyberOffense;
  short* BasicCyberOffense_Mobius_Mark;
  SystemSV<char>* EngrLanScadaLanFW_userAuthenticationType;
  char* EngrLanScadaLanFW_userAuthenticationType_Mobius_Mark;
  SystemSV<float>* EngrLanScadaLanFW_strengthOfUserAuthentication;
  float* EngrLanScadaLanFW_strengthOfUserAuthentication_Mobius_Mark;
  StepChosen* EngrLanScadaLanFW_GainUserCredentialsChosen;
  short* EngrLanScadaLanFW_GainUserCredentialsChosen_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainUserCredentialsWeight;
  short* CorpLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainUserCredentialsWeight;
  short* LinuxOS_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_AdminModifyFWOpenWeight;
  short* CorpLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainRemoteUIAccessOSWeight;
  short* LinuxOS_GainRemoteUIAccessOSWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLocalUIAccessOSWeight;
  short* LinuxOS_GainLocalUIAccessOSWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLogicalAccessWeight;
  short* CorpLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* HMI_GainLocalUIAccessDeviceWeight;
  short* HMI_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_CircumventFWRulesWeight;
  short* EngrLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNetworkNodeWeight;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_CircumventFWRulesWeight;
  short* CorpLanEngrLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainUserCredentialsWeight;
  short* EngrLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* DoNothingWeight;
  short* DoNothingWeight_Mobius_Mark;
  StepWeight* SSHServer_GainLogicalAccessWeight;
  short* SSHServer_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainUserCredentialsWeight;
  short* CorpLanEngrLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainLogicalAccessWeight;
  short* HMI_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainUserCredentialsWeight;
  short* EngrWorkstation_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLogicalAccessWeight;
  short* EngrWorkstation_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_AdminModifyFWOpenWeight;
  short* CorpLanEngrLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLocalUIAccessDeviceWeight;
  short* EngrWorkstation_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SSHServer_GainUserCredentialsWeight;
  short* SSHServer_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainUserCredentialsWeight;
  short* HMI_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLAN_PlaceRogueHostOnNetworkWeight;
  short* CorpLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLogicalAccessWeight;
  short* CorpLanEngrLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_PlaceRogueHostOnNetworkWeight;
  short* EngrLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_AdminModifyFWOpenWeight;
  short* EngrLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLogicalAccessWeight;
  short* LinuxOS_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* SCADALAN_PlaceRogueHostOnNetworkWeight;
  short* SCADALAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainRemoteUIAccessDeviceWeight;
  short* EngrWorkstation_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLogicalAccessWeight;
  short* EngrLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_CircumventFWRulesWeight;
  short* CorpLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* HMI_GainRemoteUIAccessDeviceWeight;
  short* HMI_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short* MakeDecision_Mobius_Mark;
  double* TheDistributionParameters;

  EngrLanScadaLanFW_GainUserCredentialsSuccessStep();
  ~EngrLanScadaLanFW_GainUserCredentialsSuccessStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  double timeDistributionParameter1();
  bool preconditionsMet();
  void executeEffects();
}; // EngrLanScadaLanFW_GainUserCredentialsSuccessStep

class DoNothingOutcome1Step : public Step {
public:

  StepChosen* DoNothingChosen;
  short* DoNothingChosen_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainUserCredentialsWeight;
  short* CorpLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainUserCredentialsWeight;
  short* LinuxOS_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_AdminModifyFWOpenWeight;
  short* CorpLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainRemoteUIAccessOSWeight;
  short* LinuxOS_GainRemoteUIAccessOSWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLocalUIAccessOSWeight;
  short* LinuxOS_GainLocalUIAccessOSWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLogicalAccessWeight;
  short* CorpLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* HMI_GainLocalUIAccessDeviceWeight;
  short* HMI_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_CircumventFWRulesWeight;
  short* EngrLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNetworkNodeWeight;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_CircumventFWRulesWeight;
  short* CorpLanEngrLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainUserCredentialsWeight;
  short* EngrLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* DoNothingWeight;
  short* DoNothingWeight_Mobius_Mark;
  StepWeight* SSHServer_GainLogicalAccessWeight;
  short* SSHServer_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainUserCredentialsWeight;
  short* CorpLanEngrLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainLogicalAccessWeight;
  short* HMI_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainUserCredentialsWeight;
  short* EngrWorkstation_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLogicalAccessWeight;
  short* EngrWorkstation_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_AdminModifyFWOpenWeight;
  short* CorpLanEngrLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLocalUIAccessDeviceWeight;
  short* EngrWorkstation_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SSHServer_GainUserCredentialsWeight;
  short* SSHServer_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainUserCredentialsWeight;
  short* HMI_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLAN_PlaceRogueHostOnNetworkWeight;
  short* CorpLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLogicalAccessWeight;
  short* CorpLanEngrLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_PlaceRogueHostOnNetworkWeight;
  short* EngrLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_AdminModifyFWOpenWeight;
  short* EngrLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLogicalAccessWeight;
  short* LinuxOS_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* SCADALAN_PlaceRogueHostOnNetworkWeight;
  short* SCADALAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainRemoteUIAccessDeviceWeight;
  short* EngrWorkstation_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLogicalAccessWeight;
  short* EngrLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_CircumventFWRulesWeight;
  short* CorpLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* HMI_GainRemoteUIAccessDeviceWeight;
  short* HMI_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short* MakeDecision_Mobius_Mark;
  double* TheDistributionParameters;

  DoNothingOutcome1Step();
  ~DoNothingOutcome1Step();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  bool preconditionsMet();
  void executeEffects();
}; // DoNothingOutcome1Step

class SSHServer_GainLogicalAccessFailureStep : public Step {
public:

  Access* SSHServer_LogicalAccess;
  short* SSHServer_LogicalAccess_Mobius_Mark;
  Access* LinuxOS_UIAccess;
  short* LinuxOS_UIAccess_Mobius_Mark;
  Access* SSHServer_HasUserCredentials;
  short* SSHServer_HasUserCredentials_Mobius_Mark;
  Access* SSHServer_UIAccess;
  short* SSHServer_UIAccess_Mobius_Mark;
  SystemSV<float>* SSHServer_credentialMonitoring;
  float* SSHServer_credentialMonitoring_Mobius_Mark;
  Skill* BasicCyberOffense;
  short* BasicCyberOffense_Mobius_Mark;
  SystemSV<float>* cyberAttackAttribution;
  float* cyberAttackAttribution_Mobius_Mark;
  SystemSV<char>* SSHServer_userAuthenticationType;
  char* SSHServer_userAuthenticationType_Mobius_Mark;
  StepChosen* SSHServer_GainLogicalAccessChosen;
  short* SSHServer_GainLogicalAccessChosen_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainUserCredentialsWeight;
  short* CorpLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainUserCredentialsWeight;
  short* LinuxOS_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_AdminModifyFWOpenWeight;
  short* CorpLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainRemoteUIAccessOSWeight;
  short* LinuxOS_GainRemoteUIAccessOSWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLocalUIAccessOSWeight;
  short* LinuxOS_GainLocalUIAccessOSWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLogicalAccessWeight;
  short* CorpLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* HMI_GainLocalUIAccessDeviceWeight;
  short* HMI_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_CircumventFWRulesWeight;
  short* EngrLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNetworkNodeWeight;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_CircumventFWRulesWeight;
  short* CorpLanEngrLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainUserCredentialsWeight;
  short* EngrLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* DoNothingWeight;
  short* DoNothingWeight_Mobius_Mark;
  StepWeight* SSHServer_GainLogicalAccessWeight;
  short* SSHServer_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainUserCredentialsWeight;
  short* CorpLanEngrLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainLogicalAccessWeight;
  short* HMI_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainUserCredentialsWeight;
  short* EngrWorkstation_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLogicalAccessWeight;
  short* EngrWorkstation_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_AdminModifyFWOpenWeight;
  short* CorpLanEngrLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLocalUIAccessDeviceWeight;
  short* EngrWorkstation_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SSHServer_GainUserCredentialsWeight;
  short* SSHServer_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainUserCredentialsWeight;
  short* HMI_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLAN_PlaceRogueHostOnNetworkWeight;
  short* CorpLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLogicalAccessWeight;
  short* CorpLanEngrLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_PlaceRogueHostOnNetworkWeight;
  short* EngrLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_AdminModifyFWOpenWeight;
  short* EngrLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLogicalAccessWeight;
  short* LinuxOS_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* SCADALAN_PlaceRogueHostOnNetworkWeight;
  short* SCADALAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainRemoteUIAccessDeviceWeight;
  short* EngrWorkstation_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLogicalAccessWeight;
  short* EngrLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_CircumventFWRulesWeight;
  short* CorpLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* HMI_GainRemoteUIAccessDeviceWeight;
  short* HMI_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short* MakeDecision_Mobius_Mark;
  double* TheDistributionParameters;

  SSHServer_GainLogicalAccessFailureStep();
  ~SSHServer_GainLogicalAccessFailureStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  double timeDistributionParameter1();
  bool preconditionsMet();
  void executeEffects();
}; // SSHServer_GainLogicalAccessFailureStep

class SSHServer_GainLogicalAccessSuccessStep : public Step {
public:

  Access* SSHServer_LogicalAccess;
  short* SSHServer_LogicalAccess_Mobius_Mark;
  Access* LinuxOS_UIAccess;
  short* LinuxOS_UIAccess_Mobius_Mark;
  Access* SSHServer_HasUserCredentials;
  short* SSHServer_HasUserCredentials_Mobius_Mark;
  Access* SSHServer_UIAccess;
  short* SSHServer_UIAccess_Mobius_Mark;
  SystemSV<float>* SSHServer_credentialMonitoring;
  float* SSHServer_credentialMonitoring_Mobius_Mark;
  Skill* BasicCyberOffense;
  short* BasicCyberOffense_Mobius_Mark;
  SystemSV<float>* cyberAttackAttribution;
  float* cyberAttackAttribution_Mobius_Mark;
  SystemSV<char>* SSHServer_userAuthenticationType;
  char* SSHServer_userAuthenticationType_Mobius_Mark;
  StepChosen* SSHServer_GainLogicalAccessChosen;
  short* SSHServer_GainLogicalAccessChosen_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainUserCredentialsWeight;
  short* CorpLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainUserCredentialsWeight;
  short* LinuxOS_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_AdminModifyFWOpenWeight;
  short* CorpLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainRemoteUIAccessOSWeight;
  short* LinuxOS_GainRemoteUIAccessOSWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLocalUIAccessOSWeight;
  short* LinuxOS_GainLocalUIAccessOSWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLogicalAccessWeight;
  short* CorpLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* HMI_GainLocalUIAccessDeviceWeight;
  short* HMI_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_CircumventFWRulesWeight;
  short* EngrLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNetworkNodeWeight;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_CircumventFWRulesWeight;
  short* CorpLanEngrLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainUserCredentialsWeight;
  short* EngrLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* DoNothingWeight;
  short* DoNothingWeight_Mobius_Mark;
  StepWeight* SSHServer_GainLogicalAccessWeight;
  short* SSHServer_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainUserCredentialsWeight;
  short* CorpLanEngrLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainLogicalAccessWeight;
  short* HMI_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainUserCredentialsWeight;
  short* EngrWorkstation_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLogicalAccessWeight;
  short* EngrWorkstation_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_AdminModifyFWOpenWeight;
  short* CorpLanEngrLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLocalUIAccessDeviceWeight;
  short* EngrWorkstation_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SSHServer_GainUserCredentialsWeight;
  short* SSHServer_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainUserCredentialsWeight;
  short* HMI_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLAN_PlaceRogueHostOnNetworkWeight;
  short* CorpLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLogicalAccessWeight;
  short* CorpLanEngrLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_PlaceRogueHostOnNetworkWeight;
  short* EngrLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_AdminModifyFWOpenWeight;
  short* EngrLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLogicalAccessWeight;
  short* LinuxOS_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* SCADALAN_PlaceRogueHostOnNetworkWeight;
  short* SCADALAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainRemoteUIAccessDeviceWeight;
  short* EngrWorkstation_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLogicalAccessWeight;
  short* EngrLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_CircumventFWRulesWeight;
  short* CorpLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* HMI_GainRemoteUIAccessDeviceWeight;
  short* HMI_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short* MakeDecision_Mobius_Mark;
  double* TheDistributionParameters;

  SSHServer_GainLogicalAccessSuccessStep();
  ~SSHServer_GainLogicalAccessSuccessStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  double timeDistributionParameter1();
  bool preconditionsMet();
  void executeEffects();
}; // SSHServer_GainLogicalAccessSuccessStep

class CorpLanEngrLanFW_GainUserCredentialsFailureStep : public Step {
public:

  Access* CorpLanEngrLanFW_HasUserCredentials;
  short* CorpLanEngrLanFW_HasUserCredentials_Mobius_Mark;
  Skill* BasicCyberOffense;
  short* BasicCyberOffense_Mobius_Mark;
  SystemSV<char>* CorpLanEngrLanFW_userAuthenticationType;
  char* CorpLanEngrLanFW_userAuthenticationType_Mobius_Mark;
  SystemSV<float>* CorpLanEngrLanFW_strengthOfUserAuthentication;
  float* CorpLanEngrLanFW_strengthOfUserAuthentication_Mobius_Mark;
  StepChosen* CorpLanEngrLanFW_GainUserCredentialsChosen;
  short* CorpLanEngrLanFW_GainUserCredentialsChosen_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainUserCredentialsWeight;
  short* CorpLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainUserCredentialsWeight;
  short* LinuxOS_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_AdminModifyFWOpenWeight;
  short* CorpLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainRemoteUIAccessOSWeight;
  short* LinuxOS_GainRemoteUIAccessOSWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLocalUIAccessOSWeight;
  short* LinuxOS_GainLocalUIAccessOSWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLogicalAccessWeight;
  short* CorpLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* HMI_GainLocalUIAccessDeviceWeight;
  short* HMI_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_CircumventFWRulesWeight;
  short* EngrLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNetworkNodeWeight;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_CircumventFWRulesWeight;
  short* CorpLanEngrLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainUserCredentialsWeight;
  short* EngrLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* DoNothingWeight;
  short* DoNothingWeight_Mobius_Mark;
  StepWeight* SSHServer_GainLogicalAccessWeight;
  short* SSHServer_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainUserCredentialsWeight;
  short* CorpLanEngrLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainLogicalAccessWeight;
  short* HMI_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainUserCredentialsWeight;
  short* EngrWorkstation_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLogicalAccessWeight;
  short* EngrWorkstation_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_AdminModifyFWOpenWeight;
  short* CorpLanEngrLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLocalUIAccessDeviceWeight;
  short* EngrWorkstation_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SSHServer_GainUserCredentialsWeight;
  short* SSHServer_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainUserCredentialsWeight;
  short* HMI_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLAN_PlaceRogueHostOnNetworkWeight;
  short* CorpLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLogicalAccessWeight;
  short* CorpLanEngrLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_PlaceRogueHostOnNetworkWeight;
  short* EngrLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_AdminModifyFWOpenWeight;
  short* EngrLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLogicalAccessWeight;
  short* LinuxOS_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* SCADALAN_PlaceRogueHostOnNetworkWeight;
  short* SCADALAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainRemoteUIAccessDeviceWeight;
  short* EngrWorkstation_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLogicalAccessWeight;
  short* EngrLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_CircumventFWRulesWeight;
  short* CorpLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* HMI_GainRemoteUIAccessDeviceWeight;
  short* HMI_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short* MakeDecision_Mobius_Mark;
  double* TheDistributionParameters;

  CorpLanEngrLanFW_GainUserCredentialsFailureStep();
  ~CorpLanEngrLanFW_GainUserCredentialsFailureStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  double timeDistributionParameter1();
  bool preconditionsMet();
  void executeEffects();
}; // CorpLanEngrLanFW_GainUserCredentialsFailureStep

class CorpLanEngrLanFW_GainUserCredentialsSuccessStep : public Step {
public:

  Access* CorpLanEngrLanFW_HasUserCredentials;
  short* CorpLanEngrLanFW_HasUserCredentials_Mobius_Mark;
  Skill* BasicCyberOffense;
  short* BasicCyberOffense_Mobius_Mark;
  SystemSV<char>* CorpLanEngrLanFW_userAuthenticationType;
  char* CorpLanEngrLanFW_userAuthenticationType_Mobius_Mark;
  SystemSV<float>* CorpLanEngrLanFW_strengthOfUserAuthentication;
  float* CorpLanEngrLanFW_strengthOfUserAuthentication_Mobius_Mark;
  StepChosen* CorpLanEngrLanFW_GainUserCredentialsChosen;
  short* CorpLanEngrLanFW_GainUserCredentialsChosen_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainUserCredentialsWeight;
  short* CorpLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainUserCredentialsWeight;
  short* LinuxOS_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_AdminModifyFWOpenWeight;
  short* CorpLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainRemoteUIAccessOSWeight;
  short* LinuxOS_GainRemoteUIAccessOSWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLocalUIAccessOSWeight;
  short* LinuxOS_GainLocalUIAccessOSWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLogicalAccessWeight;
  short* CorpLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* HMI_GainLocalUIAccessDeviceWeight;
  short* HMI_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_CircumventFWRulesWeight;
  short* EngrLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNetworkNodeWeight;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_CircumventFWRulesWeight;
  short* CorpLanEngrLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainUserCredentialsWeight;
  short* EngrLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* DoNothingWeight;
  short* DoNothingWeight_Mobius_Mark;
  StepWeight* SSHServer_GainLogicalAccessWeight;
  short* SSHServer_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainUserCredentialsWeight;
  short* CorpLanEngrLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainLogicalAccessWeight;
  short* HMI_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainUserCredentialsWeight;
  short* EngrWorkstation_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLogicalAccessWeight;
  short* EngrWorkstation_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_AdminModifyFWOpenWeight;
  short* CorpLanEngrLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLocalUIAccessDeviceWeight;
  short* EngrWorkstation_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SSHServer_GainUserCredentialsWeight;
  short* SSHServer_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainUserCredentialsWeight;
  short* HMI_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLAN_PlaceRogueHostOnNetworkWeight;
  short* CorpLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLogicalAccessWeight;
  short* CorpLanEngrLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_PlaceRogueHostOnNetworkWeight;
  short* EngrLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_AdminModifyFWOpenWeight;
  short* EngrLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLogicalAccessWeight;
  short* LinuxOS_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* SCADALAN_PlaceRogueHostOnNetworkWeight;
  short* SCADALAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainRemoteUIAccessDeviceWeight;
  short* EngrWorkstation_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLogicalAccessWeight;
  short* EngrLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_CircumventFWRulesWeight;
  short* CorpLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* HMI_GainRemoteUIAccessDeviceWeight;
  short* HMI_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short* MakeDecision_Mobius_Mark;
  double* TheDistributionParameters;

  CorpLanEngrLanFW_GainUserCredentialsSuccessStep();
  ~CorpLanEngrLanFW_GainUserCredentialsSuccessStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  double timeDistributionParameter1();
  bool preconditionsMet();
  void executeEffects();
}; // CorpLanEngrLanFW_GainUserCredentialsSuccessStep

class HMI_GainLogicalAccessFailureStep : public Step {
public:

  Access* HMI_LogicalAccess;
  short* HMI_LogicalAccess_Mobius_Mark;
  Access* HMI_HasUserCredentials;
  short* HMI_HasUserCredentials_Mobius_Mark;
  Access* HMI_UIAccess;
  short* HMI_UIAccess_Mobius_Mark;
  SystemSV<float>* HMI_credentialMonitoring;
  float* HMI_credentialMonitoring_Mobius_Mark;
  Skill* BasicCyberOffense;
  short* BasicCyberOffense_Mobius_Mark;
  SystemSV<float>* cyberAttackAttribution;
  float* cyberAttackAttribution_Mobius_Mark;
  SystemSV<char>* HMI_userAuthenticationType;
  char* HMI_userAuthenticationType_Mobius_Mark;
  StepChosen* HMI_GainLogicalAccessChosen;
  short* HMI_GainLogicalAccessChosen_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainUserCredentialsWeight;
  short* CorpLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainUserCredentialsWeight;
  short* LinuxOS_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_AdminModifyFWOpenWeight;
  short* CorpLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainRemoteUIAccessOSWeight;
  short* LinuxOS_GainRemoteUIAccessOSWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLocalUIAccessOSWeight;
  short* LinuxOS_GainLocalUIAccessOSWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLogicalAccessWeight;
  short* CorpLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* HMI_GainLocalUIAccessDeviceWeight;
  short* HMI_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_CircumventFWRulesWeight;
  short* EngrLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNetworkNodeWeight;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_CircumventFWRulesWeight;
  short* CorpLanEngrLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainUserCredentialsWeight;
  short* EngrLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* DoNothingWeight;
  short* DoNothingWeight_Mobius_Mark;
  StepWeight* SSHServer_GainLogicalAccessWeight;
  short* SSHServer_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainUserCredentialsWeight;
  short* CorpLanEngrLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainLogicalAccessWeight;
  short* HMI_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainUserCredentialsWeight;
  short* EngrWorkstation_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLogicalAccessWeight;
  short* EngrWorkstation_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_AdminModifyFWOpenWeight;
  short* CorpLanEngrLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLocalUIAccessDeviceWeight;
  short* EngrWorkstation_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SSHServer_GainUserCredentialsWeight;
  short* SSHServer_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainUserCredentialsWeight;
  short* HMI_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLAN_PlaceRogueHostOnNetworkWeight;
  short* CorpLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLogicalAccessWeight;
  short* CorpLanEngrLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_PlaceRogueHostOnNetworkWeight;
  short* EngrLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_AdminModifyFWOpenWeight;
  short* EngrLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLogicalAccessWeight;
  short* LinuxOS_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* SCADALAN_PlaceRogueHostOnNetworkWeight;
  short* SCADALAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainRemoteUIAccessDeviceWeight;
  short* EngrWorkstation_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLogicalAccessWeight;
  short* EngrLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_CircumventFWRulesWeight;
  short* CorpLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* HMI_GainRemoteUIAccessDeviceWeight;
  short* HMI_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short* MakeDecision_Mobius_Mark;
  double* TheDistributionParameters;

  HMI_GainLogicalAccessFailureStep();
  ~HMI_GainLogicalAccessFailureStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  double timeDistributionParameter1();
  bool preconditionsMet();
  void executeEffects();
}; // HMI_GainLogicalAccessFailureStep

class HMI_GainLogicalAccessSuccessStep : public Step {
public:

  Access* HMI_LogicalAccess;
  short* HMI_LogicalAccess_Mobius_Mark;
  Access* HMI_HasUserCredentials;
  short* HMI_HasUserCredentials_Mobius_Mark;
  Access* HMI_UIAccess;
  short* HMI_UIAccess_Mobius_Mark;
  SystemSV<float>* HMI_credentialMonitoring;
  float* HMI_credentialMonitoring_Mobius_Mark;
  Skill* BasicCyberOffense;
  short* BasicCyberOffense_Mobius_Mark;
  SystemSV<float>* cyberAttackAttribution;
  float* cyberAttackAttribution_Mobius_Mark;
  SystemSV<char>* HMI_userAuthenticationType;
  char* HMI_userAuthenticationType_Mobius_Mark;
  StepChosen* HMI_GainLogicalAccessChosen;
  short* HMI_GainLogicalAccessChosen_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainUserCredentialsWeight;
  short* CorpLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainUserCredentialsWeight;
  short* LinuxOS_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_AdminModifyFWOpenWeight;
  short* CorpLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainRemoteUIAccessOSWeight;
  short* LinuxOS_GainRemoteUIAccessOSWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLocalUIAccessOSWeight;
  short* LinuxOS_GainLocalUIAccessOSWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLogicalAccessWeight;
  short* CorpLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* HMI_GainLocalUIAccessDeviceWeight;
  short* HMI_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_CircumventFWRulesWeight;
  short* EngrLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNetworkNodeWeight;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_CircumventFWRulesWeight;
  short* CorpLanEngrLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainUserCredentialsWeight;
  short* EngrLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* DoNothingWeight;
  short* DoNothingWeight_Mobius_Mark;
  StepWeight* SSHServer_GainLogicalAccessWeight;
  short* SSHServer_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainUserCredentialsWeight;
  short* CorpLanEngrLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainLogicalAccessWeight;
  short* HMI_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainUserCredentialsWeight;
  short* EngrWorkstation_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLogicalAccessWeight;
  short* EngrWorkstation_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_AdminModifyFWOpenWeight;
  short* CorpLanEngrLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLocalUIAccessDeviceWeight;
  short* EngrWorkstation_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SSHServer_GainUserCredentialsWeight;
  short* SSHServer_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainUserCredentialsWeight;
  short* HMI_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLAN_PlaceRogueHostOnNetworkWeight;
  short* CorpLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLogicalAccessWeight;
  short* CorpLanEngrLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_PlaceRogueHostOnNetworkWeight;
  short* EngrLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_AdminModifyFWOpenWeight;
  short* EngrLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLogicalAccessWeight;
  short* LinuxOS_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* SCADALAN_PlaceRogueHostOnNetworkWeight;
  short* SCADALAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainRemoteUIAccessDeviceWeight;
  short* EngrWorkstation_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLogicalAccessWeight;
  short* EngrLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_CircumventFWRulesWeight;
  short* CorpLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* HMI_GainRemoteUIAccessDeviceWeight;
  short* HMI_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short* MakeDecision_Mobius_Mark;
  double* TheDistributionParameters;

  HMI_GainLogicalAccessSuccessStep();
  ~HMI_GainLogicalAccessSuccessStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  double timeDistributionParameter1();
  bool preconditionsMet();
  void executeEffects();
}; // HMI_GainLogicalAccessSuccessStep

class EngrWorkstation_GainUserCredentialsFailureStep : public Step {
public:

  Access* EngrWorkstation_HasUserCredentials;
  short* EngrWorkstation_HasUserCredentials_Mobius_Mark;
  Skill* BasicCyberOffense;
  short* BasicCyberOffense_Mobius_Mark;
  SystemSV<char>* EngrWorkstation_userAuthenticationType;
  char* EngrWorkstation_userAuthenticationType_Mobius_Mark;
  SystemSV<float>* EngrWorkstation_strengthOfUserAuthentication;
  float* EngrWorkstation_strengthOfUserAuthentication_Mobius_Mark;
  StepChosen* EngrWorkstation_GainUserCredentialsChosen;
  short* EngrWorkstation_GainUserCredentialsChosen_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainUserCredentialsWeight;
  short* CorpLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainUserCredentialsWeight;
  short* LinuxOS_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_AdminModifyFWOpenWeight;
  short* CorpLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainRemoteUIAccessOSWeight;
  short* LinuxOS_GainRemoteUIAccessOSWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLocalUIAccessOSWeight;
  short* LinuxOS_GainLocalUIAccessOSWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLogicalAccessWeight;
  short* CorpLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* HMI_GainLocalUIAccessDeviceWeight;
  short* HMI_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_CircumventFWRulesWeight;
  short* EngrLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNetworkNodeWeight;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_CircumventFWRulesWeight;
  short* CorpLanEngrLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainUserCredentialsWeight;
  short* EngrLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* DoNothingWeight;
  short* DoNothingWeight_Mobius_Mark;
  StepWeight* SSHServer_GainLogicalAccessWeight;
  short* SSHServer_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainUserCredentialsWeight;
  short* CorpLanEngrLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainLogicalAccessWeight;
  short* HMI_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainUserCredentialsWeight;
  short* EngrWorkstation_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLogicalAccessWeight;
  short* EngrWorkstation_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_AdminModifyFWOpenWeight;
  short* CorpLanEngrLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLocalUIAccessDeviceWeight;
  short* EngrWorkstation_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SSHServer_GainUserCredentialsWeight;
  short* SSHServer_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainUserCredentialsWeight;
  short* HMI_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLAN_PlaceRogueHostOnNetworkWeight;
  short* CorpLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLogicalAccessWeight;
  short* CorpLanEngrLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_PlaceRogueHostOnNetworkWeight;
  short* EngrLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_AdminModifyFWOpenWeight;
  short* EngrLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLogicalAccessWeight;
  short* LinuxOS_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* SCADALAN_PlaceRogueHostOnNetworkWeight;
  short* SCADALAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainRemoteUIAccessDeviceWeight;
  short* EngrWorkstation_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLogicalAccessWeight;
  short* EngrLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_CircumventFWRulesWeight;
  short* CorpLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* HMI_GainRemoteUIAccessDeviceWeight;
  short* HMI_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short* MakeDecision_Mobius_Mark;
  double* TheDistributionParameters;

  EngrWorkstation_GainUserCredentialsFailureStep();
  ~EngrWorkstation_GainUserCredentialsFailureStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  double timeDistributionParameter1();
  bool preconditionsMet();
  void executeEffects();
}; // EngrWorkstation_GainUserCredentialsFailureStep

class EngrWorkstation_GainUserCredentialsSuccessStep : public Step {
public:

  Access* EngrWorkstation_HasUserCredentials;
  short* EngrWorkstation_HasUserCredentials_Mobius_Mark;
  Skill* BasicCyberOffense;
  short* BasicCyberOffense_Mobius_Mark;
  SystemSV<char>* EngrWorkstation_userAuthenticationType;
  char* EngrWorkstation_userAuthenticationType_Mobius_Mark;
  SystemSV<float>* EngrWorkstation_strengthOfUserAuthentication;
  float* EngrWorkstation_strengthOfUserAuthentication_Mobius_Mark;
  StepChosen* EngrWorkstation_GainUserCredentialsChosen;
  short* EngrWorkstation_GainUserCredentialsChosen_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainUserCredentialsWeight;
  short* CorpLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainUserCredentialsWeight;
  short* LinuxOS_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_AdminModifyFWOpenWeight;
  short* CorpLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainRemoteUIAccessOSWeight;
  short* LinuxOS_GainRemoteUIAccessOSWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLocalUIAccessOSWeight;
  short* LinuxOS_GainLocalUIAccessOSWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLogicalAccessWeight;
  short* CorpLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* HMI_GainLocalUIAccessDeviceWeight;
  short* HMI_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_CircumventFWRulesWeight;
  short* EngrLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNetworkNodeWeight;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_CircumventFWRulesWeight;
  short* CorpLanEngrLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainUserCredentialsWeight;
  short* EngrLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* DoNothingWeight;
  short* DoNothingWeight_Mobius_Mark;
  StepWeight* SSHServer_GainLogicalAccessWeight;
  short* SSHServer_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainUserCredentialsWeight;
  short* CorpLanEngrLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainLogicalAccessWeight;
  short* HMI_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainUserCredentialsWeight;
  short* EngrWorkstation_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLogicalAccessWeight;
  short* EngrWorkstation_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_AdminModifyFWOpenWeight;
  short* CorpLanEngrLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLocalUIAccessDeviceWeight;
  short* EngrWorkstation_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SSHServer_GainUserCredentialsWeight;
  short* SSHServer_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainUserCredentialsWeight;
  short* HMI_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLAN_PlaceRogueHostOnNetworkWeight;
  short* CorpLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLogicalAccessWeight;
  short* CorpLanEngrLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_PlaceRogueHostOnNetworkWeight;
  short* EngrLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_AdminModifyFWOpenWeight;
  short* EngrLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLogicalAccessWeight;
  short* LinuxOS_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* SCADALAN_PlaceRogueHostOnNetworkWeight;
  short* SCADALAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainRemoteUIAccessDeviceWeight;
  short* EngrWorkstation_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLogicalAccessWeight;
  short* EngrLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_CircumventFWRulesWeight;
  short* CorpLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* HMI_GainRemoteUIAccessDeviceWeight;
  short* HMI_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short* MakeDecision_Mobius_Mark;
  double* TheDistributionParameters;

  EngrWorkstation_GainUserCredentialsSuccessStep();
  ~EngrWorkstation_GainUserCredentialsSuccessStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  double timeDistributionParameter1();
  bool preconditionsMet();
  void executeEffects();
}; // EngrWorkstation_GainUserCredentialsSuccessStep

class EngrLAN_GainNetworkAccessViaConnectedNetworkFailureStep : public Step {
public:

  Access* EngrLAN_NetworkAccess;
  short* EngrLAN_NetworkAccess_Mobius_Mark;
  Skill* NetworkPenetration;
  short* NetworkPenetration_Mobius_Mark;
  SystemSV<float>* EngrLAN_networkAnomalyDetectionStrength;
  float* EngrLAN_networkAnomalyDetectionStrength_Mobius_Mark;
  SystemSV<float>* cyberAttackAttribution;
  float* cyberAttackAttribution_Mobius_Mark;
  StepChosen* EngrLAN_GainNetworkAccessViaConnectedNetworkChosen;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkChosen_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainUserCredentialsWeight;
  short* CorpLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainUserCredentialsWeight;
  short* LinuxOS_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_AdminModifyFWOpenWeight;
  short* CorpLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainRemoteUIAccessOSWeight;
  short* LinuxOS_GainRemoteUIAccessOSWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLocalUIAccessOSWeight;
  short* LinuxOS_GainLocalUIAccessOSWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLogicalAccessWeight;
  short* CorpLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* HMI_GainLocalUIAccessDeviceWeight;
  short* HMI_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_CircumventFWRulesWeight;
  short* EngrLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNetworkNodeWeight;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_CircumventFWRulesWeight;
  short* CorpLanEngrLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainUserCredentialsWeight;
  short* EngrLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* DoNothingWeight;
  short* DoNothingWeight_Mobius_Mark;
  StepWeight* SSHServer_GainLogicalAccessWeight;
  short* SSHServer_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainUserCredentialsWeight;
  short* CorpLanEngrLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainLogicalAccessWeight;
  short* HMI_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainUserCredentialsWeight;
  short* EngrWorkstation_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLogicalAccessWeight;
  short* EngrWorkstation_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_AdminModifyFWOpenWeight;
  short* CorpLanEngrLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLocalUIAccessDeviceWeight;
  short* EngrWorkstation_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SSHServer_GainUserCredentialsWeight;
  short* SSHServer_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainUserCredentialsWeight;
  short* HMI_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLAN_PlaceRogueHostOnNetworkWeight;
  short* CorpLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLogicalAccessWeight;
  short* CorpLanEngrLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_PlaceRogueHostOnNetworkWeight;
  short* EngrLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_AdminModifyFWOpenWeight;
  short* EngrLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLogicalAccessWeight;
  short* LinuxOS_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* SCADALAN_PlaceRogueHostOnNetworkWeight;
  short* SCADALAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainRemoteUIAccessDeviceWeight;
  short* EngrWorkstation_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLogicalAccessWeight;
  short* EngrLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_CircumventFWRulesWeight;
  short* CorpLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* HMI_GainRemoteUIAccessDeviceWeight;
  short* HMI_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short* MakeDecision_Mobius_Mark;
  double* TheDistributionParameters;

  EngrLAN_GainNetworkAccessViaConnectedNetworkFailureStep();
  ~EngrLAN_GainNetworkAccessViaConnectedNetworkFailureStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  double timeDistributionParameter1();
  bool preconditionsMet();
  void executeEffects();
}; // EngrLAN_GainNetworkAccessViaConnectedNetworkFailureStep

class EngrLAN_GainNetworkAccessViaConnectedNetworkSuccessStep : public Step {
public:

  Access* EngrLAN_NetworkAccess;
  short* EngrLAN_NetworkAccess_Mobius_Mark;
  Skill* NetworkPenetration;
  short* NetworkPenetration_Mobius_Mark;
  SystemSV<float>* EngrLAN_networkAnomalyDetectionStrength;
  float* EngrLAN_networkAnomalyDetectionStrength_Mobius_Mark;
  SystemSV<float>* cyberAttackAttribution;
  float* cyberAttackAttribution_Mobius_Mark;
  StepChosen* EngrLAN_GainNetworkAccessViaConnectedNetworkChosen;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkChosen_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainUserCredentialsWeight;
  short* CorpLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainUserCredentialsWeight;
  short* LinuxOS_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_AdminModifyFWOpenWeight;
  short* CorpLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainRemoteUIAccessOSWeight;
  short* LinuxOS_GainRemoteUIAccessOSWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLocalUIAccessOSWeight;
  short* LinuxOS_GainLocalUIAccessOSWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLogicalAccessWeight;
  short* CorpLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* HMI_GainLocalUIAccessDeviceWeight;
  short* HMI_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_CircumventFWRulesWeight;
  short* EngrLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNetworkNodeWeight;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_CircumventFWRulesWeight;
  short* CorpLanEngrLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainUserCredentialsWeight;
  short* EngrLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* DoNothingWeight;
  short* DoNothingWeight_Mobius_Mark;
  StepWeight* SSHServer_GainLogicalAccessWeight;
  short* SSHServer_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainUserCredentialsWeight;
  short* CorpLanEngrLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainLogicalAccessWeight;
  short* HMI_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainUserCredentialsWeight;
  short* EngrWorkstation_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLogicalAccessWeight;
  short* EngrWorkstation_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_AdminModifyFWOpenWeight;
  short* CorpLanEngrLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLocalUIAccessDeviceWeight;
  short* EngrWorkstation_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SSHServer_GainUserCredentialsWeight;
  short* SSHServer_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainUserCredentialsWeight;
  short* HMI_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLAN_PlaceRogueHostOnNetworkWeight;
  short* CorpLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLogicalAccessWeight;
  short* CorpLanEngrLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_PlaceRogueHostOnNetworkWeight;
  short* EngrLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_AdminModifyFWOpenWeight;
  short* EngrLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLogicalAccessWeight;
  short* LinuxOS_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* SCADALAN_PlaceRogueHostOnNetworkWeight;
  short* SCADALAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainRemoteUIAccessDeviceWeight;
  short* EngrWorkstation_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLogicalAccessWeight;
  short* EngrLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_CircumventFWRulesWeight;
  short* CorpLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* HMI_GainRemoteUIAccessDeviceWeight;
  short* HMI_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short* MakeDecision_Mobius_Mark;
  double* TheDistributionParameters;

  EngrLAN_GainNetworkAccessViaConnectedNetworkSuccessStep();
  ~EngrLAN_GainNetworkAccessViaConnectedNetworkSuccessStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  double timeDistributionParameter1();
  bool preconditionsMet();
  void executeEffects();
}; // EngrLAN_GainNetworkAccessViaConnectedNetworkSuccessStep

class EngrWorkstation_GainLogicalAccessFailureStep : public Step {
public:

  Access* EngrWorkstation_LogicalAccess;
  short* EngrWorkstation_LogicalAccess_Mobius_Mark;
  Access* EngrWorkstation_HasUserCredentials;
  short* EngrWorkstation_HasUserCredentials_Mobius_Mark;
  Access* EngrWorkstation_UIAccess;
  short* EngrWorkstation_UIAccess_Mobius_Mark;
  SystemSV<float>* EngrWorkstation_credentialMonitoring;
  float* EngrWorkstation_credentialMonitoring_Mobius_Mark;
  Skill* BasicCyberOffense;
  short* BasicCyberOffense_Mobius_Mark;
  SystemSV<float>* cyberAttackAttribution;
  float* cyberAttackAttribution_Mobius_Mark;
  SystemSV<char>* EngrWorkstation_userAuthenticationType;
  char* EngrWorkstation_userAuthenticationType_Mobius_Mark;
  StepChosen* EngrWorkstation_GainLogicalAccessChosen;
  short* EngrWorkstation_GainLogicalAccessChosen_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainUserCredentialsWeight;
  short* CorpLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainUserCredentialsWeight;
  short* LinuxOS_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_AdminModifyFWOpenWeight;
  short* CorpLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainRemoteUIAccessOSWeight;
  short* LinuxOS_GainRemoteUIAccessOSWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLocalUIAccessOSWeight;
  short* LinuxOS_GainLocalUIAccessOSWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLogicalAccessWeight;
  short* CorpLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* HMI_GainLocalUIAccessDeviceWeight;
  short* HMI_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_CircumventFWRulesWeight;
  short* EngrLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNetworkNodeWeight;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_CircumventFWRulesWeight;
  short* CorpLanEngrLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainUserCredentialsWeight;
  short* EngrLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* DoNothingWeight;
  short* DoNothingWeight_Mobius_Mark;
  StepWeight* SSHServer_GainLogicalAccessWeight;
  short* SSHServer_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainUserCredentialsWeight;
  short* CorpLanEngrLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainLogicalAccessWeight;
  short* HMI_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainUserCredentialsWeight;
  short* EngrWorkstation_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLogicalAccessWeight;
  short* EngrWorkstation_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_AdminModifyFWOpenWeight;
  short* CorpLanEngrLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLocalUIAccessDeviceWeight;
  short* EngrWorkstation_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SSHServer_GainUserCredentialsWeight;
  short* SSHServer_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainUserCredentialsWeight;
  short* HMI_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLAN_PlaceRogueHostOnNetworkWeight;
  short* CorpLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLogicalAccessWeight;
  short* CorpLanEngrLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_PlaceRogueHostOnNetworkWeight;
  short* EngrLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_AdminModifyFWOpenWeight;
  short* EngrLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLogicalAccessWeight;
  short* LinuxOS_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* SCADALAN_PlaceRogueHostOnNetworkWeight;
  short* SCADALAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainRemoteUIAccessDeviceWeight;
  short* EngrWorkstation_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLogicalAccessWeight;
  short* EngrLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_CircumventFWRulesWeight;
  short* CorpLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* HMI_GainRemoteUIAccessDeviceWeight;
  short* HMI_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short* MakeDecision_Mobius_Mark;
  double* TheDistributionParameters;

  EngrWorkstation_GainLogicalAccessFailureStep();
  ~EngrWorkstation_GainLogicalAccessFailureStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  double timeDistributionParameter1();
  bool preconditionsMet();
  void executeEffects();
}; // EngrWorkstation_GainLogicalAccessFailureStep

class EngrWorkstation_GainLogicalAccessSuccessStep : public Step {
public:

  Access* EngrWorkstation_LogicalAccess;
  short* EngrWorkstation_LogicalAccess_Mobius_Mark;
  Access* EngrWorkstation_HasUserCredentials;
  short* EngrWorkstation_HasUserCredentials_Mobius_Mark;
  Access* EngrWorkstation_UIAccess;
  short* EngrWorkstation_UIAccess_Mobius_Mark;
  SystemSV<float>* EngrWorkstation_credentialMonitoring;
  float* EngrWorkstation_credentialMonitoring_Mobius_Mark;
  Skill* BasicCyberOffense;
  short* BasicCyberOffense_Mobius_Mark;
  SystemSV<float>* cyberAttackAttribution;
  float* cyberAttackAttribution_Mobius_Mark;
  SystemSV<char>* EngrWorkstation_userAuthenticationType;
  char* EngrWorkstation_userAuthenticationType_Mobius_Mark;
  StepChosen* EngrWorkstation_GainLogicalAccessChosen;
  short* EngrWorkstation_GainLogicalAccessChosen_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainUserCredentialsWeight;
  short* CorpLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainUserCredentialsWeight;
  short* LinuxOS_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_AdminModifyFWOpenWeight;
  short* CorpLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainRemoteUIAccessOSWeight;
  short* LinuxOS_GainRemoteUIAccessOSWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLocalUIAccessOSWeight;
  short* LinuxOS_GainLocalUIAccessOSWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLogicalAccessWeight;
  short* CorpLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* HMI_GainLocalUIAccessDeviceWeight;
  short* HMI_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_CircumventFWRulesWeight;
  short* EngrLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNetworkNodeWeight;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_CircumventFWRulesWeight;
  short* CorpLanEngrLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainUserCredentialsWeight;
  short* EngrLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* DoNothingWeight;
  short* DoNothingWeight_Mobius_Mark;
  StepWeight* SSHServer_GainLogicalAccessWeight;
  short* SSHServer_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainUserCredentialsWeight;
  short* CorpLanEngrLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainLogicalAccessWeight;
  short* HMI_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainUserCredentialsWeight;
  short* EngrWorkstation_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLogicalAccessWeight;
  short* EngrWorkstation_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_AdminModifyFWOpenWeight;
  short* CorpLanEngrLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLocalUIAccessDeviceWeight;
  short* EngrWorkstation_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SSHServer_GainUserCredentialsWeight;
  short* SSHServer_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainUserCredentialsWeight;
  short* HMI_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLAN_PlaceRogueHostOnNetworkWeight;
  short* CorpLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLogicalAccessWeight;
  short* CorpLanEngrLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_PlaceRogueHostOnNetworkWeight;
  short* EngrLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_AdminModifyFWOpenWeight;
  short* EngrLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLogicalAccessWeight;
  short* LinuxOS_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* SCADALAN_PlaceRogueHostOnNetworkWeight;
  short* SCADALAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainRemoteUIAccessDeviceWeight;
  short* EngrWorkstation_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLogicalAccessWeight;
  short* EngrLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_CircumventFWRulesWeight;
  short* CorpLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* HMI_GainRemoteUIAccessDeviceWeight;
  short* HMI_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short* MakeDecision_Mobius_Mark;
  double* TheDistributionParameters;

  EngrWorkstation_GainLogicalAccessSuccessStep();
  ~EngrWorkstation_GainLogicalAccessSuccessStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  double timeDistributionParameter1();
  bool preconditionsMet();
  void executeEffects();
}; // EngrWorkstation_GainLogicalAccessSuccessStep

class CorpLanEngrLanFW_AdminModifyFWOpenFailureStep : public Step {
public:

  Access* CorpLAN_NetworkAccess;
  short* CorpLAN_NetworkAccess_Mobius_Mark;
  Access* EngrLAN_NetworkAccess;
  short* EngrLAN_NetworkAccess_Mobius_Mark;
  Access* CorpLanEngrLanFW_LogicalAccess;
  short* CorpLanEngrLanFW_LogicalAccess_Mobius_Mark;
  Skill* NetworkPenetration;
  short* NetworkPenetration_Mobius_Mark;
  SystemSV<float>* cyberAttackAttribution;
  float* cyberAttackAttribution_Mobius_Mark;
  SystemSV<float>* CorpLanEngrLanFW_firewallConfigControl;
  float* CorpLanEngrLanFW_firewallConfigControl_Mobius_Mark;
  SystemSV<float>* CorpLanEngrLanFW_firewallConfigDetection;
  float* CorpLanEngrLanFW_firewallConfigDetection_Mobius_Mark;
  Knowledge* CorpLanEngrLanFW_FirewallConfigKnowledge;
  short* CorpLanEngrLanFW_FirewallConfigKnowledge_Mobius_Mark;
  Skill* CorpLanEngrLanFW_SpecializedTechnicalExpertise;
  short* CorpLanEngrLanFW_SpecializedTechnicalExpertise_Mobius_Mark;
  StepChosen* CorpLanEngrLanFW_AdminModifyFWOpenChosen;
  short* CorpLanEngrLanFW_AdminModifyFWOpenChosen_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainUserCredentialsWeight;
  short* CorpLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainUserCredentialsWeight;
  short* LinuxOS_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_AdminModifyFWOpenWeight;
  short* CorpLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainRemoteUIAccessOSWeight;
  short* LinuxOS_GainRemoteUIAccessOSWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLocalUIAccessOSWeight;
  short* LinuxOS_GainLocalUIAccessOSWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLogicalAccessWeight;
  short* CorpLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* HMI_GainLocalUIAccessDeviceWeight;
  short* HMI_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_CircumventFWRulesWeight;
  short* EngrLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNetworkNodeWeight;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_CircumventFWRulesWeight;
  short* CorpLanEngrLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainUserCredentialsWeight;
  short* EngrLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* DoNothingWeight;
  short* DoNothingWeight_Mobius_Mark;
  StepWeight* SSHServer_GainLogicalAccessWeight;
  short* SSHServer_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainUserCredentialsWeight;
  short* CorpLanEngrLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainLogicalAccessWeight;
  short* HMI_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainUserCredentialsWeight;
  short* EngrWorkstation_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLogicalAccessWeight;
  short* EngrWorkstation_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_AdminModifyFWOpenWeight;
  short* CorpLanEngrLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLocalUIAccessDeviceWeight;
  short* EngrWorkstation_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SSHServer_GainUserCredentialsWeight;
  short* SSHServer_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainUserCredentialsWeight;
  short* HMI_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLAN_PlaceRogueHostOnNetworkWeight;
  short* CorpLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLogicalAccessWeight;
  short* CorpLanEngrLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_PlaceRogueHostOnNetworkWeight;
  short* EngrLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_AdminModifyFWOpenWeight;
  short* EngrLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLogicalAccessWeight;
  short* LinuxOS_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* SCADALAN_PlaceRogueHostOnNetworkWeight;
  short* SCADALAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainRemoteUIAccessDeviceWeight;
  short* EngrWorkstation_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLogicalAccessWeight;
  short* EngrLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_CircumventFWRulesWeight;
  short* CorpLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* HMI_GainRemoteUIAccessDeviceWeight;
  short* HMI_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short* MakeDecision_Mobius_Mark;
  double* TheDistributionParameters;

  CorpLanEngrLanFW_AdminModifyFWOpenFailureStep();
  ~CorpLanEngrLanFW_AdminModifyFWOpenFailureStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  bool preconditionsMet();
  void executeEffects();
}; // CorpLanEngrLanFW_AdminModifyFWOpenFailureStep

class CorpLanEngrLanFW_AdminModifyFWOpenSuccessStep : public Step {
public:

  Access* CorpLAN_NetworkAccess;
  short* CorpLAN_NetworkAccess_Mobius_Mark;
  Access* EngrLAN_NetworkAccess;
  short* EngrLAN_NetworkAccess_Mobius_Mark;
  Access* CorpLanEngrLanFW_LogicalAccess;
  short* CorpLanEngrLanFW_LogicalAccess_Mobius_Mark;
  Skill* NetworkPenetration;
  short* NetworkPenetration_Mobius_Mark;
  SystemSV<float>* cyberAttackAttribution;
  float* cyberAttackAttribution_Mobius_Mark;
  SystemSV<float>* CorpLanEngrLanFW_firewallConfigControl;
  float* CorpLanEngrLanFW_firewallConfigControl_Mobius_Mark;
  SystemSV<float>* CorpLanEngrLanFW_firewallConfigDetection;
  float* CorpLanEngrLanFW_firewallConfigDetection_Mobius_Mark;
  Knowledge* CorpLanEngrLanFW_FirewallConfigKnowledge;
  short* CorpLanEngrLanFW_FirewallConfigKnowledge_Mobius_Mark;
  Skill* CorpLanEngrLanFW_SpecializedTechnicalExpertise;
  short* CorpLanEngrLanFW_SpecializedTechnicalExpertise_Mobius_Mark;
  StepChosen* CorpLanEngrLanFW_AdminModifyFWOpenChosen;
  short* CorpLanEngrLanFW_AdminModifyFWOpenChosen_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainUserCredentialsWeight;
  short* CorpLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainUserCredentialsWeight;
  short* LinuxOS_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_AdminModifyFWOpenWeight;
  short* CorpLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainRemoteUIAccessOSWeight;
  short* LinuxOS_GainRemoteUIAccessOSWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLocalUIAccessOSWeight;
  short* LinuxOS_GainLocalUIAccessOSWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLogicalAccessWeight;
  short* CorpLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* HMI_GainLocalUIAccessDeviceWeight;
  short* HMI_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_CircumventFWRulesWeight;
  short* EngrLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNetworkNodeWeight;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_CircumventFWRulesWeight;
  short* CorpLanEngrLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainUserCredentialsWeight;
  short* EngrLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* DoNothingWeight;
  short* DoNothingWeight_Mobius_Mark;
  StepWeight* SSHServer_GainLogicalAccessWeight;
  short* SSHServer_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainUserCredentialsWeight;
  short* CorpLanEngrLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainLogicalAccessWeight;
  short* HMI_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainUserCredentialsWeight;
  short* EngrWorkstation_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLogicalAccessWeight;
  short* EngrWorkstation_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_AdminModifyFWOpenWeight;
  short* CorpLanEngrLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLocalUIAccessDeviceWeight;
  short* EngrWorkstation_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SSHServer_GainUserCredentialsWeight;
  short* SSHServer_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainUserCredentialsWeight;
  short* HMI_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLAN_PlaceRogueHostOnNetworkWeight;
  short* CorpLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLogicalAccessWeight;
  short* CorpLanEngrLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_PlaceRogueHostOnNetworkWeight;
  short* EngrLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_AdminModifyFWOpenWeight;
  short* EngrLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLogicalAccessWeight;
  short* LinuxOS_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* SCADALAN_PlaceRogueHostOnNetworkWeight;
  short* SCADALAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainRemoteUIAccessDeviceWeight;
  short* EngrWorkstation_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLogicalAccessWeight;
  short* EngrLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_CircumventFWRulesWeight;
  short* CorpLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* HMI_GainRemoteUIAccessDeviceWeight;
  short* HMI_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short* MakeDecision_Mobius_Mark;
  double* TheDistributionParameters;

  CorpLanEngrLanFW_AdminModifyFWOpenSuccessStep();
  ~CorpLanEngrLanFW_AdminModifyFWOpenSuccessStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  bool preconditionsMet();
  void executeEffects();
}; // CorpLanEngrLanFW_AdminModifyFWOpenSuccessStep

class EngrWorkstation_GainLocalUIAccessDeviceFailureStep : public Step {
public:

  Access* EngrWorkstation_UIAccess;
  short* EngrWorkstation_UIAccess_Mobius_Mark;
  Access* EngrWorkstation_LogicalAccess;
  short* EngrWorkstation_LogicalAccess_Mobius_Mark;
  Access* EngrWorkstation_PhysicalAccess;
  short* EngrWorkstation_PhysicalAccess_Mobius_Mark;
  SystemSV<char>* EngrWorkstation_userAuthenticationType;
  char* EngrWorkstation_userAuthenticationType_Mobius_Mark;
  Skill* KineticEquipmentAttack;
  short* KineticEquipmentAttack_Mobius_Mark;
  SystemSV<float>* EngrWorkstation_physicalAttackAttribution;
  float* EngrWorkstation_physicalAttackAttribution_Mobius_Mark;
  StepChosen* EngrWorkstation_GainLocalUIAccessDeviceChosen;
  short* EngrWorkstation_GainLocalUIAccessDeviceChosen_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainUserCredentialsWeight;
  short* CorpLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainUserCredentialsWeight;
  short* LinuxOS_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_AdminModifyFWOpenWeight;
  short* CorpLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainRemoteUIAccessOSWeight;
  short* LinuxOS_GainRemoteUIAccessOSWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLocalUIAccessOSWeight;
  short* LinuxOS_GainLocalUIAccessOSWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLogicalAccessWeight;
  short* CorpLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* HMI_GainLocalUIAccessDeviceWeight;
  short* HMI_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_CircumventFWRulesWeight;
  short* EngrLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNetworkNodeWeight;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_CircumventFWRulesWeight;
  short* CorpLanEngrLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainUserCredentialsWeight;
  short* EngrLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* DoNothingWeight;
  short* DoNothingWeight_Mobius_Mark;
  StepWeight* SSHServer_GainLogicalAccessWeight;
  short* SSHServer_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainUserCredentialsWeight;
  short* CorpLanEngrLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainLogicalAccessWeight;
  short* HMI_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainUserCredentialsWeight;
  short* EngrWorkstation_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLogicalAccessWeight;
  short* EngrWorkstation_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_AdminModifyFWOpenWeight;
  short* CorpLanEngrLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLocalUIAccessDeviceWeight;
  short* EngrWorkstation_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SSHServer_GainUserCredentialsWeight;
  short* SSHServer_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainUserCredentialsWeight;
  short* HMI_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLAN_PlaceRogueHostOnNetworkWeight;
  short* CorpLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLogicalAccessWeight;
  short* CorpLanEngrLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_PlaceRogueHostOnNetworkWeight;
  short* EngrLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_AdminModifyFWOpenWeight;
  short* EngrLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLogicalAccessWeight;
  short* LinuxOS_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* SCADALAN_PlaceRogueHostOnNetworkWeight;
  short* SCADALAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainRemoteUIAccessDeviceWeight;
  short* EngrWorkstation_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLogicalAccessWeight;
  short* EngrLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_CircumventFWRulesWeight;
  short* CorpLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* HMI_GainRemoteUIAccessDeviceWeight;
  short* HMI_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short* MakeDecision_Mobius_Mark;
  double* TheDistributionParameters;

  EngrWorkstation_GainLocalUIAccessDeviceFailureStep();
  ~EngrWorkstation_GainLocalUIAccessDeviceFailureStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  double timeDistributionParameter1();
  bool preconditionsMet();
  void executeEffects();
}; // EngrWorkstation_GainLocalUIAccessDeviceFailureStep

class EngrWorkstation_GainLocalUIAccessDeviceSuccessStep : public Step {
public:

  Access* EngrWorkstation_UIAccess;
  short* EngrWorkstation_UIAccess_Mobius_Mark;
  Access* EngrWorkstation_LogicalAccess;
  short* EngrWorkstation_LogicalAccess_Mobius_Mark;
  Access* EngrWorkstation_PhysicalAccess;
  short* EngrWorkstation_PhysicalAccess_Mobius_Mark;
  SystemSV<char>* EngrWorkstation_userAuthenticationType;
  char* EngrWorkstation_userAuthenticationType_Mobius_Mark;
  Skill* KineticEquipmentAttack;
  short* KineticEquipmentAttack_Mobius_Mark;
  SystemSV<float>* EngrWorkstation_physicalAttackAttribution;
  float* EngrWorkstation_physicalAttackAttribution_Mobius_Mark;
  StepChosen* EngrWorkstation_GainLocalUIAccessDeviceChosen;
  short* EngrWorkstation_GainLocalUIAccessDeviceChosen_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainUserCredentialsWeight;
  short* CorpLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainUserCredentialsWeight;
  short* LinuxOS_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_AdminModifyFWOpenWeight;
  short* CorpLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainRemoteUIAccessOSWeight;
  short* LinuxOS_GainRemoteUIAccessOSWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLocalUIAccessOSWeight;
  short* LinuxOS_GainLocalUIAccessOSWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLogicalAccessWeight;
  short* CorpLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* HMI_GainLocalUIAccessDeviceWeight;
  short* HMI_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_CircumventFWRulesWeight;
  short* EngrLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNetworkNodeWeight;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_CircumventFWRulesWeight;
  short* CorpLanEngrLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainUserCredentialsWeight;
  short* EngrLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* DoNothingWeight;
  short* DoNothingWeight_Mobius_Mark;
  StepWeight* SSHServer_GainLogicalAccessWeight;
  short* SSHServer_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainUserCredentialsWeight;
  short* CorpLanEngrLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainLogicalAccessWeight;
  short* HMI_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainUserCredentialsWeight;
  short* EngrWorkstation_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLogicalAccessWeight;
  short* EngrWorkstation_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_AdminModifyFWOpenWeight;
  short* CorpLanEngrLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLocalUIAccessDeviceWeight;
  short* EngrWorkstation_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SSHServer_GainUserCredentialsWeight;
  short* SSHServer_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainUserCredentialsWeight;
  short* HMI_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLAN_PlaceRogueHostOnNetworkWeight;
  short* CorpLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLogicalAccessWeight;
  short* CorpLanEngrLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_PlaceRogueHostOnNetworkWeight;
  short* EngrLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_AdminModifyFWOpenWeight;
  short* EngrLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLogicalAccessWeight;
  short* LinuxOS_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* SCADALAN_PlaceRogueHostOnNetworkWeight;
  short* SCADALAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainRemoteUIAccessDeviceWeight;
  short* EngrWorkstation_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLogicalAccessWeight;
  short* EngrLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_CircumventFWRulesWeight;
  short* CorpLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* HMI_GainRemoteUIAccessDeviceWeight;
  short* HMI_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short* MakeDecision_Mobius_Mark;
  double* TheDistributionParameters;

  EngrWorkstation_GainLocalUIAccessDeviceSuccessStep();
  ~EngrWorkstation_GainLocalUIAccessDeviceSuccessStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  double timeDistributionParameter1();
  bool preconditionsMet();
  void executeEffects();
}; // EngrWorkstation_GainLocalUIAccessDeviceSuccessStep

class SSHServer_GainUserCredentialsFailureStep : public Step {
public:

  Access* SSHServer_HasUserCredentials;
  short* SSHServer_HasUserCredentials_Mobius_Mark;
  Skill* BasicCyberOffense;
  short* BasicCyberOffense_Mobius_Mark;
  SystemSV<char>* SSHServer_userAuthenticationType;
  char* SSHServer_userAuthenticationType_Mobius_Mark;
  SystemSV<float>* SSHServer_strengthOfUserAuthentication;
  float* SSHServer_strengthOfUserAuthentication_Mobius_Mark;
  StepChosen* SSHServer_GainUserCredentialsChosen;
  short* SSHServer_GainUserCredentialsChosen_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainUserCredentialsWeight;
  short* CorpLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainUserCredentialsWeight;
  short* LinuxOS_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_AdminModifyFWOpenWeight;
  short* CorpLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainRemoteUIAccessOSWeight;
  short* LinuxOS_GainRemoteUIAccessOSWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLocalUIAccessOSWeight;
  short* LinuxOS_GainLocalUIAccessOSWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLogicalAccessWeight;
  short* CorpLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* HMI_GainLocalUIAccessDeviceWeight;
  short* HMI_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_CircumventFWRulesWeight;
  short* EngrLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNetworkNodeWeight;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_CircumventFWRulesWeight;
  short* CorpLanEngrLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainUserCredentialsWeight;
  short* EngrLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* DoNothingWeight;
  short* DoNothingWeight_Mobius_Mark;
  StepWeight* SSHServer_GainLogicalAccessWeight;
  short* SSHServer_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainUserCredentialsWeight;
  short* CorpLanEngrLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainLogicalAccessWeight;
  short* HMI_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainUserCredentialsWeight;
  short* EngrWorkstation_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLogicalAccessWeight;
  short* EngrWorkstation_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_AdminModifyFWOpenWeight;
  short* CorpLanEngrLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLocalUIAccessDeviceWeight;
  short* EngrWorkstation_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SSHServer_GainUserCredentialsWeight;
  short* SSHServer_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainUserCredentialsWeight;
  short* HMI_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLAN_PlaceRogueHostOnNetworkWeight;
  short* CorpLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLogicalAccessWeight;
  short* CorpLanEngrLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_PlaceRogueHostOnNetworkWeight;
  short* EngrLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_AdminModifyFWOpenWeight;
  short* EngrLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLogicalAccessWeight;
  short* LinuxOS_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* SCADALAN_PlaceRogueHostOnNetworkWeight;
  short* SCADALAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainRemoteUIAccessDeviceWeight;
  short* EngrWorkstation_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLogicalAccessWeight;
  short* EngrLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_CircumventFWRulesWeight;
  short* CorpLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* HMI_GainRemoteUIAccessDeviceWeight;
  short* HMI_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short* MakeDecision_Mobius_Mark;
  double* TheDistributionParameters;

  SSHServer_GainUserCredentialsFailureStep();
  ~SSHServer_GainUserCredentialsFailureStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  double timeDistributionParameter1();
  bool preconditionsMet();
  void executeEffects();
}; // SSHServer_GainUserCredentialsFailureStep

class SSHServer_GainUserCredentialsSuccessStep : public Step {
public:

  Access* SSHServer_HasUserCredentials;
  short* SSHServer_HasUserCredentials_Mobius_Mark;
  Skill* BasicCyberOffense;
  short* BasicCyberOffense_Mobius_Mark;
  SystemSV<char>* SSHServer_userAuthenticationType;
  char* SSHServer_userAuthenticationType_Mobius_Mark;
  SystemSV<float>* SSHServer_strengthOfUserAuthentication;
  float* SSHServer_strengthOfUserAuthentication_Mobius_Mark;
  StepChosen* SSHServer_GainUserCredentialsChosen;
  short* SSHServer_GainUserCredentialsChosen_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainUserCredentialsWeight;
  short* CorpLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainUserCredentialsWeight;
  short* LinuxOS_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_AdminModifyFWOpenWeight;
  short* CorpLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainRemoteUIAccessOSWeight;
  short* LinuxOS_GainRemoteUIAccessOSWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLocalUIAccessOSWeight;
  short* LinuxOS_GainLocalUIAccessOSWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLogicalAccessWeight;
  short* CorpLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* HMI_GainLocalUIAccessDeviceWeight;
  short* HMI_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_CircumventFWRulesWeight;
  short* EngrLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNetworkNodeWeight;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_CircumventFWRulesWeight;
  short* CorpLanEngrLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainUserCredentialsWeight;
  short* EngrLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* DoNothingWeight;
  short* DoNothingWeight_Mobius_Mark;
  StepWeight* SSHServer_GainLogicalAccessWeight;
  short* SSHServer_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainUserCredentialsWeight;
  short* CorpLanEngrLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainLogicalAccessWeight;
  short* HMI_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainUserCredentialsWeight;
  short* EngrWorkstation_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLogicalAccessWeight;
  short* EngrWorkstation_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_AdminModifyFWOpenWeight;
  short* CorpLanEngrLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLocalUIAccessDeviceWeight;
  short* EngrWorkstation_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SSHServer_GainUserCredentialsWeight;
  short* SSHServer_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainUserCredentialsWeight;
  short* HMI_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLAN_PlaceRogueHostOnNetworkWeight;
  short* CorpLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLogicalAccessWeight;
  short* CorpLanEngrLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_PlaceRogueHostOnNetworkWeight;
  short* EngrLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_AdminModifyFWOpenWeight;
  short* EngrLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLogicalAccessWeight;
  short* LinuxOS_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* SCADALAN_PlaceRogueHostOnNetworkWeight;
  short* SCADALAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainRemoteUIAccessDeviceWeight;
  short* EngrWorkstation_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLogicalAccessWeight;
  short* EngrLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_CircumventFWRulesWeight;
  short* CorpLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* HMI_GainRemoteUIAccessDeviceWeight;
  short* HMI_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short* MakeDecision_Mobius_Mark;
  double* TheDistributionParameters;

  SSHServer_GainUserCredentialsSuccessStep();
  ~SSHServer_GainUserCredentialsSuccessStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  double timeDistributionParameter1();
  bool preconditionsMet();
  void executeEffects();
}; // SSHServer_GainUserCredentialsSuccessStep

class HMI_GainUserCredentialsFailureStep : public Step {
public:

  Access* HMI_HasUserCredentials;
  short* HMI_HasUserCredentials_Mobius_Mark;
  Skill* BasicCyberOffense;
  short* BasicCyberOffense_Mobius_Mark;
  SystemSV<char>* HMI_userAuthenticationType;
  char* HMI_userAuthenticationType_Mobius_Mark;
  SystemSV<float>* HMI_strengthOfUserAuthentication;
  float* HMI_strengthOfUserAuthentication_Mobius_Mark;
  StepChosen* HMI_GainUserCredentialsChosen;
  short* HMI_GainUserCredentialsChosen_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainUserCredentialsWeight;
  short* CorpLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainUserCredentialsWeight;
  short* LinuxOS_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_AdminModifyFWOpenWeight;
  short* CorpLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainRemoteUIAccessOSWeight;
  short* LinuxOS_GainRemoteUIAccessOSWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLocalUIAccessOSWeight;
  short* LinuxOS_GainLocalUIAccessOSWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLogicalAccessWeight;
  short* CorpLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* HMI_GainLocalUIAccessDeviceWeight;
  short* HMI_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_CircumventFWRulesWeight;
  short* EngrLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNetworkNodeWeight;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_CircumventFWRulesWeight;
  short* CorpLanEngrLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainUserCredentialsWeight;
  short* EngrLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* DoNothingWeight;
  short* DoNothingWeight_Mobius_Mark;
  StepWeight* SSHServer_GainLogicalAccessWeight;
  short* SSHServer_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainUserCredentialsWeight;
  short* CorpLanEngrLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainLogicalAccessWeight;
  short* HMI_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainUserCredentialsWeight;
  short* EngrWorkstation_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLogicalAccessWeight;
  short* EngrWorkstation_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_AdminModifyFWOpenWeight;
  short* CorpLanEngrLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLocalUIAccessDeviceWeight;
  short* EngrWorkstation_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SSHServer_GainUserCredentialsWeight;
  short* SSHServer_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainUserCredentialsWeight;
  short* HMI_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLAN_PlaceRogueHostOnNetworkWeight;
  short* CorpLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLogicalAccessWeight;
  short* CorpLanEngrLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_PlaceRogueHostOnNetworkWeight;
  short* EngrLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_AdminModifyFWOpenWeight;
  short* EngrLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLogicalAccessWeight;
  short* LinuxOS_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* SCADALAN_PlaceRogueHostOnNetworkWeight;
  short* SCADALAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainRemoteUIAccessDeviceWeight;
  short* EngrWorkstation_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLogicalAccessWeight;
  short* EngrLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_CircumventFWRulesWeight;
  short* CorpLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* HMI_GainRemoteUIAccessDeviceWeight;
  short* HMI_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short* MakeDecision_Mobius_Mark;
  double* TheDistributionParameters;

  HMI_GainUserCredentialsFailureStep();
  ~HMI_GainUserCredentialsFailureStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  double timeDistributionParameter1();
  bool preconditionsMet();
  void executeEffects();
}; // HMI_GainUserCredentialsFailureStep

class HMI_GainUserCredentialsSuccessStep : public Step {
public:

  Access* HMI_HasUserCredentials;
  short* HMI_HasUserCredentials_Mobius_Mark;
  Skill* BasicCyberOffense;
  short* BasicCyberOffense_Mobius_Mark;
  SystemSV<char>* HMI_userAuthenticationType;
  char* HMI_userAuthenticationType_Mobius_Mark;
  SystemSV<float>* HMI_strengthOfUserAuthentication;
  float* HMI_strengthOfUserAuthentication_Mobius_Mark;
  StepChosen* HMI_GainUserCredentialsChosen;
  short* HMI_GainUserCredentialsChosen_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainUserCredentialsWeight;
  short* CorpLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainUserCredentialsWeight;
  short* LinuxOS_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_AdminModifyFWOpenWeight;
  short* CorpLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainRemoteUIAccessOSWeight;
  short* LinuxOS_GainRemoteUIAccessOSWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLocalUIAccessOSWeight;
  short* LinuxOS_GainLocalUIAccessOSWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLogicalAccessWeight;
  short* CorpLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* HMI_GainLocalUIAccessDeviceWeight;
  short* HMI_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_CircumventFWRulesWeight;
  short* EngrLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNetworkNodeWeight;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_CircumventFWRulesWeight;
  short* CorpLanEngrLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainUserCredentialsWeight;
  short* EngrLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* DoNothingWeight;
  short* DoNothingWeight_Mobius_Mark;
  StepWeight* SSHServer_GainLogicalAccessWeight;
  short* SSHServer_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainUserCredentialsWeight;
  short* CorpLanEngrLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainLogicalAccessWeight;
  short* HMI_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainUserCredentialsWeight;
  short* EngrWorkstation_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLogicalAccessWeight;
  short* EngrWorkstation_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_AdminModifyFWOpenWeight;
  short* CorpLanEngrLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLocalUIAccessDeviceWeight;
  short* EngrWorkstation_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SSHServer_GainUserCredentialsWeight;
  short* SSHServer_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainUserCredentialsWeight;
  short* HMI_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLAN_PlaceRogueHostOnNetworkWeight;
  short* CorpLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLogicalAccessWeight;
  short* CorpLanEngrLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_PlaceRogueHostOnNetworkWeight;
  short* EngrLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_AdminModifyFWOpenWeight;
  short* EngrLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLogicalAccessWeight;
  short* LinuxOS_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* SCADALAN_PlaceRogueHostOnNetworkWeight;
  short* SCADALAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainRemoteUIAccessDeviceWeight;
  short* EngrWorkstation_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLogicalAccessWeight;
  short* EngrLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_CircumventFWRulesWeight;
  short* CorpLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* HMI_GainRemoteUIAccessDeviceWeight;
  short* HMI_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short* MakeDecision_Mobius_Mark;
  double* TheDistributionParameters;

  HMI_GainUserCredentialsSuccessStep();
  ~HMI_GainUserCredentialsSuccessStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  double timeDistributionParameter1();
  bool preconditionsMet();
  void executeEffects();
}; // HMI_GainUserCredentialsSuccessStep

class CorpLAN_PlaceRogueHostOnNetworkFailureStep : public Step {
public:

  Access* CorpLAN_NetworkAccess;
  short* CorpLAN_NetworkAccess_Mobius_Mark;
  Access* CorpLAN_PhysicalAccess;
  short* CorpLAN_PhysicalAccess_Mobius_Mark;
  SystemSV<float>* hourlyRateAdversary;
  float* hourlyRateAdversary_Mobius_Mark;
  Skill* NetworkPenetration;
  short* NetworkPenetration_Mobius_Mark;
  SystemSV<float>* CorpLAN_physicalNetworkProtection;
  float* CorpLAN_physicalNetworkProtection_Mobius_Mark;
  SystemSV<bool>* CorpLAN_networkWhiteList;
  bool* CorpLAN_networkWhiteList_Mobius_Mark;
  SystemSV<float>* CorpLAN_rogueDeviceControl;
  float* CorpLAN_rogueDeviceControl_Mobius_Mark;
  SystemSV<float>* CorpLAN_rogueDeviceDetection;
  float* CorpLAN_rogueDeviceDetection_Mobius_Mark;
  SystemSV<float>* CorpLAN_physicalAttackAttribution;
  float* CorpLAN_physicalAttackAttribution_Mobius_Mark;
  Access* InsiderAccess;
  short* InsiderAccess_Mobius_Mark;
  StepChosen* CorpLAN_PlaceRogueHostOnNetworkChosen;
  short* CorpLAN_PlaceRogueHostOnNetworkChosen_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainUserCredentialsWeight;
  short* CorpLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainUserCredentialsWeight;
  short* LinuxOS_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_AdminModifyFWOpenWeight;
  short* CorpLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainRemoteUIAccessOSWeight;
  short* LinuxOS_GainRemoteUIAccessOSWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLocalUIAccessOSWeight;
  short* LinuxOS_GainLocalUIAccessOSWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLogicalAccessWeight;
  short* CorpLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* HMI_GainLocalUIAccessDeviceWeight;
  short* HMI_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_CircumventFWRulesWeight;
  short* EngrLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNetworkNodeWeight;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_CircumventFWRulesWeight;
  short* CorpLanEngrLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainUserCredentialsWeight;
  short* EngrLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* DoNothingWeight;
  short* DoNothingWeight_Mobius_Mark;
  StepWeight* SSHServer_GainLogicalAccessWeight;
  short* SSHServer_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainUserCredentialsWeight;
  short* CorpLanEngrLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainLogicalAccessWeight;
  short* HMI_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainUserCredentialsWeight;
  short* EngrWorkstation_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLogicalAccessWeight;
  short* EngrWorkstation_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_AdminModifyFWOpenWeight;
  short* CorpLanEngrLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLocalUIAccessDeviceWeight;
  short* EngrWorkstation_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SSHServer_GainUserCredentialsWeight;
  short* SSHServer_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainUserCredentialsWeight;
  short* HMI_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLAN_PlaceRogueHostOnNetworkWeight;
  short* CorpLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLogicalAccessWeight;
  short* CorpLanEngrLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_PlaceRogueHostOnNetworkWeight;
  short* EngrLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_AdminModifyFWOpenWeight;
  short* EngrLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLogicalAccessWeight;
  short* LinuxOS_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* SCADALAN_PlaceRogueHostOnNetworkWeight;
  short* SCADALAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainRemoteUIAccessDeviceWeight;
  short* EngrWorkstation_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLogicalAccessWeight;
  short* EngrLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_CircumventFWRulesWeight;
  short* CorpLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* HMI_GainRemoteUIAccessDeviceWeight;
  short* HMI_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short* MakeDecision_Mobius_Mark;
  double* TheDistributionParameters;

  CorpLAN_PlaceRogueHostOnNetworkFailureStep();
  ~CorpLAN_PlaceRogueHostOnNetworkFailureStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  bool preconditionsMet();
  void executeEffects();
}; // CorpLAN_PlaceRogueHostOnNetworkFailureStep

class CorpLAN_PlaceRogueHostOnNetworkSuccessStep : public Step {
public:

  Access* CorpLAN_NetworkAccess;
  short* CorpLAN_NetworkAccess_Mobius_Mark;
  Access* CorpLAN_PhysicalAccess;
  short* CorpLAN_PhysicalAccess_Mobius_Mark;
  SystemSV<float>* hourlyRateAdversary;
  float* hourlyRateAdversary_Mobius_Mark;
  Skill* NetworkPenetration;
  short* NetworkPenetration_Mobius_Mark;
  SystemSV<float>* CorpLAN_physicalNetworkProtection;
  float* CorpLAN_physicalNetworkProtection_Mobius_Mark;
  SystemSV<bool>* CorpLAN_networkWhiteList;
  bool* CorpLAN_networkWhiteList_Mobius_Mark;
  SystemSV<float>* CorpLAN_rogueDeviceControl;
  float* CorpLAN_rogueDeviceControl_Mobius_Mark;
  SystemSV<float>* CorpLAN_rogueDeviceDetection;
  float* CorpLAN_rogueDeviceDetection_Mobius_Mark;
  SystemSV<float>* CorpLAN_physicalAttackAttribution;
  float* CorpLAN_physicalAttackAttribution_Mobius_Mark;
  Access* InsiderAccess;
  short* InsiderAccess_Mobius_Mark;
  StepChosen* CorpLAN_PlaceRogueHostOnNetworkChosen;
  short* CorpLAN_PlaceRogueHostOnNetworkChosen_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainUserCredentialsWeight;
  short* CorpLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainUserCredentialsWeight;
  short* LinuxOS_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_AdminModifyFWOpenWeight;
  short* CorpLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainRemoteUIAccessOSWeight;
  short* LinuxOS_GainRemoteUIAccessOSWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLocalUIAccessOSWeight;
  short* LinuxOS_GainLocalUIAccessOSWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLogicalAccessWeight;
  short* CorpLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* HMI_GainLocalUIAccessDeviceWeight;
  short* HMI_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_CircumventFWRulesWeight;
  short* EngrLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNetworkNodeWeight;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_CircumventFWRulesWeight;
  short* CorpLanEngrLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainUserCredentialsWeight;
  short* EngrLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* DoNothingWeight;
  short* DoNothingWeight_Mobius_Mark;
  StepWeight* SSHServer_GainLogicalAccessWeight;
  short* SSHServer_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainUserCredentialsWeight;
  short* CorpLanEngrLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainLogicalAccessWeight;
  short* HMI_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainUserCredentialsWeight;
  short* EngrWorkstation_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLogicalAccessWeight;
  short* EngrWorkstation_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_AdminModifyFWOpenWeight;
  short* CorpLanEngrLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLocalUIAccessDeviceWeight;
  short* EngrWorkstation_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SSHServer_GainUserCredentialsWeight;
  short* SSHServer_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainUserCredentialsWeight;
  short* HMI_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLAN_PlaceRogueHostOnNetworkWeight;
  short* CorpLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLogicalAccessWeight;
  short* CorpLanEngrLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_PlaceRogueHostOnNetworkWeight;
  short* EngrLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_AdminModifyFWOpenWeight;
  short* EngrLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLogicalAccessWeight;
  short* LinuxOS_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* SCADALAN_PlaceRogueHostOnNetworkWeight;
  short* SCADALAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainRemoteUIAccessDeviceWeight;
  short* EngrWorkstation_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLogicalAccessWeight;
  short* EngrLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_CircumventFWRulesWeight;
  short* CorpLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* HMI_GainRemoteUIAccessDeviceWeight;
  short* HMI_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short* MakeDecision_Mobius_Mark;
  double* TheDistributionParameters;

  CorpLAN_PlaceRogueHostOnNetworkSuccessStep();
  ~CorpLAN_PlaceRogueHostOnNetworkSuccessStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  bool preconditionsMet();
  void executeEffects();
}; // CorpLAN_PlaceRogueHostOnNetworkSuccessStep

class CorpLanEngrLanFW_GainLogicalAccessFailureStep : public Step {
public:

  Access* CorpLanEngrLanFW_LogicalAccess;
  short* CorpLanEngrLanFW_LogicalAccess_Mobius_Mark;
  Access* CorpLanEngrLanFW_HasUserCredentials;
  short* CorpLanEngrLanFW_HasUserCredentials_Mobius_Mark;
  Access* CorpLanEngrLanFW_UIAccess;
  short* CorpLanEngrLanFW_UIAccess_Mobius_Mark;
  SystemSV<float>* CorpLanEngrLanFW_credentialMonitoring;
  float* CorpLanEngrLanFW_credentialMonitoring_Mobius_Mark;
  Skill* BasicCyberOffense;
  short* BasicCyberOffense_Mobius_Mark;
  SystemSV<float>* cyberAttackAttribution;
  float* cyberAttackAttribution_Mobius_Mark;
  SystemSV<char>* CorpLanEngrLanFW_userAuthenticationType;
  char* CorpLanEngrLanFW_userAuthenticationType_Mobius_Mark;
  StepChosen* CorpLanEngrLanFW_GainLogicalAccessChosen;
  short* CorpLanEngrLanFW_GainLogicalAccessChosen_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainUserCredentialsWeight;
  short* CorpLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainUserCredentialsWeight;
  short* LinuxOS_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_AdminModifyFWOpenWeight;
  short* CorpLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainRemoteUIAccessOSWeight;
  short* LinuxOS_GainRemoteUIAccessOSWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLocalUIAccessOSWeight;
  short* LinuxOS_GainLocalUIAccessOSWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLogicalAccessWeight;
  short* CorpLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* HMI_GainLocalUIAccessDeviceWeight;
  short* HMI_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_CircumventFWRulesWeight;
  short* EngrLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNetworkNodeWeight;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_CircumventFWRulesWeight;
  short* CorpLanEngrLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainUserCredentialsWeight;
  short* EngrLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* DoNothingWeight;
  short* DoNothingWeight_Mobius_Mark;
  StepWeight* SSHServer_GainLogicalAccessWeight;
  short* SSHServer_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainUserCredentialsWeight;
  short* CorpLanEngrLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainLogicalAccessWeight;
  short* HMI_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainUserCredentialsWeight;
  short* EngrWorkstation_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLogicalAccessWeight;
  short* EngrWorkstation_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_AdminModifyFWOpenWeight;
  short* CorpLanEngrLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLocalUIAccessDeviceWeight;
  short* EngrWorkstation_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SSHServer_GainUserCredentialsWeight;
  short* SSHServer_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainUserCredentialsWeight;
  short* HMI_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLAN_PlaceRogueHostOnNetworkWeight;
  short* CorpLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLogicalAccessWeight;
  short* CorpLanEngrLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_PlaceRogueHostOnNetworkWeight;
  short* EngrLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_AdminModifyFWOpenWeight;
  short* EngrLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLogicalAccessWeight;
  short* LinuxOS_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* SCADALAN_PlaceRogueHostOnNetworkWeight;
  short* SCADALAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainRemoteUIAccessDeviceWeight;
  short* EngrWorkstation_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLogicalAccessWeight;
  short* EngrLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_CircumventFWRulesWeight;
  short* CorpLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* HMI_GainRemoteUIAccessDeviceWeight;
  short* HMI_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short* MakeDecision_Mobius_Mark;
  double* TheDistributionParameters;

  CorpLanEngrLanFW_GainLogicalAccessFailureStep();
  ~CorpLanEngrLanFW_GainLogicalAccessFailureStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  double timeDistributionParameter1();
  bool preconditionsMet();
  void executeEffects();
}; // CorpLanEngrLanFW_GainLogicalAccessFailureStep

class CorpLanEngrLanFW_GainLogicalAccessSuccessStep : public Step {
public:

  Access* CorpLanEngrLanFW_LogicalAccess;
  short* CorpLanEngrLanFW_LogicalAccess_Mobius_Mark;
  Access* CorpLanEngrLanFW_HasUserCredentials;
  short* CorpLanEngrLanFW_HasUserCredentials_Mobius_Mark;
  Access* CorpLanEngrLanFW_UIAccess;
  short* CorpLanEngrLanFW_UIAccess_Mobius_Mark;
  SystemSV<float>* CorpLanEngrLanFW_credentialMonitoring;
  float* CorpLanEngrLanFW_credentialMonitoring_Mobius_Mark;
  Skill* BasicCyberOffense;
  short* BasicCyberOffense_Mobius_Mark;
  SystemSV<float>* cyberAttackAttribution;
  float* cyberAttackAttribution_Mobius_Mark;
  SystemSV<char>* CorpLanEngrLanFW_userAuthenticationType;
  char* CorpLanEngrLanFW_userAuthenticationType_Mobius_Mark;
  StepChosen* CorpLanEngrLanFW_GainLogicalAccessChosen;
  short* CorpLanEngrLanFW_GainLogicalAccessChosen_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainUserCredentialsWeight;
  short* CorpLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainUserCredentialsWeight;
  short* LinuxOS_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_AdminModifyFWOpenWeight;
  short* CorpLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainRemoteUIAccessOSWeight;
  short* LinuxOS_GainRemoteUIAccessOSWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLocalUIAccessOSWeight;
  short* LinuxOS_GainLocalUIAccessOSWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLogicalAccessWeight;
  short* CorpLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* HMI_GainLocalUIAccessDeviceWeight;
  short* HMI_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_CircumventFWRulesWeight;
  short* EngrLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNetworkNodeWeight;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_CircumventFWRulesWeight;
  short* CorpLanEngrLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainUserCredentialsWeight;
  short* EngrLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* DoNothingWeight;
  short* DoNothingWeight_Mobius_Mark;
  StepWeight* SSHServer_GainLogicalAccessWeight;
  short* SSHServer_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainUserCredentialsWeight;
  short* CorpLanEngrLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainLogicalAccessWeight;
  short* HMI_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainUserCredentialsWeight;
  short* EngrWorkstation_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLogicalAccessWeight;
  short* EngrWorkstation_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_AdminModifyFWOpenWeight;
  short* CorpLanEngrLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLocalUIAccessDeviceWeight;
  short* EngrWorkstation_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SSHServer_GainUserCredentialsWeight;
  short* SSHServer_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainUserCredentialsWeight;
  short* HMI_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLAN_PlaceRogueHostOnNetworkWeight;
  short* CorpLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLogicalAccessWeight;
  short* CorpLanEngrLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_PlaceRogueHostOnNetworkWeight;
  short* EngrLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_AdminModifyFWOpenWeight;
  short* EngrLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLogicalAccessWeight;
  short* LinuxOS_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* SCADALAN_PlaceRogueHostOnNetworkWeight;
  short* SCADALAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainRemoteUIAccessDeviceWeight;
  short* EngrWorkstation_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLogicalAccessWeight;
  short* EngrLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_CircumventFWRulesWeight;
  short* CorpLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* HMI_GainRemoteUIAccessDeviceWeight;
  short* HMI_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short* MakeDecision_Mobius_Mark;
  double* TheDistributionParameters;

  CorpLanEngrLanFW_GainLogicalAccessSuccessStep();
  ~CorpLanEngrLanFW_GainLogicalAccessSuccessStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  double timeDistributionParameter1();
  bool preconditionsMet();
  void executeEffects();
}; // CorpLanEngrLanFW_GainLogicalAccessSuccessStep

class CorpLanScadaLanFW_GainRemoteUIAccessDeviceFailureStep : public Step {
public:

  Access* CorpLanScadaLanFW_UIAccess;
  short* CorpLanScadaLanFW_UIAccess_Mobius_Mark;
  Skill* CorpLanScadaLanFW_SpecializedTechnicalHardwareExpertise;
  short* CorpLanScadaLanFW_SpecializedTechnicalHardwareExpertise_Mobius_Mark;
  Skill* BasicCyberOffense;
  short* BasicCyberOffense_Mobius_Mark;
  Skill* NetworkPenetration;
  short* NetworkPenetration_Mobius_Mark;
  SystemSV<float>* cyberAttackAttribution;
  float* cyberAttackAttribution_Mobius_Mark;
  Access* SCADALAN_NetworkAccess;
  short* SCADALAN_NetworkAccess_Mobius_Mark;
  Access* CorpLAN_NetworkAccess;
  short* CorpLAN_NetworkAccess_Mobius_Mark;
  SystemSV<float>* SCADALAN_networkAnomalyDetectionStrength;
  float* SCADALAN_networkAnomalyDetectionStrength_Mobius_Mark;
  SystemSV<float>* CorpLAN_networkAnomalyDetectionStrength;
  float* CorpLAN_networkAnomalyDetectionStrength_Mobius_Mark;
  StepChosen* CorpLanScadaLanFW_GainRemoteUIAccessDeviceChosen;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceChosen_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainUserCredentialsWeight;
  short* CorpLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainUserCredentialsWeight;
  short* LinuxOS_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_AdminModifyFWOpenWeight;
  short* CorpLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainRemoteUIAccessOSWeight;
  short* LinuxOS_GainRemoteUIAccessOSWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLocalUIAccessOSWeight;
  short* LinuxOS_GainLocalUIAccessOSWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLogicalAccessWeight;
  short* CorpLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* HMI_GainLocalUIAccessDeviceWeight;
  short* HMI_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_CircumventFWRulesWeight;
  short* EngrLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNetworkNodeWeight;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_CircumventFWRulesWeight;
  short* CorpLanEngrLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainUserCredentialsWeight;
  short* EngrLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* DoNothingWeight;
  short* DoNothingWeight_Mobius_Mark;
  StepWeight* SSHServer_GainLogicalAccessWeight;
  short* SSHServer_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainUserCredentialsWeight;
  short* CorpLanEngrLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainLogicalAccessWeight;
  short* HMI_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainUserCredentialsWeight;
  short* EngrWorkstation_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLogicalAccessWeight;
  short* EngrWorkstation_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_AdminModifyFWOpenWeight;
  short* CorpLanEngrLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLocalUIAccessDeviceWeight;
  short* EngrWorkstation_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SSHServer_GainUserCredentialsWeight;
  short* SSHServer_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainUserCredentialsWeight;
  short* HMI_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLAN_PlaceRogueHostOnNetworkWeight;
  short* CorpLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLogicalAccessWeight;
  short* CorpLanEngrLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_PlaceRogueHostOnNetworkWeight;
  short* EngrLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_AdminModifyFWOpenWeight;
  short* EngrLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLogicalAccessWeight;
  short* LinuxOS_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* SCADALAN_PlaceRogueHostOnNetworkWeight;
  short* SCADALAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainRemoteUIAccessDeviceWeight;
  short* EngrWorkstation_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLogicalAccessWeight;
  short* EngrLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_CircumventFWRulesWeight;
  short* CorpLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* HMI_GainRemoteUIAccessDeviceWeight;
  short* HMI_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short* MakeDecision_Mobius_Mark;
  double* TheDistributionParameters;

  CorpLanScadaLanFW_GainRemoteUIAccessDeviceFailureStep();
  ~CorpLanScadaLanFW_GainRemoteUIAccessDeviceFailureStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  double timeDistributionParameter1();
  bool preconditionsMet();
  void executeEffects();
}; // CorpLanScadaLanFW_GainRemoteUIAccessDeviceFailureStep

class CorpLanScadaLanFW_GainRemoteUIAccessDeviceSuccessStep : public Step {
public:

  Access* CorpLanScadaLanFW_UIAccess;
  short* CorpLanScadaLanFW_UIAccess_Mobius_Mark;
  Skill* CorpLanScadaLanFW_SpecializedTechnicalHardwareExpertise;
  short* CorpLanScadaLanFW_SpecializedTechnicalHardwareExpertise_Mobius_Mark;
  Skill* BasicCyberOffense;
  short* BasicCyberOffense_Mobius_Mark;
  Skill* NetworkPenetration;
  short* NetworkPenetration_Mobius_Mark;
  SystemSV<float>* cyberAttackAttribution;
  float* cyberAttackAttribution_Mobius_Mark;
  Access* SCADALAN_NetworkAccess;
  short* SCADALAN_NetworkAccess_Mobius_Mark;
  Access* CorpLAN_NetworkAccess;
  short* CorpLAN_NetworkAccess_Mobius_Mark;
  SystemSV<float>* SCADALAN_networkAnomalyDetectionStrength;
  float* SCADALAN_networkAnomalyDetectionStrength_Mobius_Mark;
  SystemSV<float>* CorpLAN_networkAnomalyDetectionStrength;
  float* CorpLAN_networkAnomalyDetectionStrength_Mobius_Mark;
  StepChosen* CorpLanScadaLanFW_GainRemoteUIAccessDeviceChosen;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceChosen_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainUserCredentialsWeight;
  short* CorpLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainUserCredentialsWeight;
  short* LinuxOS_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_AdminModifyFWOpenWeight;
  short* CorpLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainRemoteUIAccessOSWeight;
  short* LinuxOS_GainRemoteUIAccessOSWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLocalUIAccessOSWeight;
  short* LinuxOS_GainLocalUIAccessOSWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLogicalAccessWeight;
  short* CorpLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* HMI_GainLocalUIAccessDeviceWeight;
  short* HMI_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_CircumventFWRulesWeight;
  short* EngrLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNetworkNodeWeight;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_CircumventFWRulesWeight;
  short* CorpLanEngrLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainUserCredentialsWeight;
  short* EngrLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* DoNothingWeight;
  short* DoNothingWeight_Mobius_Mark;
  StepWeight* SSHServer_GainLogicalAccessWeight;
  short* SSHServer_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainUserCredentialsWeight;
  short* CorpLanEngrLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainLogicalAccessWeight;
  short* HMI_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainUserCredentialsWeight;
  short* EngrWorkstation_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLogicalAccessWeight;
  short* EngrWorkstation_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_AdminModifyFWOpenWeight;
  short* CorpLanEngrLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLocalUIAccessDeviceWeight;
  short* EngrWorkstation_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SSHServer_GainUserCredentialsWeight;
  short* SSHServer_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainUserCredentialsWeight;
  short* HMI_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLAN_PlaceRogueHostOnNetworkWeight;
  short* CorpLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLogicalAccessWeight;
  short* CorpLanEngrLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_PlaceRogueHostOnNetworkWeight;
  short* EngrLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_AdminModifyFWOpenWeight;
  short* EngrLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLogicalAccessWeight;
  short* LinuxOS_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* SCADALAN_PlaceRogueHostOnNetworkWeight;
  short* SCADALAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainRemoteUIAccessDeviceWeight;
  short* EngrWorkstation_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLogicalAccessWeight;
  short* EngrLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_CircumventFWRulesWeight;
  short* CorpLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* HMI_GainRemoteUIAccessDeviceWeight;
  short* HMI_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short* MakeDecision_Mobius_Mark;
  double* TheDistributionParameters;

  CorpLanScadaLanFW_GainRemoteUIAccessDeviceSuccessStep();
  ~CorpLanScadaLanFW_GainRemoteUIAccessDeviceSuccessStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  double timeDistributionParameter1();
  bool preconditionsMet();
  void executeEffects();
}; // CorpLanScadaLanFW_GainRemoteUIAccessDeviceSuccessStep

class EngrLAN_PlaceRogueHostOnNetworkFailureStep : public Step {
public:

  Access* EngrLAN_NetworkAccess;
  short* EngrLAN_NetworkAccess_Mobius_Mark;
  Access* EngrLAN_PhysicalAccess;
  short* EngrLAN_PhysicalAccess_Mobius_Mark;
  SystemSV<float>* hourlyRateAdversary;
  float* hourlyRateAdversary_Mobius_Mark;
  Skill* NetworkPenetration;
  short* NetworkPenetration_Mobius_Mark;
  SystemSV<float>* EngrLAN_physicalNetworkProtection;
  float* EngrLAN_physicalNetworkProtection_Mobius_Mark;
  SystemSV<bool>* EngrLAN_networkWhiteList;
  bool* EngrLAN_networkWhiteList_Mobius_Mark;
  SystemSV<float>* EngrLAN_rogueDeviceControl;
  float* EngrLAN_rogueDeviceControl_Mobius_Mark;
  SystemSV<float>* EngrLAN_rogueDeviceDetection;
  float* EngrLAN_rogueDeviceDetection_Mobius_Mark;
  SystemSV<float>* EngrLAN_physicalAttackAttribution;
  float* EngrLAN_physicalAttackAttribution_Mobius_Mark;
  Access* InsiderAccess;
  short* InsiderAccess_Mobius_Mark;
  StepChosen* EngrLAN_PlaceRogueHostOnNetworkChosen;
  short* EngrLAN_PlaceRogueHostOnNetworkChosen_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainUserCredentialsWeight;
  short* CorpLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainUserCredentialsWeight;
  short* LinuxOS_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_AdminModifyFWOpenWeight;
  short* CorpLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainRemoteUIAccessOSWeight;
  short* LinuxOS_GainRemoteUIAccessOSWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLocalUIAccessOSWeight;
  short* LinuxOS_GainLocalUIAccessOSWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLogicalAccessWeight;
  short* CorpLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* HMI_GainLocalUIAccessDeviceWeight;
  short* HMI_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_CircumventFWRulesWeight;
  short* EngrLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNetworkNodeWeight;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_CircumventFWRulesWeight;
  short* CorpLanEngrLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainUserCredentialsWeight;
  short* EngrLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* DoNothingWeight;
  short* DoNothingWeight_Mobius_Mark;
  StepWeight* SSHServer_GainLogicalAccessWeight;
  short* SSHServer_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainUserCredentialsWeight;
  short* CorpLanEngrLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainLogicalAccessWeight;
  short* HMI_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainUserCredentialsWeight;
  short* EngrWorkstation_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLogicalAccessWeight;
  short* EngrWorkstation_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_AdminModifyFWOpenWeight;
  short* CorpLanEngrLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLocalUIAccessDeviceWeight;
  short* EngrWorkstation_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SSHServer_GainUserCredentialsWeight;
  short* SSHServer_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainUserCredentialsWeight;
  short* HMI_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLAN_PlaceRogueHostOnNetworkWeight;
  short* CorpLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLogicalAccessWeight;
  short* CorpLanEngrLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_PlaceRogueHostOnNetworkWeight;
  short* EngrLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_AdminModifyFWOpenWeight;
  short* EngrLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLogicalAccessWeight;
  short* LinuxOS_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* SCADALAN_PlaceRogueHostOnNetworkWeight;
  short* SCADALAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainRemoteUIAccessDeviceWeight;
  short* EngrWorkstation_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLogicalAccessWeight;
  short* EngrLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_CircumventFWRulesWeight;
  short* CorpLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* HMI_GainRemoteUIAccessDeviceWeight;
  short* HMI_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short* MakeDecision_Mobius_Mark;
  double* TheDistributionParameters;

  EngrLAN_PlaceRogueHostOnNetworkFailureStep();
  ~EngrLAN_PlaceRogueHostOnNetworkFailureStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  bool preconditionsMet();
  void executeEffects();
}; // EngrLAN_PlaceRogueHostOnNetworkFailureStep

class EngrLAN_PlaceRogueHostOnNetworkSuccessStep : public Step {
public:

  Access* EngrLAN_NetworkAccess;
  short* EngrLAN_NetworkAccess_Mobius_Mark;
  Access* EngrLAN_PhysicalAccess;
  short* EngrLAN_PhysicalAccess_Mobius_Mark;
  SystemSV<float>* hourlyRateAdversary;
  float* hourlyRateAdversary_Mobius_Mark;
  Skill* NetworkPenetration;
  short* NetworkPenetration_Mobius_Mark;
  SystemSV<float>* EngrLAN_physicalNetworkProtection;
  float* EngrLAN_physicalNetworkProtection_Mobius_Mark;
  SystemSV<bool>* EngrLAN_networkWhiteList;
  bool* EngrLAN_networkWhiteList_Mobius_Mark;
  SystemSV<float>* EngrLAN_rogueDeviceControl;
  float* EngrLAN_rogueDeviceControl_Mobius_Mark;
  SystemSV<float>* EngrLAN_rogueDeviceDetection;
  float* EngrLAN_rogueDeviceDetection_Mobius_Mark;
  SystemSV<float>* EngrLAN_physicalAttackAttribution;
  float* EngrLAN_physicalAttackAttribution_Mobius_Mark;
  Access* InsiderAccess;
  short* InsiderAccess_Mobius_Mark;
  StepChosen* EngrLAN_PlaceRogueHostOnNetworkChosen;
  short* EngrLAN_PlaceRogueHostOnNetworkChosen_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainUserCredentialsWeight;
  short* CorpLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainUserCredentialsWeight;
  short* LinuxOS_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_AdminModifyFWOpenWeight;
  short* CorpLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainRemoteUIAccessOSWeight;
  short* LinuxOS_GainRemoteUIAccessOSWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLocalUIAccessOSWeight;
  short* LinuxOS_GainLocalUIAccessOSWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLogicalAccessWeight;
  short* CorpLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* HMI_GainLocalUIAccessDeviceWeight;
  short* HMI_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_CircumventFWRulesWeight;
  short* EngrLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNetworkNodeWeight;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_CircumventFWRulesWeight;
  short* CorpLanEngrLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainUserCredentialsWeight;
  short* EngrLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* DoNothingWeight;
  short* DoNothingWeight_Mobius_Mark;
  StepWeight* SSHServer_GainLogicalAccessWeight;
  short* SSHServer_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainUserCredentialsWeight;
  short* CorpLanEngrLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainLogicalAccessWeight;
  short* HMI_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainUserCredentialsWeight;
  short* EngrWorkstation_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLogicalAccessWeight;
  short* EngrWorkstation_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_AdminModifyFWOpenWeight;
  short* CorpLanEngrLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLocalUIAccessDeviceWeight;
  short* EngrWorkstation_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SSHServer_GainUserCredentialsWeight;
  short* SSHServer_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainUserCredentialsWeight;
  short* HMI_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLAN_PlaceRogueHostOnNetworkWeight;
  short* CorpLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLogicalAccessWeight;
  short* CorpLanEngrLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_PlaceRogueHostOnNetworkWeight;
  short* EngrLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_AdminModifyFWOpenWeight;
  short* EngrLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLogicalAccessWeight;
  short* LinuxOS_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* SCADALAN_PlaceRogueHostOnNetworkWeight;
  short* SCADALAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainRemoteUIAccessDeviceWeight;
  short* EngrWorkstation_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLogicalAccessWeight;
  short* EngrLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_CircumventFWRulesWeight;
  short* CorpLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* HMI_GainRemoteUIAccessDeviceWeight;
  short* HMI_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short* MakeDecision_Mobius_Mark;
  double* TheDistributionParameters;

  EngrLAN_PlaceRogueHostOnNetworkSuccessStep();
  ~EngrLAN_PlaceRogueHostOnNetworkSuccessStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  bool preconditionsMet();
  void executeEffects();
}; // EngrLAN_PlaceRogueHostOnNetworkSuccessStep

class EngrLanScadaLanFW_AdminModifyFWOpenFailureStep : public Step {
public:

  Access* EngrLAN_NetworkAccess;
  short* EngrLAN_NetworkAccess_Mobius_Mark;
  Access* SCADALAN_NetworkAccess;
  short* SCADALAN_NetworkAccess_Mobius_Mark;
  Goal* Goal_GainNetworkAccessOnScadaNetwork;
  short* Goal_GainNetworkAccessOnScadaNetwork_Mobius_Mark;
  Access* EngrLanScadaLanFW_LogicalAccess;
  short* EngrLanScadaLanFW_LogicalAccess_Mobius_Mark;
  Skill* NetworkPenetration;
  short* NetworkPenetration_Mobius_Mark;
  SystemSV<float>* cyberAttackAttribution;
  float* cyberAttackAttribution_Mobius_Mark;
  SystemSV<float>* EngrLanScadaLanFW_firewallConfigControl;
  float* EngrLanScadaLanFW_firewallConfigControl_Mobius_Mark;
  SystemSV<float>* EngrLanScadaLanFW_firewallConfigDetection;
  float* EngrLanScadaLanFW_firewallConfigDetection_Mobius_Mark;
  Knowledge* EngrLanScadaLanFW_FirewallConfigKnowledge;
  short* EngrLanScadaLanFW_FirewallConfigKnowledge_Mobius_Mark;
  Skill* EngrLanScadaLanFW_SpecializedTechnicalExpertise;
  short* EngrLanScadaLanFW_SpecializedTechnicalExpertise_Mobius_Mark;
  StepChosen* EngrLanScadaLanFW_AdminModifyFWOpenChosen;
  short* EngrLanScadaLanFW_AdminModifyFWOpenChosen_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainUserCredentialsWeight;
  short* CorpLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainUserCredentialsWeight;
  short* LinuxOS_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_AdminModifyFWOpenWeight;
  short* CorpLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainRemoteUIAccessOSWeight;
  short* LinuxOS_GainRemoteUIAccessOSWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLocalUIAccessOSWeight;
  short* LinuxOS_GainLocalUIAccessOSWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLogicalAccessWeight;
  short* CorpLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* HMI_GainLocalUIAccessDeviceWeight;
  short* HMI_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_CircumventFWRulesWeight;
  short* EngrLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNetworkNodeWeight;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_CircumventFWRulesWeight;
  short* CorpLanEngrLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainUserCredentialsWeight;
  short* EngrLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* DoNothingWeight;
  short* DoNothingWeight_Mobius_Mark;
  StepWeight* SSHServer_GainLogicalAccessWeight;
  short* SSHServer_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainUserCredentialsWeight;
  short* CorpLanEngrLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainLogicalAccessWeight;
  short* HMI_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainUserCredentialsWeight;
  short* EngrWorkstation_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLogicalAccessWeight;
  short* EngrWorkstation_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_AdminModifyFWOpenWeight;
  short* CorpLanEngrLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLocalUIAccessDeviceWeight;
  short* EngrWorkstation_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SSHServer_GainUserCredentialsWeight;
  short* SSHServer_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainUserCredentialsWeight;
  short* HMI_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLAN_PlaceRogueHostOnNetworkWeight;
  short* CorpLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLogicalAccessWeight;
  short* CorpLanEngrLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_PlaceRogueHostOnNetworkWeight;
  short* EngrLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_AdminModifyFWOpenWeight;
  short* EngrLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLogicalAccessWeight;
  short* LinuxOS_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* SCADALAN_PlaceRogueHostOnNetworkWeight;
  short* SCADALAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainRemoteUIAccessDeviceWeight;
  short* EngrWorkstation_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLogicalAccessWeight;
  short* EngrLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_CircumventFWRulesWeight;
  short* CorpLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* HMI_GainRemoteUIAccessDeviceWeight;
  short* HMI_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short* MakeDecision_Mobius_Mark;
  double* TheDistributionParameters;

  EngrLanScadaLanFW_AdminModifyFWOpenFailureStep();
  ~EngrLanScadaLanFW_AdminModifyFWOpenFailureStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  bool preconditionsMet();
  void executeEffects();
}; // EngrLanScadaLanFW_AdminModifyFWOpenFailureStep

class EngrLanScadaLanFW_AdminModifyFWOpenSuccessStep : public Step {
public:

  Access* EngrLAN_NetworkAccess;
  short* EngrLAN_NetworkAccess_Mobius_Mark;
  Access* SCADALAN_NetworkAccess;
  short* SCADALAN_NetworkAccess_Mobius_Mark;
  Goal* Goal_GainNetworkAccessOnScadaNetwork;
  short* Goal_GainNetworkAccessOnScadaNetwork_Mobius_Mark;
  Access* EngrLanScadaLanFW_LogicalAccess;
  short* EngrLanScadaLanFW_LogicalAccess_Mobius_Mark;
  Skill* NetworkPenetration;
  short* NetworkPenetration_Mobius_Mark;
  SystemSV<float>* cyberAttackAttribution;
  float* cyberAttackAttribution_Mobius_Mark;
  SystemSV<float>* EngrLanScadaLanFW_firewallConfigControl;
  float* EngrLanScadaLanFW_firewallConfigControl_Mobius_Mark;
  SystemSV<float>* EngrLanScadaLanFW_firewallConfigDetection;
  float* EngrLanScadaLanFW_firewallConfigDetection_Mobius_Mark;
  Knowledge* EngrLanScadaLanFW_FirewallConfigKnowledge;
  short* EngrLanScadaLanFW_FirewallConfigKnowledge_Mobius_Mark;
  Skill* EngrLanScadaLanFW_SpecializedTechnicalExpertise;
  short* EngrLanScadaLanFW_SpecializedTechnicalExpertise_Mobius_Mark;
  StepChosen* EngrLanScadaLanFW_AdminModifyFWOpenChosen;
  short* EngrLanScadaLanFW_AdminModifyFWOpenChosen_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainUserCredentialsWeight;
  short* CorpLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainUserCredentialsWeight;
  short* LinuxOS_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_AdminModifyFWOpenWeight;
  short* CorpLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainRemoteUIAccessOSWeight;
  short* LinuxOS_GainRemoteUIAccessOSWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLocalUIAccessOSWeight;
  short* LinuxOS_GainLocalUIAccessOSWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLogicalAccessWeight;
  short* CorpLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* HMI_GainLocalUIAccessDeviceWeight;
  short* HMI_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_CircumventFWRulesWeight;
  short* EngrLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNetworkNodeWeight;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_CircumventFWRulesWeight;
  short* CorpLanEngrLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainUserCredentialsWeight;
  short* EngrLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* DoNothingWeight;
  short* DoNothingWeight_Mobius_Mark;
  StepWeight* SSHServer_GainLogicalAccessWeight;
  short* SSHServer_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainUserCredentialsWeight;
  short* CorpLanEngrLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainLogicalAccessWeight;
  short* HMI_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainUserCredentialsWeight;
  short* EngrWorkstation_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLogicalAccessWeight;
  short* EngrWorkstation_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_AdminModifyFWOpenWeight;
  short* CorpLanEngrLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLocalUIAccessDeviceWeight;
  short* EngrWorkstation_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SSHServer_GainUserCredentialsWeight;
  short* SSHServer_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainUserCredentialsWeight;
  short* HMI_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLAN_PlaceRogueHostOnNetworkWeight;
  short* CorpLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLogicalAccessWeight;
  short* CorpLanEngrLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_PlaceRogueHostOnNetworkWeight;
  short* EngrLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_AdminModifyFWOpenWeight;
  short* EngrLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLogicalAccessWeight;
  short* LinuxOS_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* SCADALAN_PlaceRogueHostOnNetworkWeight;
  short* SCADALAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainRemoteUIAccessDeviceWeight;
  short* EngrWorkstation_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLogicalAccessWeight;
  short* EngrLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_CircumventFWRulesWeight;
  short* CorpLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* HMI_GainRemoteUIAccessDeviceWeight;
  short* HMI_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short* MakeDecision_Mobius_Mark;
  double* TheDistributionParameters;

  EngrLanScadaLanFW_AdminModifyFWOpenSuccessStep();
  ~EngrLanScadaLanFW_AdminModifyFWOpenSuccessStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  bool preconditionsMet();
  void executeEffects();
}; // EngrLanScadaLanFW_AdminModifyFWOpenSuccessStep

class EngrLAN_GainNetworkAccessViaNetworkNodeFailureStep : public Step {
public:

  Access* EngrLAN_NetworkAccess;
  short* EngrLAN_NetworkAccess_Mobius_Mark;
  Skill* NetworkPenetration;
  short* NetworkPenetration_Mobius_Mark;
  SystemSV<float>* EngrLAN_networkAnomalyDetectionStrength;
  float* EngrLAN_networkAnomalyDetectionStrength_Mobius_Mark;
  Skill* BasicCyberOffense;
  short* BasicCyberOffense_Mobius_Mark;
  SystemSV<float>* cyberAttackAttribution;
  float* cyberAttackAttribution_Mobius_Mark;
  Access* EngrLanScadaLanFW_LogicalAccess;
  short* EngrLanScadaLanFW_LogicalAccess_Mobius_Mark;
  Access* CorpLanEngrLanFW_LogicalAccess;
  short* CorpLanEngrLanFW_LogicalAccess_Mobius_Mark;
  Access* EngrWorkstation_LogicalAccess;
  short* EngrWorkstation_LogicalAccess_Mobius_Mark;
  Access* LinuxOS_LogicalAccess;
  short* LinuxOS_LogicalAccess_Mobius_Mark;
  StepChosen* EngrLAN_GainNetworkAccessViaNetworkNodeChosen;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeChosen_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainUserCredentialsWeight;
  short* CorpLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainUserCredentialsWeight;
  short* LinuxOS_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_AdminModifyFWOpenWeight;
  short* CorpLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainRemoteUIAccessOSWeight;
  short* LinuxOS_GainRemoteUIAccessOSWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLocalUIAccessOSWeight;
  short* LinuxOS_GainLocalUIAccessOSWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLogicalAccessWeight;
  short* CorpLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* HMI_GainLocalUIAccessDeviceWeight;
  short* HMI_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_CircumventFWRulesWeight;
  short* EngrLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNetworkNodeWeight;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_CircumventFWRulesWeight;
  short* CorpLanEngrLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainUserCredentialsWeight;
  short* EngrLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* DoNothingWeight;
  short* DoNothingWeight_Mobius_Mark;
  StepWeight* SSHServer_GainLogicalAccessWeight;
  short* SSHServer_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainUserCredentialsWeight;
  short* CorpLanEngrLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainLogicalAccessWeight;
  short* HMI_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainUserCredentialsWeight;
  short* EngrWorkstation_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLogicalAccessWeight;
  short* EngrWorkstation_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_AdminModifyFWOpenWeight;
  short* CorpLanEngrLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLocalUIAccessDeviceWeight;
  short* EngrWorkstation_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SSHServer_GainUserCredentialsWeight;
  short* SSHServer_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainUserCredentialsWeight;
  short* HMI_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLAN_PlaceRogueHostOnNetworkWeight;
  short* CorpLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLogicalAccessWeight;
  short* CorpLanEngrLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_PlaceRogueHostOnNetworkWeight;
  short* EngrLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_AdminModifyFWOpenWeight;
  short* EngrLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLogicalAccessWeight;
  short* LinuxOS_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* SCADALAN_PlaceRogueHostOnNetworkWeight;
  short* SCADALAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainRemoteUIAccessDeviceWeight;
  short* EngrWorkstation_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLogicalAccessWeight;
  short* EngrLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_CircumventFWRulesWeight;
  short* CorpLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* HMI_GainRemoteUIAccessDeviceWeight;
  short* HMI_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short* MakeDecision_Mobius_Mark;
  double* TheDistributionParameters;

  EngrLAN_GainNetworkAccessViaNetworkNodeFailureStep();
  ~EngrLAN_GainNetworkAccessViaNetworkNodeFailureStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  double timeDistributionParameter1();
  bool preconditionsMet();
  void executeEffects();
}; // EngrLAN_GainNetworkAccessViaNetworkNodeFailureStep

class EngrLAN_GainNetworkAccessViaNetworkNodeSuccessStep : public Step {
public:

  Access* EngrLAN_NetworkAccess;
  short* EngrLAN_NetworkAccess_Mobius_Mark;
  Skill* NetworkPenetration;
  short* NetworkPenetration_Mobius_Mark;
  SystemSV<float>* EngrLAN_networkAnomalyDetectionStrength;
  float* EngrLAN_networkAnomalyDetectionStrength_Mobius_Mark;
  Skill* BasicCyberOffense;
  short* BasicCyberOffense_Mobius_Mark;
  SystemSV<float>* cyberAttackAttribution;
  float* cyberAttackAttribution_Mobius_Mark;
  Access* EngrLanScadaLanFW_LogicalAccess;
  short* EngrLanScadaLanFW_LogicalAccess_Mobius_Mark;
  Access* CorpLanEngrLanFW_LogicalAccess;
  short* CorpLanEngrLanFW_LogicalAccess_Mobius_Mark;
  Access* EngrWorkstation_LogicalAccess;
  short* EngrWorkstation_LogicalAccess_Mobius_Mark;
  Access* LinuxOS_LogicalAccess;
  short* LinuxOS_LogicalAccess_Mobius_Mark;
  StepChosen* EngrLAN_GainNetworkAccessViaNetworkNodeChosen;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeChosen_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainUserCredentialsWeight;
  short* CorpLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainUserCredentialsWeight;
  short* LinuxOS_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_AdminModifyFWOpenWeight;
  short* CorpLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainRemoteUIAccessOSWeight;
  short* LinuxOS_GainRemoteUIAccessOSWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLocalUIAccessOSWeight;
  short* LinuxOS_GainLocalUIAccessOSWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLogicalAccessWeight;
  short* CorpLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* HMI_GainLocalUIAccessDeviceWeight;
  short* HMI_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_CircumventFWRulesWeight;
  short* EngrLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNetworkNodeWeight;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_CircumventFWRulesWeight;
  short* CorpLanEngrLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainUserCredentialsWeight;
  short* EngrLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* DoNothingWeight;
  short* DoNothingWeight_Mobius_Mark;
  StepWeight* SSHServer_GainLogicalAccessWeight;
  short* SSHServer_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainUserCredentialsWeight;
  short* CorpLanEngrLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainLogicalAccessWeight;
  short* HMI_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainUserCredentialsWeight;
  short* EngrWorkstation_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLogicalAccessWeight;
  short* EngrWorkstation_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_AdminModifyFWOpenWeight;
  short* CorpLanEngrLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLocalUIAccessDeviceWeight;
  short* EngrWorkstation_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SSHServer_GainUserCredentialsWeight;
  short* SSHServer_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainUserCredentialsWeight;
  short* HMI_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLAN_PlaceRogueHostOnNetworkWeight;
  short* CorpLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLogicalAccessWeight;
  short* CorpLanEngrLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_PlaceRogueHostOnNetworkWeight;
  short* EngrLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_AdminModifyFWOpenWeight;
  short* EngrLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLogicalAccessWeight;
  short* LinuxOS_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* SCADALAN_PlaceRogueHostOnNetworkWeight;
  short* SCADALAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainRemoteUIAccessDeviceWeight;
  short* EngrWorkstation_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLogicalAccessWeight;
  short* EngrLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_CircumventFWRulesWeight;
  short* CorpLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* HMI_GainRemoteUIAccessDeviceWeight;
  short* HMI_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short* MakeDecision_Mobius_Mark;
  double* TheDistributionParameters;

  EngrLAN_GainNetworkAccessViaNetworkNodeSuccessStep();
  ~EngrLAN_GainNetworkAccessViaNetworkNodeSuccessStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  double timeDistributionParameter1();
  bool preconditionsMet();
  void executeEffects();
}; // EngrLAN_GainNetworkAccessViaNetworkNodeSuccessStep

class LinuxOS_GainLogicalAccessFailureStep : public Step {
public:

  Access* LinuxOS_LogicalAccess;
  short* LinuxOS_LogicalAccess_Mobius_Mark;
  Access* SSHServer_UIAccess;
  short* SSHServer_UIAccess_Mobius_Mark;
  Access* LinuxOS_HasUserCredentials;
  short* LinuxOS_HasUserCredentials_Mobius_Mark;
  Access* LinuxOS_UIAccess;
  short* LinuxOS_UIAccess_Mobius_Mark;
  SystemSV<float>* LinuxOS_credentialMonitoring;
  float* LinuxOS_credentialMonitoring_Mobius_Mark;
  Skill* BasicCyberOffense;
  short* BasicCyberOffense_Mobius_Mark;
  SystemSV<float>* cyberAttackAttribution;
  float* cyberAttackAttribution_Mobius_Mark;
  SystemSV<char>* LinuxOS_userAuthenticationType;
  char* LinuxOS_userAuthenticationType_Mobius_Mark;
  StepChosen* LinuxOS_GainLogicalAccessChosen;
  short* LinuxOS_GainLogicalAccessChosen_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainUserCredentialsWeight;
  short* CorpLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainUserCredentialsWeight;
  short* LinuxOS_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_AdminModifyFWOpenWeight;
  short* CorpLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainRemoteUIAccessOSWeight;
  short* LinuxOS_GainRemoteUIAccessOSWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLocalUIAccessOSWeight;
  short* LinuxOS_GainLocalUIAccessOSWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLogicalAccessWeight;
  short* CorpLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* HMI_GainLocalUIAccessDeviceWeight;
  short* HMI_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_CircumventFWRulesWeight;
  short* EngrLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNetworkNodeWeight;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_CircumventFWRulesWeight;
  short* CorpLanEngrLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainUserCredentialsWeight;
  short* EngrLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* DoNothingWeight;
  short* DoNothingWeight_Mobius_Mark;
  StepWeight* SSHServer_GainLogicalAccessWeight;
  short* SSHServer_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainUserCredentialsWeight;
  short* CorpLanEngrLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainLogicalAccessWeight;
  short* HMI_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainUserCredentialsWeight;
  short* EngrWorkstation_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLogicalAccessWeight;
  short* EngrWorkstation_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_AdminModifyFWOpenWeight;
  short* CorpLanEngrLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLocalUIAccessDeviceWeight;
  short* EngrWorkstation_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SSHServer_GainUserCredentialsWeight;
  short* SSHServer_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainUserCredentialsWeight;
  short* HMI_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLAN_PlaceRogueHostOnNetworkWeight;
  short* CorpLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLogicalAccessWeight;
  short* CorpLanEngrLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_PlaceRogueHostOnNetworkWeight;
  short* EngrLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_AdminModifyFWOpenWeight;
  short* EngrLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLogicalAccessWeight;
  short* LinuxOS_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* SCADALAN_PlaceRogueHostOnNetworkWeight;
  short* SCADALAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainRemoteUIAccessDeviceWeight;
  short* EngrWorkstation_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLogicalAccessWeight;
  short* EngrLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_CircumventFWRulesWeight;
  short* CorpLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* HMI_GainRemoteUIAccessDeviceWeight;
  short* HMI_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short* MakeDecision_Mobius_Mark;
  double* TheDistributionParameters;

  LinuxOS_GainLogicalAccessFailureStep();
  ~LinuxOS_GainLogicalAccessFailureStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  double timeDistributionParameter1();
  bool preconditionsMet();
  void executeEffects();
}; // LinuxOS_GainLogicalAccessFailureStep

class LinuxOS_GainLogicalAccessSuccessStep : public Step {
public:

  Access* LinuxOS_LogicalAccess;
  short* LinuxOS_LogicalAccess_Mobius_Mark;
  Access* SSHServer_UIAccess;
  short* SSHServer_UIAccess_Mobius_Mark;
  Access* LinuxOS_HasUserCredentials;
  short* LinuxOS_HasUserCredentials_Mobius_Mark;
  Access* LinuxOS_UIAccess;
  short* LinuxOS_UIAccess_Mobius_Mark;
  SystemSV<float>* LinuxOS_credentialMonitoring;
  float* LinuxOS_credentialMonitoring_Mobius_Mark;
  Skill* BasicCyberOffense;
  short* BasicCyberOffense_Mobius_Mark;
  SystemSV<float>* cyberAttackAttribution;
  float* cyberAttackAttribution_Mobius_Mark;
  SystemSV<char>* LinuxOS_userAuthenticationType;
  char* LinuxOS_userAuthenticationType_Mobius_Mark;
  StepChosen* LinuxOS_GainLogicalAccessChosen;
  short* LinuxOS_GainLogicalAccessChosen_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainUserCredentialsWeight;
  short* CorpLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainUserCredentialsWeight;
  short* LinuxOS_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_AdminModifyFWOpenWeight;
  short* CorpLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainRemoteUIAccessOSWeight;
  short* LinuxOS_GainRemoteUIAccessOSWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLocalUIAccessOSWeight;
  short* LinuxOS_GainLocalUIAccessOSWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLogicalAccessWeight;
  short* CorpLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* HMI_GainLocalUIAccessDeviceWeight;
  short* HMI_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_CircumventFWRulesWeight;
  short* EngrLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNetworkNodeWeight;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_CircumventFWRulesWeight;
  short* CorpLanEngrLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainUserCredentialsWeight;
  short* EngrLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* DoNothingWeight;
  short* DoNothingWeight_Mobius_Mark;
  StepWeight* SSHServer_GainLogicalAccessWeight;
  short* SSHServer_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainUserCredentialsWeight;
  short* CorpLanEngrLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainLogicalAccessWeight;
  short* HMI_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainUserCredentialsWeight;
  short* EngrWorkstation_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLogicalAccessWeight;
  short* EngrWorkstation_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_AdminModifyFWOpenWeight;
  short* CorpLanEngrLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLocalUIAccessDeviceWeight;
  short* EngrWorkstation_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SSHServer_GainUserCredentialsWeight;
  short* SSHServer_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainUserCredentialsWeight;
  short* HMI_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLAN_PlaceRogueHostOnNetworkWeight;
  short* CorpLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLogicalAccessWeight;
  short* CorpLanEngrLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_PlaceRogueHostOnNetworkWeight;
  short* EngrLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_AdminModifyFWOpenWeight;
  short* EngrLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLogicalAccessWeight;
  short* LinuxOS_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* SCADALAN_PlaceRogueHostOnNetworkWeight;
  short* SCADALAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainRemoteUIAccessDeviceWeight;
  short* EngrWorkstation_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLogicalAccessWeight;
  short* EngrLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_CircumventFWRulesWeight;
  short* CorpLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* HMI_GainRemoteUIAccessDeviceWeight;
  short* HMI_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short* MakeDecision_Mobius_Mark;
  double* TheDistributionParameters;

  LinuxOS_GainLogicalAccessSuccessStep();
  ~LinuxOS_GainLogicalAccessSuccessStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  double timeDistributionParameter1();
  bool preconditionsMet();
  void executeEffects();
}; // LinuxOS_GainLogicalAccessSuccessStep

class SCADALAN_PlaceRogueHostOnNetworkFailureStep : public Step {
public:

  Access* SCADALAN_NetworkAccess;
  short* SCADALAN_NetworkAccess_Mobius_Mark;
  Goal* Goal_GainNetworkAccessOnScadaNetwork;
  short* Goal_GainNetworkAccessOnScadaNetwork_Mobius_Mark;
  Access* SCADALAN_PhysicalAccess;
  short* SCADALAN_PhysicalAccess_Mobius_Mark;
  SystemSV<float>* hourlyRateAdversary;
  float* hourlyRateAdversary_Mobius_Mark;
  Skill* NetworkPenetration;
  short* NetworkPenetration_Mobius_Mark;
  SystemSV<float>* SCADALAN_physicalNetworkProtection;
  float* SCADALAN_physicalNetworkProtection_Mobius_Mark;
  SystemSV<bool>* SCADALAN_networkWhiteList;
  bool* SCADALAN_networkWhiteList_Mobius_Mark;
  SystemSV<float>* SCADALAN_rogueDeviceControl;
  float* SCADALAN_rogueDeviceControl_Mobius_Mark;
  SystemSV<float>* SCADALAN_rogueDeviceDetection;
  float* SCADALAN_rogueDeviceDetection_Mobius_Mark;
  SystemSV<float>* SCADALAN_physicalAttackAttribution;
  float* SCADALAN_physicalAttackAttribution_Mobius_Mark;
  Access* InsiderAccess;
  short* InsiderAccess_Mobius_Mark;
  StepChosen* SCADALAN_PlaceRogueHostOnNetworkChosen;
  short* SCADALAN_PlaceRogueHostOnNetworkChosen_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainUserCredentialsWeight;
  short* CorpLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainUserCredentialsWeight;
  short* LinuxOS_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_AdminModifyFWOpenWeight;
  short* CorpLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainRemoteUIAccessOSWeight;
  short* LinuxOS_GainRemoteUIAccessOSWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLocalUIAccessOSWeight;
  short* LinuxOS_GainLocalUIAccessOSWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLogicalAccessWeight;
  short* CorpLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* HMI_GainLocalUIAccessDeviceWeight;
  short* HMI_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_CircumventFWRulesWeight;
  short* EngrLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNetworkNodeWeight;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_CircumventFWRulesWeight;
  short* CorpLanEngrLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainUserCredentialsWeight;
  short* EngrLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* DoNothingWeight;
  short* DoNothingWeight_Mobius_Mark;
  StepWeight* SSHServer_GainLogicalAccessWeight;
  short* SSHServer_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainUserCredentialsWeight;
  short* CorpLanEngrLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainLogicalAccessWeight;
  short* HMI_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainUserCredentialsWeight;
  short* EngrWorkstation_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLogicalAccessWeight;
  short* EngrWorkstation_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_AdminModifyFWOpenWeight;
  short* CorpLanEngrLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLocalUIAccessDeviceWeight;
  short* EngrWorkstation_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SSHServer_GainUserCredentialsWeight;
  short* SSHServer_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainUserCredentialsWeight;
  short* HMI_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLAN_PlaceRogueHostOnNetworkWeight;
  short* CorpLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLogicalAccessWeight;
  short* CorpLanEngrLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_PlaceRogueHostOnNetworkWeight;
  short* EngrLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_AdminModifyFWOpenWeight;
  short* EngrLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLogicalAccessWeight;
  short* LinuxOS_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* SCADALAN_PlaceRogueHostOnNetworkWeight;
  short* SCADALAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainRemoteUIAccessDeviceWeight;
  short* EngrWorkstation_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLogicalAccessWeight;
  short* EngrLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_CircumventFWRulesWeight;
  short* CorpLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* HMI_GainRemoteUIAccessDeviceWeight;
  short* HMI_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short* MakeDecision_Mobius_Mark;
  double* TheDistributionParameters;

  SCADALAN_PlaceRogueHostOnNetworkFailureStep();
  ~SCADALAN_PlaceRogueHostOnNetworkFailureStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  bool preconditionsMet();
  void executeEffects();
}; // SCADALAN_PlaceRogueHostOnNetworkFailureStep

class SCADALAN_PlaceRogueHostOnNetworkSuccessStep : public Step {
public:

  Access* SCADALAN_NetworkAccess;
  short* SCADALAN_NetworkAccess_Mobius_Mark;
  Goal* Goal_GainNetworkAccessOnScadaNetwork;
  short* Goal_GainNetworkAccessOnScadaNetwork_Mobius_Mark;
  Access* SCADALAN_PhysicalAccess;
  short* SCADALAN_PhysicalAccess_Mobius_Mark;
  SystemSV<float>* hourlyRateAdversary;
  float* hourlyRateAdversary_Mobius_Mark;
  Skill* NetworkPenetration;
  short* NetworkPenetration_Mobius_Mark;
  SystemSV<float>* SCADALAN_physicalNetworkProtection;
  float* SCADALAN_physicalNetworkProtection_Mobius_Mark;
  SystemSV<bool>* SCADALAN_networkWhiteList;
  bool* SCADALAN_networkWhiteList_Mobius_Mark;
  SystemSV<float>* SCADALAN_rogueDeviceControl;
  float* SCADALAN_rogueDeviceControl_Mobius_Mark;
  SystemSV<float>* SCADALAN_rogueDeviceDetection;
  float* SCADALAN_rogueDeviceDetection_Mobius_Mark;
  SystemSV<float>* SCADALAN_physicalAttackAttribution;
  float* SCADALAN_physicalAttackAttribution_Mobius_Mark;
  Access* InsiderAccess;
  short* InsiderAccess_Mobius_Mark;
  StepChosen* SCADALAN_PlaceRogueHostOnNetworkChosen;
  short* SCADALAN_PlaceRogueHostOnNetworkChosen_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainUserCredentialsWeight;
  short* CorpLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainUserCredentialsWeight;
  short* LinuxOS_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_AdminModifyFWOpenWeight;
  short* CorpLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainRemoteUIAccessOSWeight;
  short* LinuxOS_GainRemoteUIAccessOSWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLocalUIAccessOSWeight;
  short* LinuxOS_GainLocalUIAccessOSWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLogicalAccessWeight;
  short* CorpLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* HMI_GainLocalUIAccessDeviceWeight;
  short* HMI_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_CircumventFWRulesWeight;
  short* EngrLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNetworkNodeWeight;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_CircumventFWRulesWeight;
  short* CorpLanEngrLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainUserCredentialsWeight;
  short* EngrLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* DoNothingWeight;
  short* DoNothingWeight_Mobius_Mark;
  StepWeight* SSHServer_GainLogicalAccessWeight;
  short* SSHServer_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainUserCredentialsWeight;
  short* CorpLanEngrLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainLogicalAccessWeight;
  short* HMI_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainUserCredentialsWeight;
  short* EngrWorkstation_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLogicalAccessWeight;
  short* EngrWorkstation_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_AdminModifyFWOpenWeight;
  short* CorpLanEngrLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLocalUIAccessDeviceWeight;
  short* EngrWorkstation_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SSHServer_GainUserCredentialsWeight;
  short* SSHServer_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainUserCredentialsWeight;
  short* HMI_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLAN_PlaceRogueHostOnNetworkWeight;
  short* CorpLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLogicalAccessWeight;
  short* CorpLanEngrLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_PlaceRogueHostOnNetworkWeight;
  short* EngrLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_AdminModifyFWOpenWeight;
  short* EngrLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLogicalAccessWeight;
  short* LinuxOS_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* SCADALAN_PlaceRogueHostOnNetworkWeight;
  short* SCADALAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainRemoteUIAccessDeviceWeight;
  short* EngrWorkstation_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLogicalAccessWeight;
  short* EngrLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_CircumventFWRulesWeight;
  short* CorpLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* HMI_GainRemoteUIAccessDeviceWeight;
  short* HMI_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short* MakeDecision_Mobius_Mark;
  double* TheDistributionParameters;

  SCADALAN_PlaceRogueHostOnNetworkSuccessStep();
  ~SCADALAN_PlaceRogueHostOnNetworkSuccessStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  bool preconditionsMet();
  void executeEffects();
}; // SCADALAN_PlaceRogueHostOnNetworkSuccessStep

class EngrLanScadaLanFW_GainLocalUIAccessDeviceFailureStep : public Step {
public:

  Access* EngrLanScadaLanFW_UIAccess;
  short* EngrLanScadaLanFW_UIAccess_Mobius_Mark;
  Access* EngrLanScadaLanFW_LogicalAccess;
  short* EngrLanScadaLanFW_LogicalAccess_Mobius_Mark;
  Access* EngrLanScadaLanFW_PhysicalAccess;
  short* EngrLanScadaLanFW_PhysicalAccess_Mobius_Mark;
  SystemSV<char>* EngrLanScadaLanFW_userAuthenticationType;
  char* EngrLanScadaLanFW_userAuthenticationType_Mobius_Mark;
  Skill* KineticEquipmentAttack;
  short* KineticEquipmentAttack_Mobius_Mark;
  SystemSV<float>* EngrLanScadaLanFW_physicalAttackAttribution;
  float* EngrLanScadaLanFW_physicalAttackAttribution_Mobius_Mark;
  StepChosen* EngrLanScadaLanFW_GainLocalUIAccessDeviceChosen;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceChosen_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainUserCredentialsWeight;
  short* CorpLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainUserCredentialsWeight;
  short* LinuxOS_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_AdminModifyFWOpenWeight;
  short* CorpLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainRemoteUIAccessOSWeight;
  short* LinuxOS_GainRemoteUIAccessOSWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLocalUIAccessOSWeight;
  short* LinuxOS_GainLocalUIAccessOSWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLogicalAccessWeight;
  short* CorpLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* HMI_GainLocalUIAccessDeviceWeight;
  short* HMI_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_CircumventFWRulesWeight;
  short* EngrLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNetworkNodeWeight;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_CircumventFWRulesWeight;
  short* CorpLanEngrLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainUserCredentialsWeight;
  short* EngrLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* DoNothingWeight;
  short* DoNothingWeight_Mobius_Mark;
  StepWeight* SSHServer_GainLogicalAccessWeight;
  short* SSHServer_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainUserCredentialsWeight;
  short* CorpLanEngrLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainLogicalAccessWeight;
  short* HMI_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainUserCredentialsWeight;
  short* EngrWorkstation_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLogicalAccessWeight;
  short* EngrWorkstation_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_AdminModifyFWOpenWeight;
  short* CorpLanEngrLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLocalUIAccessDeviceWeight;
  short* EngrWorkstation_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SSHServer_GainUserCredentialsWeight;
  short* SSHServer_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainUserCredentialsWeight;
  short* HMI_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLAN_PlaceRogueHostOnNetworkWeight;
  short* CorpLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLogicalAccessWeight;
  short* CorpLanEngrLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_PlaceRogueHostOnNetworkWeight;
  short* EngrLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_AdminModifyFWOpenWeight;
  short* EngrLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLogicalAccessWeight;
  short* LinuxOS_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* SCADALAN_PlaceRogueHostOnNetworkWeight;
  short* SCADALAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainRemoteUIAccessDeviceWeight;
  short* EngrWorkstation_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLogicalAccessWeight;
  short* EngrLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_CircumventFWRulesWeight;
  short* CorpLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* HMI_GainRemoteUIAccessDeviceWeight;
  short* HMI_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short* MakeDecision_Mobius_Mark;
  double* TheDistributionParameters;

  EngrLanScadaLanFW_GainLocalUIAccessDeviceFailureStep();
  ~EngrLanScadaLanFW_GainLocalUIAccessDeviceFailureStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  double timeDistributionParameter1();
  bool preconditionsMet();
  void executeEffects();
}; // EngrLanScadaLanFW_GainLocalUIAccessDeviceFailureStep

class EngrLanScadaLanFW_GainLocalUIAccessDeviceSuccessStep : public Step {
public:

  Access* EngrLanScadaLanFW_UIAccess;
  short* EngrLanScadaLanFW_UIAccess_Mobius_Mark;
  Access* EngrLanScadaLanFW_LogicalAccess;
  short* EngrLanScadaLanFW_LogicalAccess_Mobius_Mark;
  Access* EngrLanScadaLanFW_PhysicalAccess;
  short* EngrLanScadaLanFW_PhysicalAccess_Mobius_Mark;
  SystemSV<char>* EngrLanScadaLanFW_userAuthenticationType;
  char* EngrLanScadaLanFW_userAuthenticationType_Mobius_Mark;
  Skill* KineticEquipmentAttack;
  short* KineticEquipmentAttack_Mobius_Mark;
  SystemSV<float>* EngrLanScadaLanFW_physicalAttackAttribution;
  float* EngrLanScadaLanFW_physicalAttackAttribution_Mobius_Mark;
  StepChosen* EngrLanScadaLanFW_GainLocalUIAccessDeviceChosen;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceChosen_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainUserCredentialsWeight;
  short* CorpLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainUserCredentialsWeight;
  short* LinuxOS_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_AdminModifyFWOpenWeight;
  short* CorpLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainRemoteUIAccessOSWeight;
  short* LinuxOS_GainRemoteUIAccessOSWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLocalUIAccessOSWeight;
  short* LinuxOS_GainLocalUIAccessOSWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLogicalAccessWeight;
  short* CorpLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* HMI_GainLocalUIAccessDeviceWeight;
  short* HMI_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_CircumventFWRulesWeight;
  short* EngrLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNetworkNodeWeight;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_CircumventFWRulesWeight;
  short* CorpLanEngrLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainUserCredentialsWeight;
  short* EngrLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* DoNothingWeight;
  short* DoNothingWeight_Mobius_Mark;
  StepWeight* SSHServer_GainLogicalAccessWeight;
  short* SSHServer_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainUserCredentialsWeight;
  short* CorpLanEngrLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainLogicalAccessWeight;
  short* HMI_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainUserCredentialsWeight;
  short* EngrWorkstation_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLogicalAccessWeight;
  short* EngrWorkstation_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_AdminModifyFWOpenWeight;
  short* CorpLanEngrLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLocalUIAccessDeviceWeight;
  short* EngrWorkstation_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SSHServer_GainUserCredentialsWeight;
  short* SSHServer_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainUserCredentialsWeight;
  short* HMI_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLAN_PlaceRogueHostOnNetworkWeight;
  short* CorpLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLogicalAccessWeight;
  short* CorpLanEngrLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_PlaceRogueHostOnNetworkWeight;
  short* EngrLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_AdminModifyFWOpenWeight;
  short* EngrLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLogicalAccessWeight;
  short* LinuxOS_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* SCADALAN_PlaceRogueHostOnNetworkWeight;
  short* SCADALAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainRemoteUIAccessDeviceWeight;
  short* EngrWorkstation_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLogicalAccessWeight;
  short* EngrLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_CircumventFWRulesWeight;
  short* CorpLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* HMI_GainRemoteUIAccessDeviceWeight;
  short* HMI_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short* MakeDecision_Mobius_Mark;
  double* TheDistributionParameters;

  EngrLanScadaLanFW_GainLocalUIAccessDeviceSuccessStep();
  ~EngrLanScadaLanFW_GainLocalUIAccessDeviceSuccessStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  double timeDistributionParameter1();
  bool preconditionsMet();
  void executeEffects();
}; // EngrLanScadaLanFW_GainLocalUIAccessDeviceSuccessStep

class EngrWorkstation_GainRemoteUIAccessDeviceFailureStep : public Step {
public:

  Access* EngrWorkstation_UIAccess;
  short* EngrWorkstation_UIAccess_Mobius_Mark;
  Skill* EngrWorkstation_SpecializedTechnicalHardwareExpertise;
  short* EngrWorkstation_SpecializedTechnicalHardwareExpertise_Mobius_Mark;
  Skill* BasicCyberOffense;
  short* BasicCyberOffense_Mobius_Mark;
  Skill* NetworkPenetration;
  short* NetworkPenetration_Mobius_Mark;
  SystemSV<float>* cyberAttackAttribution;
  float* cyberAttackAttribution_Mobius_Mark;
  Access* EngrLAN_NetworkAccess;
  short* EngrLAN_NetworkAccess_Mobius_Mark;
  SystemSV<float>* EngrLAN_networkAnomalyDetectionStrength;
  float* EngrLAN_networkAnomalyDetectionStrength_Mobius_Mark;
  StepChosen* EngrWorkstation_GainRemoteUIAccessDeviceChosen;
  short* EngrWorkstation_GainRemoteUIAccessDeviceChosen_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainUserCredentialsWeight;
  short* CorpLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainUserCredentialsWeight;
  short* LinuxOS_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_AdminModifyFWOpenWeight;
  short* CorpLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainRemoteUIAccessOSWeight;
  short* LinuxOS_GainRemoteUIAccessOSWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLocalUIAccessOSWeight;
  short* LinuxOS_GainLocalUIAccessOSWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLogicalAccessWeight;
  short* CorpLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* HMI_GainLocalUIAccessDeviceWeight;
  short* HMI_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_CircumventFWRulesWeight;
  short* EngrLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNetworkNodeWeight;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_CircumventFWRulesWeight;
  short* CorpLanEngrLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainUserCredentialsWeight;
  short* EngrLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* DoNothingWeight;
  short* DoNothingWeight_Mobius_Mark;
  StepWeight* SSHServer_GainLogicalAccessWeight;
  short* SSHServer_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainUserCredentialsWeight;
  short* CorpLanEngrLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainLogicalAccessWeight;
  short* HMI_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainUserCredentialsWeight;
  short* EngrWorkstation_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLogicalAccessWeight;
  short* EngrWorkstation_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_AdminModifyFWOpenWeight;
  short* CorpLanEngrLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLocalUIAccessDeviceWeight;
  short* EngrWorkstation_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SSHServer_GainUserCredentialsWeight;
  short* SSHServer_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainUserCredentialsWeight;
  short* HMI_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLAN_PlaceRogueHostOnNetworkWeight;
  short* CorpLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLogicalAccessWeight;
  short* CorpLanEngrLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_PlaceRogueHostOnNetworkWeight;
  short* EngrLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_AdminModifyFWOpenWeight;
  short* EngrLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLogicalAccessWeight;
  short* LinuxOS_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* SCADALAN_PlaceRogueHostOnNetworkWeight;
  short* SCADALAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainRemoteUIAccessDeviceWeight;
  short* EngrWorkstation_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLogicalAccessWeight;
  short* EngrLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_CircumventFWRulesWeight;
  short* CorpLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* HMI_GainRemoteUIAccessDeviceWeight;
  short* HMI_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short* MakeDecision_Mobius_Mark;
  double* TheDistributionParameters;

  EngrWorkstation_GainRemoteUIAccessDeviceFailureStep();
  ~EngrWorkstation_GainRemoteUIAccessDeviceFailureStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  double timeDistributionParameter1();
  bool preconditionsMet();
  void executeEffects();
}; // EngrWorkstation_GainRemoteUIAccessDeviceFailureStep

class EngrWorkstation_GainRemoteUIAccessDeviceSuccessStep : public Step {
public:

  Access* EngrWorkstation_UIAccess;
  short* EngrWorkstation_UIAccess_Mobius_Mark;
  Skill* EngrWorkstation_SpecializedTechnicalHardwareExpertise;
  short* EngrWorkstation_SpecializedTechnicalHardwareExpertise_Mobius_Mark;
  Skill* BasicCyberOffense;
  short* BasicCyberOffense_Mobius_Mark;
  Skill* NetworkPenetration;
  short* NetworkPenetration_Mobius_Mark;
  SystemSV<float>* cyberAttackAttribution;
  float* cyberAttackAttribution_Mobius_Mark;
  Access* EngrLAN_NetworkAccess;
  short* EngrLAN_NetworkAccess_Mobius_Mark;
  SystemSV<float>* EngrLAN_networkAnomalyDetectionStrength;
  float* EngrLAN_networkAnomalyDetectionStrength_Mobius_Mark;
  StepChosen* EngrWorkstation_GainRemoteUIAccessDeviceChosen;
  short* EngrWorkstation_GainRemoteUIAccessDeviceChosen_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainUserCredentialsWeight;
  short* CorpLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainUserCredentialsWeight;
  short* LinuxOS_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_AdminModifyFWOpenWeight;
  short* CorpLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainRemoteUIAccessOSWeight;
  short* LinuxOS_GainRemoteUIAccessOSWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLocalUIAccessOSWeight;
  short* LinuxOS_GainLocalUIAccessOSWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLogicalAccessWeight;
  short* CorpLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* HMI_GainLocalUIAccessDeviceWeight;
  short* HMI_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_CircumventFWRulesWeight;
  short* EngrLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNetworkNodeWeight;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_CircumventFWRulesWeight;
  short* CorpLanEngrLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainUserCredentialsWeight;
  short* EngrLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* DoNothingWeight;
  short* DoNothingWeight_Mobius_Mark;
  StepWeight* SSHServer_GainLogicalAccessWeight;
  short* SSHServer_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainUserCredentialsWeight;
  short* CorpLanEngrLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainLogicalAccessWeight;
  short* HMI_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainUserCredentialsWeight;
  short* EngrWorkstation_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLogicalAccessWeight;
  short* EngrWorkstation_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_AdminModifyFWOpenWeight;
  short* CorpLanEngrLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLocalUIAccessDeviceWeight;
  short* EngrWorkstation_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SSHServer_GainUserCredentialsWeight;
  short* SSHServer_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainUserCredentialsWeight;
  short* HMI_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLAN_PlaceRogueHostOnNetworkWeight;
  short* CorpLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLogicalAccessWeight;
  short* CorpLanEngrLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_PlaceRogueHostOnNetworkWeight;
  short* EngrLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_AdminModifyFWOpenWeight;
  short* EngrLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLogicalAccessWeight;
  short* LinuxOS_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* SCADALAN_PlaceRogueHostOnNetworkWeight;
  short* SCADALAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainRemoteUIAccessDeviceWeight;
  short* EngrWorkstation_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLogicalAccessWeight;
  short* EngrLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_CircumventFWRulesWeight;
  short* CorpLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* HMI_GainRemoteUIAccessDeviceWeight;
  short* HMI_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short* MakeDecision_Mobius_Mark;
  double* TheDistributionParameters;

  EngrWorkstation_GainRemoteUIAccessDeviceSuccessStep();
  ~EngrWorkstation_GainRemoteUIAccessDeviceSuccessStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  double timeDistributionParameter1();
  bool preconditionsMet();
  void executeEffects();
}; // EngrWorkstation_GainRemoteUIAccessDeviceSuccessStep

class EngrLanScadaLanFW_GainLogicalAccessFailureStep : public Step {
public:

  Access* EngrLanScadaLanFW_LogicalAccess;
  short* EngrLanScadaLanFW_LogicalAccess_Mobius_Mark;
  Access* EngrLanScadaLanFW_HasUserCredentials;
  short* EngrLanScadaLanFW_HasUserCredentials_Mobius_Mark;
  Access* EngrLanScadaLanFW_UIAccess;
  short* EngrLanScadaLanFW_UIAccess_Mobius_Mark;
  SystemSV<float>* EngrLanScadaLanFW_credentialMonitoring;
  float* EngrLanScadaLanFW_credentialMonitoring_Mobius_Mark;
  Skill* BasicCyberOffense;
  short* BasicCyberOffense_Mobius_Mark;
  SystemSV<float>* cyberAttackAttribution;
  float* cyberAttackAttribution_Mobius_Mark;
  SystemSV<char>* EngrLanScadaLanFW_userAuthenticationType;
  char* EngrLanScadaLanFW_userAuthenticationType_Mobius_Mark;
  StepChosen* EngrLanScadaLanFW_GainLogicalAccessChosen;
  short* EngrLanScadaLanFW_GainLogicalAccessChosen_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainUserCredentialsWeight;
  short* CorpLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainUserCredentialsWeight;
  short* LinuxOS_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_AdminModifyFWOpenWeight;
  short* CorpLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainRemoteUIAccessOSWeight;
  short* LinuxOS_GainRemoteUIAccessOSWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLocalUIAccessOSWeight;
  short* LinuxOS_GainLocalUIAccessOSWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLogicalAccessWeight;
  short* CorpLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* HMI_GainLocalUIAccessDeviceWeight;
  short* HMI_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_CircumventFWRulesWeight;
  short* EngrLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNetworkNodeWeight;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_CircumventFWRulesWeight;
  short* CorpLanEngrLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainUserCredentialsWeight;
  short* EngrLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* DoNothingWeight;
  short* DoNothingWeight_Mobius_Mark;
  StepWeight* SSHServer_GainLogicalAccessWeight;
  short* SSHServer_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainUserCredentialsWeight;
  short* CorpLanEngrLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainLogicalAccessWeight;
  short* HMI_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainUserCredentialsWeight;
  short* EngrWorkstation_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLogicalAccessWeight;
  short* EngrWorkstation_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_AdminModifyFWOpenWeight;
  short* CorpLanEngrLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLocalUIAccessDeviceWeight;
  short* EngrWorkstation_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SSHServer_GainUserCredentialsWeight;
  short* SSHServer_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainUserCredentialsWeight;
  short* HMI_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLAN_PlaceRogueHostOnNetworkWeight;
  short* CorpLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLogicalAccessWeight;
  short* CorpLanEngrLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_PlaceRogueHostOnNetworkWeight;
  short* EngrLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_AdminModifyFWOpenWeight;
  short* EngrLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLogicalAccessWeight;
  short* LinuxOS_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* SCADALAN_PlaceRogueHostOnNetworkWeight;
  short* SCADALAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainRemoteUIAccessDeviceWeight;
  short* EngrWorkstation_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLogicalAccessWeight;
  short* EngrLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_CircumventFWRulesWeight;
  short* CorpLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* HMI_GainRemoteUIAccessDeviceWeight;
  short* HMI_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short* MakeDecision_Mobius_Mark;
  double* TheDistributionParameters;

  EngrLanScadaLanFW_GainLogicalAccessFailureStep();
  ~EngrLanScadaLanFW_GainLogicalAccessFailureStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  double timeDistributionParameter1();
  bool preconditionsMet();
  void executeEffects();
}; // EngrLanScadaLanFW_GainLogicalAccessFailureStep

class EngrLanScadaLanFW_GainLogicalAccessSuccessStep : public Step {
public:

  Access* EngrLanScadaLanFW_LogicalAccess;
  short* EngrLanScadaLanFW_LogicalAccess_Mobius_Mark;
  Access* EngrLanScadaLanFW_HasUserCredentials;
  short* EngrLanScadaLanFW_HasUserCredentials_Mobius_Mark;
  Access* EngrLanScadaLanFW_UIAccess;
  short* EngrLanScadaLanFW_UIAccess_Mobius_Mark;
  SystemSV<float>* EngrLanScadaLanFW_credentialMonitoring;
  float* EngrLanScadaLanFW_credentialMonitoring_Mobius_Mark;
  Skill* BasicCyberOffense;
  short* BasicCyberOffense_Mobius_Mark;
  SystemSV<float>* cyberAttackAttribution;
  float* cyberAttackAttribution_Mobius_Mark;
  SystemSV<char>* EngrLanScadaLanFW_userAuthenticationType;
  char* EngrLanScadaLanFW_userAuthenticationType_Mobius_Mark;
  StepChosen* EngrLanScadaLanFW_GainLogicalAccessChosen;
  short* EngrLanScadaLanFW_GainLogicalAccessChosen_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainUserCredentialsWeight;
  short* CorpLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainUserCredentialsWeight;
  short* LinuxOS_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_AdminModifyFWOpenWeight;
  short* CorpLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainRemoteUIAccessOSWeight;
  short* LinuxOS_GainRemoteUIAccessOSWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLocalUIAccessOSWeight;
  short* LinuxOS_GainLocalUIAccessOSWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLogicalAccessWeight;
  short* CorpLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* HMI_GainLocalUIAccessDeviceWeight;
  short* HMI_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_CircumventFWRulesWeight;
  short* EngrLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNetworkNodeWeight;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_CircumventFWRulesWeight;
  short* CorpLanEngrLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainUserCredentialsWeight;
  short* EngrLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* DoNothingWeight;
  short* DoNothingWeight_Mobius_Mark;
  StepWeight* SSHServer_GainLogicalAccessWeight;
  short* SSHServer_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainUserCredentialsWeight;
  short* CorpLanEngrLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainLogicalAccessWeight;
  short* HMI_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainUserCredentialsWeight;
  short* EngrWorkstation_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLogicalAccessWeight;
  short* EngrWorkstation_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_AdminModifyFWOpenWeight;
  short* CorpLanEngrLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLocalUIAccessDeviceWeight;
  short* EngrWorkstation_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SSHServer_GainUserCredentialsWeight;
  short* SSHServer_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainUserCredentialsWeight;
  short* HMI_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLAN_PlaceRogueHostOnNetworkWeight;
  short* CorpLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLogicalAccessWeight;
  short* CorpLanEngrLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_PlaceRogueHostOnNetworkWeight;
  short* EngrLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_AdminModifyFWOpenWeight;
  short* EngrLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLogicalAccessWeight;
  short* LinuxOS_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* SCADALAN_PlaceRogueHostOnNetworkWeight;
  short* SCADALAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainRemoteUIAccessDeviceWeight;
  short* EngrWorkstation_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLogicalAccessWeight;
  short* EngrLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_CircumventFWRulesWeight;
  short* CorpLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* HMI_GainRemoteUIAccessDeviceWeight;
  short* HMI_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short* MakeDecision_Mobius_Mark;
  double* TheDistributionParameters;

  EngrLanScadaLanFW_GainLogicalAccessSuccessStep();
  ~EngrLanScadaLanFW_GainLogicalAccessSuccessStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  double timeDistributionParameter1();
  bool preconditionsMet();
  void executeEffects();
}; // EngrLanScadaLanFW_GainLogicalAccessSuccessStep

class CorpLanScadaLanFW_CircumventFWRulesFailureStep : public Step {
public:

  Access* SCADALAN_NetworkAccess;
  short* SCADALAN_NetworkAccess_Mobius_Mark;
  Access* CorpLAN_NetworkAccess;
  short* CorpLAN_NetworkAccess_Mobius_Mark;
  Goal* Goal_GainNetworkAccessOnScadaNetwork;
  short* Goal_GainNetworkAccessOnScadaNetwork_Mobius_Mark;
  Knowledge* FirewallConfigKnowledge;
  short* FirewallConfigKnowledge_Mobius_Mark;
  SystemSV<float>* CorpLanScadaLanFW_firewallConfigControl;
  float* CorpLanScadaLanFW_firewallConfigControl_Mobius_Mark;
  SystemSV<float>* hourlyRateAdversary;
  float* hourlyRateAdversary_Mobius_Mark;
  Skill* NetworkPenetration;
  short* NetworkPenetration_Mobius_Mark;
  SystemSV<float>* cyberAttackAttribution;
  float* cyberAttackAttribution_Mobius_Mark;
  SystemSV<float>* SCADALAN_networkAnomalyResponseStrength;
  float* SCADALAN_networkAnomalyResponseStrength_Mobius_Mark;
  StepChosen* CorpLanScadaLanFW_CircumventFWRulesChosen;
  short* CorpLanScadaLanFW_CircumventFWRulesChosen_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainUserCredentialsWeight;
  short* CorpLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainUserCredentialsWeight;
  short* LinuxOS_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_AdminModifyFWOpenWeight;
  short* CorpLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainRemoteUIAccessOSWeight;
  short* LinuxOS_GainRemoteUIAccessOSWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLocalUIAccessOSWeight;
  short* LinuxOS_GainLocalUIAccessOSWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLogicalAccessWeight;
  short* CorpLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* HMI_GainLocalUIAccessDeviceWeight;
  short* HMI_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_CircumventFWRulesWeight;
  short* EngrLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNetworkNodeWeight;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_CircumventFWRulesWeight;
  short* CorpLanEngrLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainUserCredentialsWeight;
  short* EngrLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* DoNothingWeight;
  short* DoNothingWeight_Mobius_Mark;
  StepWeight* SSHServer_GainLogicalAccessWeight;
  short* SSHServer_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainUserCredentialsWeight;
  short* CorpLanEngrLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainLogicalAccessWeight;
  short* HMI_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainUserCredentialsWeight;
  short* EngrWorkstation_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLogicalAccessWeight;
  short* EngrWorkstation_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_AdminModifyFWOpenWeight;
  short* CorpLanEngrLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLocalUIAccessDeviceWeight;
  short* EngrWorkstation_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SSHServer_GainUserCredentialsWeight;
  short* SSHServer_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainUserCredentialsWeight;
  short* HMI_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLAN_PlaceRogueHostOnNetworkWeight;
  short* CorpLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLogicalAccessWeight;
  short* CorpLanEngrLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_PlaceRogueHostOnNetworkWeight;
  short* EngrLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_AdminModifyFWOpenWeight;
  short* EngrLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLogicalAccessWeight;
  short* LinuxOS_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* SCADALAN_PlaceRogueHostOnNetworkWeight;
  short* SCADALAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainRemoteUIAccessDeviceWeight;
  short* EngrWorkstation_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLogicalAccessWeight;
  short* EngrLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_CircumventFWRulesWeight;
  short* CorpLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* HMI_GainRemoteUIAccessDeviceWeight;
  short* HMI_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short* MakeDecision_Mobius_Mark;
  double* TheDistributionParameters;

  CorpLanScadaLanFW_CircumventFWRulesFailureStep();
  ~CorpLanScadaLanFW_CircumventFWRulesFailureStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  double timeDistributionParameter1();
  bool preconditionsMet();
  void executeEffects();
}; // CorpLanScadaLanFW_CircumventFWRulesFailureStep

class CorpLanScadaLanFW_CircumventFWRulesSuccessStep : public Step {
public:

  Access* SCADALAN_NetworkAccess;
  short* SCADALAN_NetworkAccess_Mobius_Mark;
  Access* CorpLAN_NetworkAccess;
  short* CorpLAN_NetworkAccess_Mobius_Mark;
  Goal* Goal_GainNetworkAccessOnScadaNetwork;
  short* Goal_GainNetworkAccessOnScadaNetwork_Mobius_Mark;
  Knowledge* FirewallConfigKnowledge;
  short* FirewallConfigKnowledge_Mobius_Mark;
  SystemSV<float>* CorpLanScadaLanFW_firewallConfigControl;
  float* CorpLanScadaLanFW_firewallConfigControl_Mobius_Mark;
  SystemSV<float>* hourlyRateAdversary;
  float* hourlyRateAdversary_Mobius_Mark;
  Skill* NetworkPenetration;
  short* NetworkPenetration_Mobius_Mark;
  SystemSV<float>* cyberAttackAttribution;
  float* cyberAttackAttribution_Mobius_Mark;
  SystemSV<float>* SCADALAN_networkAnomalyResponseStrength;
  float* SCADALAN_networkAnomalyResponseStrength_Mobius_Mark;
  StepChosen* CorpLanScadaLanFW_CircumventFWRulesChosen;
  short* CorpLanScadaLanFW_CircumventFWRulesChosen_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainUserCredentialsWeight;
  short* CorpLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainUserCredentialsWeight;
  short* LinuxOS_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_AdminModifyFWOpenWeight;
  short* CorpLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainRemoteUIAccessOSWeight;
  short* LinuxOS_GainRemoteUIAccessOSWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLocalUIAccessOSWeight;
  short* LinuxOS_GainLocalUIAccessOSWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLogicalAccessWeight;
  short* CorpLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* HMI_GainLocalUIAccessDeviceWeight;
  short* HMI_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_CircumventFWRulesWeight;
  short* EngrLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNetworkNodeWeight;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_CircumventFWRulesWeight;
  short* CorpLanEngrLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainUserCredentialsWeight;
  short* EngrLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* DoNothingWeight;
  short* DoNothingWeight_Mobius_Mark;
  StepWeight* SSHServer_GainLogicalAccessWeight;
  short* SSHServer_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainUserCredentialsWeight;
  short* CorpLanEngrLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainLogicalAccessWeight;
  short* HMI_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainUserCredentialsWeight;
  short* EngrWorkstation_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLogicalAccessWeight;
  short* EngrWorkstation_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_AdminModifyFWOpenWeight;
  short* CorpLanEngrLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLocalUIAccessDeviceWeight;
  short* EngrWorkstation_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SSHServer_GainUserCredentialsWeight;
  short* SSHServer_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainUserCredentialsWeight;
  short* HMI_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLAN_PlaceRogueHostOnNetworkWeight;
  short* CorpLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLogicalAccessWeight;
  short* CorpLanEngrLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_PlaceRogueHostOnNetworkWeight;
  short* EngrLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_AdminModifyFWOpenWeight;
  short* EngrLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLogicalAccessWeight;
  short* LinuxOS_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* SCADALAN_PlaceRogueHostOnNetworkWeight;
  short* SCADALAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainRemoteUIAccessDeviceWeight;
  short* EngrWorkstation_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLogicalAccessWeight;
  short* EngrLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_CircumventFWRulesWeight;
  short* CorpLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* HMI_GainRemoteUIAccessDeviceWeight;
  short* HMI_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short* MakeDecision_Mobius_Mark;
  double* TheDistributionParameters;

  CorpLanScadaLanFW_CircumventFWRulesSuccessStep();
  ~CorpLanScadaLanFW_CircumventFWRulesSuccessStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  double timeDistributionParameter1();
  bool preconditionsMet();
  void executeEffects();
}; // CorpLanScadaLanFW_CircumventFWRulesSuccessStep

class HMI_GainRemoteUIAccessDeviceFailureStep : public Step {
public:

  Access* HMI_UIAccess;
  short* HMI_UIAccess_Mobius_Mark;
  Skill* HMI_SpecializedTechnicalHardwareExpertise;
  short* HMI_SpecializedTechnicalHardwareExpertise_Mobius_Mark;
  Skill* BasicCyberOffense;
  short* BasicCyberOffense_Mobius_Mark;
  Skill* NetworkPenetration;
  short* NetworkPenetration_Mobius_Mark;
  SystemSV<float>* cyberAttackAttribution;
  float* cyberAttackAttribution_Mobius_Mark;
  Access* SCADALAN_NetworkAccess;
  short* SCADALAN_NetworkAccess_Mobius_Mark;
  SystemSV<float>* SCADALAN_networkAnomalyDetectionStrength;
  float* SCADALAN_networkAnomalyDetectionStrength_Mobius_Mark;
  StepChosen* HMI_GainRemoteUIAccessDeviceChosen;
  short* HMI_GainRemoteUIAccessDeviceChosen_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainUserCredentialsWeight;
  short* CorpLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainUserCredentialsWeight;
  short* LinuxOS_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_AdminModifyFWOpenWeight;
  short* CorpLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainRemoteUIAccessOSWeight;
  short* LinuxOS_GainRemoteUIAccessOSWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLocalUIAccessOSWeight;
  short* LinuxOS_GainLocalUIAccessOSWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLogicalAccessWeight;
  short* CorpLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* HMI_GainLocalUIAccessDeviceWeight;
  short* HMI_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_CircumventFWRulesWeight;
  short* EngrLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNetworkNodeWeight;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_CircumventFWRulesWeight;
  short* CorpLanEngrLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainUserCredentialsWeight;
  short* EngrLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* DoNothingWeight;
  short* DoNothingWeight_Mobius_Mark;
  StepWeight* SSHServer_GainLogicalAccessWeight;
  short* SSHServer_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainUserCredentialsWeight;
  short* CorpLanEngrLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainLogicalAccessWeight;
  short* HMI_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainUserCredentialsWeight;
  short* EngrWorkstation_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLogicalAccessWeight;
  short* EngrWorkstation_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_AdminModifyFWOpenWeight;
  short* CorpLanEngrLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLocalUIAccessDeviceWeight;
  short* EngrWorkstation_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SSHServer_GainUserCredentialsWeight;
  short* SSHServer_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainUserCredentialsWeight;
  short* HMI_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLAN_PlaceRogueHostOnNetworkWeight;
  short* CorpLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLogicalAccessWeight;
  short* CorpLanEngrLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_PlaceRogueHostOnNetworkWeight;
  short* EngrLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_AdminModifyFWOpenWeight;
  short* EngrLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLogicalAccessWeight;
  short* LinuxOS_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* SCADALAN_PlaceRogueHostOnNetworkWeight;
  short* SCADALAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainRemoteUIAccessDeviceWeight;
  short* EngrWorkstation_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLogicalAccessWeight;
  short* EngrLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_CircumventFWRulesWeight;
  short* CorpLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* HMI_GainRemoteUIAccessDeviceWeight;
  short* HMI_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short* MakeDecision_Mobius_Mark;
  double* TheDistributionParameters;

  HMI_GainRemoteUIAccessDeviceFailureStep();
  ~HMI_GainRemoteUIAccessDeviceFailureStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  double timeDistributionParameter1();
  bool preconditionsMet();
  void executeEffects();
}; // HMI_GainRemoteUIAccessDeviceFailureStep

class HMI_GainRemoteUIAccessDeviceSuccessStep : public Step {
public:

  Access* HMI_UIAccess;
  short* HMI_UIAccess_Mobius_Mark;
  Skill* HMI_SpecializedTechnicalHardwareExpertise;
  short* HMI_SpecializedTechnicalHardwareExpertise_Mobius_Mark;
  Skill* BasicCyberOffense;
  short* BasicCyberOffense_Mobius_Mark;
  Skill* NetworkPenetration;
  short* NetworkPenetration_Mobius_Mark;
  SystemSV<float>* cyberAttackAttribution;
  float* cyberAttackAttribution_Mobius_Mark;
  Access* SCADALAN_NetworkAccess;
  short* SCADALAN_NetworkAccess_Mobius_Mark;
  SystemSV<float>* SCADALAN_networkAnomalyDetectionStrength;
  float* SCADALAN_networkAnomalyDetectionStrength_Mobius_Mark;
  StepChosen* HMI_GainRemoteUIAccessDeviceChosen;
  short* HMI_GainRemoteUIAccessDeviceChosen_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainUserCredentialsWeight;
  short* CorpLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainUserCredentialsWeight;
  short* LinuxOS_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_AdminModifyFWOpenWeight;
  short* CorpLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainRemoteUIAccessOSWeight;
  short* LinuxOS_GainRemoteUIAccessOSWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLocalUIAccessOSWeight;
  short* LinuxOS_GainLocalUIAccessOSWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLogicalAccessWeight;
  short* CorpLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* HMI_GainLocalUIAccessDeviceWeight;
  short* HMI_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_CircumventFWRulesWeight;
  short* EngrLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNetworkNodeWeight;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_CircumventFWRulesWeight;
  short* CorpLanEngrLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainUserCredentialsWeight;
  short* EngrLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* DoNothingWeight;
  short* DoNothingWeight_Mobius_Mark;
  StepWeight* SSHServer_GainLogicalAccessWeight;
  short* SSHServer_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainUserCredentialsWeight;
  short* CorpLanEngrLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainLogicalAccessWeight;
  short* HMI_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainUserCredentialsWeight;
  short* EngrWorkstation_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLogicalAccessWeight;
  short* EngrWorkstation_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_AdminModifyFWOpenWeight;
  short* CorpLanEngrLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLocalUIAccessDeviceWeight;
  short* EngrWorkstation_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SSHServer_GainUserCredentialsWeight;
  short* SSHServer_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainUserCredentialsWeight;
  short* HMI_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLAN_PlaceRogueHostOnNetworkWeight;
  short* CorpLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLogicalAccessWeight;
  short* CorpLanEngrLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_PlaceRogueHostOnNetworkWeight;
  short* EngrLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_AdminModifyFWOpenWeight;
  short* EngrLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLogicalAccessWeight;
  short* LinuxOS_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* SCADALAN_PlaceRogueHostOnNetworkWeight;
  short* SCADALAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainRemoteUIAccessDeviceWeight;
  short* EngrWorkstation_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLogicalAccessWeight;
  short* EngrLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_CircumventFWRulesWeight;
  short* CorpLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* HMI_GainRemoteUIAccessDeviceWeight;
  short* HMI_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short* MakeDecision_Mobius_Mark;
  double* TheDistributionParameters;

  HMI_GainRemoteUIAccessDeviceSuccessStep();
  ~HMI_GainRemoteUIAccessDeviceSuccessStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  double timeDistributionParameter1();
  bool preconditionsMet();
  void executeEffects();
}; // HMI_GainRemoteUIAccessDeviceSuccessStep

class SCADALAN_GainNetworkAccessViaConnectedNetworkFailureStep : public Step {
public:

  Access* SCADALAN_NetworkAccess;
  short* SCADALAN_NetworkAccess_Mobius_Mark;
  Goal* Goal_GainNetworkAccessOnScadaNetwork;
  short* Goal_GainNetworkAccessOnScadaNetwork_Mobius_Mark;
  Skill* NetworkPenetration;
  short* NetworkPenetration_Mobius_Mark;
  SystemSV<float>* SCADALAN_networkAnomalyDetectionStrength;
  float* SCADALAN_networkAnomalyDetectionStrength_Mobius_Mark;
  SystemSV<float>* cyberAttackAttribution;
  float* cyberAttackAttribution_Mobius_Mark;
  StepChosen* SCADALAN_GainNetworkAccessViaConnectedNetworkChosen;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkChosen_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainUserCredentialsWeight;
  short* CorpLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainUserCredentialsWeight;
  short* LinuxOS_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_AdminModifyFWOpenWeight;
  short* CorpLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainRemoteUIAccessOSWeight;
  short* LinuxOS_GainRemoteUIAccessOSWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLocalUIAccessOSWeight;
  short* LinuxOS_GainLocalUIAccessOSWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLogicalAccessWeight;
  short* CorpLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* HMI_GainLocalUIAccessDeviceWeight;
  short* HMI_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_CircumventFWRulesWeight;
  short* EngrLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNetworkNodeWeight;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_CircumventFWRulesWeight;
  short* CorpLanEngrLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainUserCredentialsWeight;
  short* EngrLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* DoNothingWeight;
  short* DoNothingWeight_Mobius_Mark;
  StepWeight* SSHServer_GainLogicalAccessWeight;
  short* SSHServer_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainUserCredentialsWeight;
  short* CorpLanEngrLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainLogicalAccessWeight;
  short* HMI_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainUserCredentialsWeight;
  short* EngrWorkstation_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLogicalAccessWeight;
  short* EngrWorkstation_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_AdminModifyFWOpenWeight;
  short* CorpLanEngrLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLocalUIAccessDeviceWeight;
  short* EngrWorkstation_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SSHServer_GainUserCredentialsWeight;
  short* SSHServer_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainUserCredentialsWeight;
  short* HMI_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLAN_PlaceRogueHostOnNetworkWeight;
  short* CorpLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLogicalAccessWeight;
  short* CorpLanEngrLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_PlaceRogueHostOnNetworkWeight;
  short* EngrLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_AdminModifyFWOpenWeight;
  short* EngrLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLogicalAccessWeight;
  short* LinuxOS_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* SCADALAN_PlaceRogueHostOnNetworkWeight;
  short* SCADALAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainRemoteUIAccessDeviceWeight;
  short* EngrWorkstation_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLogicalAccessWeight;
  short* EngrLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_CircumventFWRulesWeight;
  short* CorpLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* HMI_GainRemoteUIAccessDeviceWeight;
  short* HMI_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short* MakeDecision_Mobius_Mark;
  double* TheDistributionParameters;

  SCADALAN_GainNetworkAccessViaConnectedNetworkFailureStep();
  ~SCADALAN_GainNetworkAccessViaConnectedNetworkFailureStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  double timeDistributionParameter1();
  bool preconditionsMet();
  void executeEffects();
}; // SCADALAN_GainNetworkAccessViaConnectedNetworkFailureStep

class SCADALAN_GainNetworkAccessViaConnectedNetworkSuccessStep : public Step {
public:

  Access* SCADALAN_NetworkAccess;
  short* SCADALAN_NetworkAccess_Mobius_Mark;
  Goal* Goal_GainNetworkAccessOnScadaNetwork;
  short* Goal_GainNetworkAccessOnScadaNetwork_Mobius_Mark;
  Skill* NetworkPenetration;
  short* NetworkPenetration_Mobius_Mark;
  SystemSV<float>* SCADALAN_networkAnomalyDetectionStrength;
  float* SCADALAN_networkAnomalyDetectionStrength_Mobius_Mark;
  SystemSV<float>* cyberAttackAttribution;
  float* cyberAttackAttribution_Mobius_Mark;
  StepChosen* SCADALAN_GainNetworkAccessViaConnectedNetworkChosen;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkChosen_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainUserCredentialsWeight;
  short* CorpLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainUserCredentialsWeight;
  short* LinuxOS_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_AdminModifyFWOpenWeight;
  short* CorpLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainRemoteUIAccessOSWeight;
  short* LinuxOS_GainRemoteUIAccessOSWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLocalUIAccessOSWeight;
  short* LinuxOS_GainLocalUIAccessOSWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLogicalAccessWeight;
  short* CorpLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* HMI_GainLocalUIAccessDeviceWeight;
  short* HMI_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_CircumventFWRulesWeight;
  short* EngrLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNetworkNodeWeight;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_CircumventFWRulesWeight;
  short* CorpLanEngrLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainUserCredentialsWeight;
  short* EngrLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* DoNothingWeight;
  short* DoNothingWeight_Mobius_Mark;
  StepWeight* SSHServer_GainLogicalAccessWeight;
  short* SSHServer_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainUserCredentialsWeight;
  short* CorpLanEngrLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainLogicalAccessWeight;
  short* HMI_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainUserCredentialsWeight;
  short* EngrWorkstation_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLogicalAccessWeight;
  short* EngrWorkstation_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_AdminModifyFWOpenWeight;
  short* CorpLanEngrLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLocalUIAccessDeviceWeight;
  short* EngrWorkstation_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SSHServer_GainUserCredentialsWeight;
  short* SSHServer_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainUserCredentialsWeight;
  short* HMI_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLAN_PlaceRogueHostOnNetworkWeight;
  short* CorpLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLogicalAccessWeight;
  short* CorpLanEngrLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_PlaceRogueHostOnNetworkWeight;
  short* EngrLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_AdminModifyFWOpenWeight;
  short* EngrLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLogicalAccessWeight;
  short* LinuxOS_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* SCADALAN_PlaceRogueHostOnNetworkWeight;
  short* SCADALAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainRemoteUIAccessDeviceWeight;
  short* EngrWorkstation_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLogicalAccessWeight;
  short* EngrLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_CircumventFWRulesWeight;
  short* CorpLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* HMI_GainRemoteUIAccessDeviceWeight;
  short* HMI_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short* MakeDecision_Mobius_Mark;
  double* TheDistributionParameters;

  SCADALAN_GainNetworkAccessViaConnectedNetworkSuccessStep();
  ~SCADALAN_GainNetworkAccessViaConnectedNetworkSuccessStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  double timeDistributionParameter1();
  bool preconditionsMet();
  void executeEffects();
}; // SCADALAN_GainNetworkAccessViaConnectedNetworkSuccessStep

class CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkFailureStep : public Step {
public:

  Access* CorpLAN_NetworkAccess;
  short* CorpLAN_NetworkAccess_Mobius_Mark;
  Skill* NetworkPenetration;
  short* NetworkPenetration_Mobius_Mark;
  SystemSV<float>* CorpLAN_networkAnomalyDetectionStrength;
  float* CorpLAN_networkAnomalyDetectionStrength_Mobius_Mark;
  SystemSV<float>* cyberAttackAttribution;
  float* cyberAttackAttribution_Mobius_Mark;
  StepChosen* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkChosen;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkChosen_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainUserCredentialsWeight;
  short* CorpLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainUserCredentialsWeight;
  short* LinuxOS_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_AdminModifyFWOpenWeight;
  short* CorpLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainRemoteUIAccessOSWeight;
  short* LinuxOS_GainRemoteUIAccessOSWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLocalUIAccessOSWeight;
  short* LinuxOS_GainLocalUIAccessOSWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLogicalAccessWeight;
  short* CorpLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* HMI_GainLocalUIAccessDeviceWeight;
  short* HMI_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_CircumventFWRulesWeight;
  short* EngrLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNetworkNodeWeight;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_CircumventFWRulesWeight;
  short* CorpLanEngrLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainUserCredentialsWeight;
  short* EngrLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* DoNothingWeight;
  short* DoNothingWeight_Mobius_Mark;
  StepWeight* SSHServer_GainLogicalAccessWeight;
  short* SSHServer_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainUserCredentialsWeight;
  short* CorpLanEngrLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainLogicalAccessWeight;
  short* HMI_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainUserCredentialsWeight;
  short* EngrWorkstation_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLogicalAccessWeight;
  short* EngrWorkstation_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_AdminModifyFWOpenWeight;
  short* CorpLanEngrLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLocalUIAccessDeviceWeight;
  short* EngrWorkstation_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SSHServer_GainUserCredentialsWeight;
  short* SSHServer_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainUserCredentialsWeight;
  short* HMI_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLAN_PlaceRogueHostOnNetworkWeight;
  short* CorpLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLogicalAccessWeight;
  short* CorpLanEngrLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_PlaceRogueHostOnNetworkWeight;
  short* EngrLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_AdminModifyFWOpenWeight;
  short* EngrLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLogicalAccessWeight;
  short* LinuxOS_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* SCADALAN_PlaceRogueHostOnNetworkWeight;
  short* SCADALAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainRemoteUIAccessDeviceWeight;
  short* EngrWorkstation_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLogicalAccessWeight;
  short* EngrLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_CircumventFWRulesWeight;
  short* CorpLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* HMI_GainRemoteUIAccessDeviceWeight;
  short* HMI_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short* MakeDecision_Mobius_Mark;
  double* TheDistributionParameters;

  CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkFailureStep();
  ~CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkFailureStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  double timeDistributionParameter1();
  bool preconditionsMet();
  void executeEffects();
}; // CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkFailureStep

class CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkSuccessStep : public Step {
public:

  Access* CorpLAN_NetworkAccess;
  short* CorpLAN_NetworkAccess_Mobius_Mark;
  Skill* NetworkPenetration;
  short* NetworkPenetration_Mobius_Mark;
  SystemSV<float>* CorpLAN_networkAnomalyDetectionStrength;
  float* CorpLAN_networkAnomalyDetectionStrength_Mobius_Mark;
  SystemSV<float>* cyberAttackAttribution;
  float* cyberAttackAttribution_Mobius_Mark;
  StepChosen* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkChosen;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkChosen_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainUserCredentialsWeight;
  short* CorpLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainUserCredentialsWeight;
  short* LinuxOS_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_AdminModifyFWOpenWeight;
  short* CorpLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainRemoteUIAccessOSWeight;
  short* LinuxOS_GainRemoteUIAccessOSWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLocalUIAccessOSWeight;
  short* LinuxOS_GainLocalUIAccessOSWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLogicalAccessWeight;
  short* CorpLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* HMI_GainLocalUIAccessDeviceWeight;
  short* HMI_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_CircumventFWRulesWeight;
  short* EngrLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNetworkNodeWeight;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_CircumventFWRulesWeight;
  short* CorpLanEngrLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainUserCredentialsWeight;
  short* EngrLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* DoNothingWeight;
  short* DoNothingWeight_Mobius_Mark;
  StepWeight* SSHServer_GainLogicalAccessWeight;
  short* SSHServer_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainUserCredentialsWeight;
  short* CorpLanEngrLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainLogicalAccessWeight;
  short* HMI_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainUserCredentialsWeight;
  short* EngrWorkstation_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLogicalAccessWeight;
  short* EngrWorkstation_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_AdminModifyFWOpenWeight;
  short* CorpLanEngrLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLocalUIAccessDeviceWeight;
  short* EngrWorkstation_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SSHServer_GainUserCredentialsWeight;
  short* SSHServer_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainUserCredentialsWeight;
  short* HMI_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLAN_PlaceRogueHostOnNetworkWeight;
  short* CorpLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLogicalAccessWeight;
  short* CorpLanEngrLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_PlaceRogueHostOnNetworkWeight;
  short* EngrLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_AdminModifyFWOpenWeight;
  short* EngrLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLogicalAccessWeight;
  short* LinuxOS_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* SCADALAN_PlaceRogueHostOnNetworkWeight;
  short* SCADALAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainRemoteUIAccessDeviceWeight;
  short* EngrWorkstation_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLogicalAccessWeight;
  short* EngrLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_CircumventFWRulesWeight;
  short* CorpLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* HMI_GainRemoteUIAccessDeviceWeight;
  short* HMI_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short* MakeDecision_Mobius_Mark;
  double* TheDistributionParameters;

  CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkSuccessStep();
  ~CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkSuccessStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  double timeDistributionParameter1();
  bool preconditionsMet();
  void executeEffects();
}; // CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkSuccessStep

class CorpLanScadaLanFW_GainLocalUIAccessDeviceFailureStep : public Step {
public:

  Access* CorpLanScadaLanFW_UIAccess;
  short* CorpLanScadaLanFW_UIAccess_Mobius_Mark;
  Access* CorpLanScadaLanFW_LogicalAccess;
  short* CorpLanScadaLanFW_LogicalAccess_Mobius_Mark;
  Access* CorpLanScadaLanFW_PhysicalAccess;
  short* CorpLanScadaLanFW_PhysicalAccess_Mobius_Mark;
  SystemSV<char>* CorpLanScadaLanFW_userAuthenticationType;
  char* CorpLanScadaLanFW_userAuthenticationType_Mobius_Mark;
  Skill* KineticEquipmentAttack;
  short* KineticEquipmentAttack_Mobius_Mark;
  SystemSV<float>* CorpLanScadaLanFW_physicalAttackAttribution;
  float* CorpLanScadaLanFW_physicalAttackAttribution_Mobius_Mark;
  StepChosen* CorpLanScadaLanFW_GainLocalUIAccessDeviceChosen;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceChosen_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainUserCredentialsWeight;
  short* CorpLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainUserCredentialsWeight;
  short* LinuxOS_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_AdminModifyFWOpenWeight;
  short* CorpLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainRemoteUIAccessOSWeight;
  short* LinuxOS_GainRemoteUIAccessOSWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLocalUIAccessOSWeight;
  short* LinuxOS_GainLocalUIAccessOSWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLogicalAccessWeight;
  short* CorpLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* HMI_GainLocalUIAccessDeviceWeight;
  short* HMI_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_CircumventFWRulesWeight;
  short* EngrLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNetworkNodeWeight;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_CircumventFWRulesWeight;
  short* CorpLanEngrLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainUserCredentialsWeight;
  short* EngrLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* DoNothingWeight;
  short* DoNothingWeight_Mobius_Mark;
  StepWeight* SSHServer_GainLogicalAccessWeight;
  short* SSHServer_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainUserCredentialsWeight;
  short* CorpLanEngrLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainLogicalAccessWeight;
  short* HMI_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainUserCredentialsWeight;
  short* EngrWorkstation_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLogicalAccessWeight;
  short* EngrWorkstation_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_AdminModifyFWOpenWeight;
  short* CorpLanEngrLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLocalUIAccessDeviceWeight;
  short* EngrWorkstation_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SSHServer_GainUserCredentialsWeight;
  short* SSHServer_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainUserCredentialsWeight;
  short* HMI_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLAN_PlaceRogueHostOnNetworkWeight;
  short* CorpLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLogicalAccessWeight;
  short* CorpLanEngrLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_PlaceRogueHostOnNetworkWeight;
  short* EngrLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_AdminModifyFWOpenWeight;
  short* EngrLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLogicalAccessWeight;
  short* LinuxOS_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* SCADALAN_PlaceRogueHostOnNetworkWeight;
  short* SCADALAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainRemoteUIAccessDeviceWeight;
  short* EngrWorkstation_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLogicalAccessWeight;
  short* EngrLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_CircumventFWRulesWeight;
  short* CorpLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* HMI_GainRemoteUIAccessDeviceWeight;
  short* HMI_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short* MakeDecision_Mobius_Mark;
  double* TheDistributionParameters;

  CorpLanScadaLanFW_GainLocalUIAccessDeviceFailureStep();
  ~CorpLanScadaLanFW_GainLocalUIAccessDeviceFailureStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  double timeDistributionParameter1();
  bool preconditionsMet();
  void executeEffects();
}; // CorpLanScadaLanFW_GainLocalUIAccessDeviceFailureStep

class CorpLanScadaLanFW_GainLocalUIAccessDeviceSuccessStep : public Step {
public:

  Access* CorpLanScadaLanFW_UIAccess;
  short* CorpLanScadaLanFW_UIAccess_Mobius_Mark;
  Access* CorpLanScadaLanFW_LogicalAccess;
  short* CorpLanScadaLanFW_LogicalAccess_Mobius_Mark;
  Access* CorpLanScadaLanFW_PhysicalAccess;
  short* CorpLanScadaLanFW_PhysicalAccess_Mobius_Mark;
  SystemSV<char>* CorpLanScadaLanFW_userAuthenticationType;
  char* CorpLanScadaLanFW_userAuthenticationType_Mobius_Mark;
  Skill* KineticEquipmentAttack;
  short* KineticEquipmentAttack_Mobius_Mark;
  SystemSV<float>* CorpLanScadaLanFW_physicalAttackAttribution;
  float* CorpLanScadaLanFW_physicalAttackAttribution_Mobius_Mark;
  StepChosen* CorpLanScadaLanFW_GainLocalUIAccessDeviceChosen;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceChosen_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* CorpLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainUserCredentialsWeight;
  short* CorpLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainUserCredentialsWeight;
  short* LinuxOS_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_AdminModifyFWOpenWeight;
  short* CorpLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainRemoteUIAccessOSWeight;
  short* LinuxOS_GainRemoteUIAccessOSWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLocalUIAccessOSWeight;
  short* LinuxOS_GainLocalUIAccessOSWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLogicalAccessWeight;
  short* CorpLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* HMI_GainLocalUIAccessDeviceWeight;
  short* HMI_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_CircumventFWRulesWeight;
  short* EngrLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaNetworkNodeWeight;
  short* SCADALAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_CircumventFWRulesWeight;
  short* CorpLanEngrLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainUserCredentialsWeight;
  short* EngrLanScadaLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* DoNothingWeight;
  short* DoNothingWeight_Mobius_Mark;
  StepWeight* SSHServer_GainLogicalAccessWeight;
  short* SSHServer_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainUserCredentialsWeight;
  short* CorpLanEngrLanFW_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainLogicalAccessWeight;
  short* HMI_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainUserCredentialsWeight;
  short* EngrWorkstation_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* EngrLAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLogicalAccessWeight;
  short* EngrWorkstation_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_AdminModifyFWOpenWeight;
  short* CorpLanEngrLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainLocalUIAccessDeviceWeight;
  short* EngrWorkstation_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SSHServer_GainUserCredentialsWeight;
  short* SSHServer_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* HMI_GainUserCredentialsWeight;
  short* HMI_GainUserCredentialsWeight_Mobius_Mark;
  StepWeight* CorpLAN_PlaceRogueHostOnNetworkWeight;
  short* CorpLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanEngrLanFW_GainLogicalAccessWeight;
  short* CorpLanEngrLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLAN_PlaceRogueHostOnNetworkWeight;
  short* EngrLAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_AdminModifyFWOpenWeight;
  short* EngrLanScadaLanFW_AdminModifyFWOpenWeight_Mobius_Mark;
  StepWeight* EngrLAN_GainNetworkAccessViaNetworkNodeWeight;
  short* EngrLAN_GainNetworkAccessViaNetworkNodeWeight_Mobius_Mark;
  StepWeight* LinuxOS_GainLogicalAccessWeight;
  short* LinuxOS_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* SCADALAN_PlaceRogueHostOnNetworkWeight;
  short* SCADALAN_PlaceRogueHostOnNetworkWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrWorkstation_GainRemoteUIAccessDeviceWeight;
  short* EngrWorkstation_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* EngrLanScadaLanFW_GainLogicalAccessWeight;
  short* EngrLanScadaLanFW_GainLogicalAccessWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_CircumventFWRulesWeight;
  short* CorpLanScadaLanFW_CircumventFWRulesWeight_Mobius_Mark;
  StepWeight* HMI_GainRemoteUIAccessDeviceWeight;
  short* HMI_GainRemoteUIAccessDeviceWeight_Mobius_Mark;
  StepWeight* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight;
  short* SCADALAN_GainNetworkAccessViaConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  short* CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight_Mobius_Mark;
  StepWeight* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  short* CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight_Mobius_Mark;
  BeginAdversaryDecision *MakeDecision;
  short* MakeDecision_Mobius_Mark;
  double* TheDistributionParameters;

  CorpLanScadaLanFW_GainLocalUIAccessDeviceSuccessStep();
  ~CorpLanScadaLanFW_GainLocalUIAccessDeviceSuccessStep();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  double getCost();
  double getOutcomeProbability();
  double getDetection();
  int Rank();
  double timeDistributionParameter0();
  double timeDistributionParameter1();
  bool preconditionsMet();
  void executeEffects();
}; // CorpLanScadaLanFW_GainLocalUIAccessDeviceSuccessStep

  //List of user-specified state variables
  Access *EngrLanScadaLanFW_LogicalAccess;
  Access *LinuxOS_HasUserCredentials;
  Access *CorpLanEngrLanFW_HasUserCredentials;
  Access *HMI_PhysicalAccess;
  Access *CorpLanEngrLanFW_PhysicalAccess;
  Access *CorpLanScadaLanFW_HasUserCredentials;
  Access *EngrLanScadaLanFW_UIAccess;
  Access *SSHServer_HasUserCredentials;
  Access *LinuxOS_LogicalAccess;
  Access *SCADALAN_PhysicalAccess;
  Access *HMI_UIAccess;
  Access *InsiderAccess;
  Access *SSHServer_LogicalAccess;
  Access *CorpLanEngrLanFW_UIAccess;
  Access *CorpLanEngrLanFW_LogicalAccess;
  Access *SCADALAN_NetworkAccess;
  Access *HMI_LogicalAccess;
  Access *CorpLAN_NetworkAccess;
  Access *CorpLanScadaLanFW_UIAccess;
  Access *EngrWorkstation_HasUserCredentials;
  Access *EngrLanScadaLanFW_HasUserCredentials;
  Access *EngrWorkstation_PhysicalAccess;
  Access *EngrLAN_NetworkAccess;
  Access *LinuxOS_UIAccess;
  Access *EngrLanScadaLanFW_PhysicalAccess;
  Access *CorpLanScadaLanFW_PhysicalAccess;
  Access *SSHServer_UIAccess;
  Access *CorpLAN_PhysicalAccess;
  Access *HMI_HasUserCredentials;
  Access *EngrWorkstation_UIAccess;
  Access *EngrLAN_PhysicalAccess;
  Access *CorpLanScadaLanFW_LogicalAccess;
  Access *EngrWorkstation_LogicalAccess;
  Knowledge *CorpLanEngrLanFW_FirewallConfigKnowledge;
  Knowledge *FirewallConfigKnowledge;
  Knowledge *EngrLanScadaLanFW_FirewallConfigKnowledge;
  Knowledge *CorpLanScadaLanFW_FirewallConfigKnowledge;
  Skill *CorpLanScadaLanFW_SpecializedTechnicalHardwareExpertise;
  Skill *CorpLanEngrLanFW_SpecializedTechnicalExpertise;
  Skill *EngrWorkstation_SpecializedTechnicalHardwareExpertise;
  Skill *EngrLanScadaLanFW_SpecializedTechnicalHardwareExpertise;
  Skill *CorpLanScadaLanFW_SpecializedTechnicalExpertise;
  Skill *HMI_SpecializedTechnicalHardwareExpertise;
  Skill *NetworkPenetration;
  Skill *KineticEquipmentAttack;
  Skill *CorpLanEngrLanFW_SpecializedTechnicalHardwareExpertise;
  Skill *EngrLanScadaLanFW_SpecializedTechnicalExpertise;
  Skill *BasicCyberOffense;
  Goal *Goal_GainNetworkAccessOnScadaNetwork;
  SystemSV<char> *SSHServer_userAuthenticationType;
  SystemSV<float> *HMI_strengthOfUserAuthentication;
  SystemSV<float> *CorpLanEngrLanFW_firewallConfigDetection;
  SystemSV<float> *LinuxOS_strengthOfUserAuthentication;
  SystemSV<char> *EngrLanScadaLanFW_userAuthenticationType;
  SystemSV<float> *CorpLAN_networkAnomalyResponseStrength;
  SystemSV<float> *CorpLanScadaLanFW_credentialMonitoring;
  SystemSV<float> *SCADALAN_physicalAttackAttribution;
  SystemSV<float> *CorpLAN_rogueDeviceDetection;
  SystemSV<float> *EngrWorkstation_strengthOfUserAuthentication;
  SystemSV<char> *HMI_userAuthenticationType;
  SystemSV<char> *LinuxOS_userAuthenticationType;
  SystemSV<float> *CorpLAN_physicalAttackAttribution;
  SystemSV<float> *EngrLanScadaLanFW_strengthOfUserAuthentication;
  SystemSV<float> *EngrLAN_networkAnomalyDetectionStrength;
  SystemSV<float> *EngrLAN_physicalNetworkProtection;
  SystemSV<bool> *EngrLAN_networkWhiteList;
  SystemSV<float> *CorpLanEngrLanFW_strengthOfUserAuthentication;
  SystemSV<float> *CorpLanScadaLanFW_strengthOfUserAuthentication;
  SystemSV<float> *SSHServer_strengthOfUserAuthentication;
  SystemSV<float> *HMI_credentialMonitoring;
  SystemSV<float> *EngrWorkstation_credentialMonitoring;
  SystemSV<float> *SSHServer_credentialMonitoring;
  SystemSV<float> *SCADALAN_rogueDeviceControl;
  SystemSV<bool> *CorpLAN_networkWhiteList;
  SystemSV<float> *SCADALAN_networkAnomalyResponseStrength;
  SystemSV<float> *EngrLAN_rogueDeviceDetection;
  SystemSV<float> *CorpLanEngrLanFW_physicalAttackAttribution;
  SystemSV<float> *EngrLanScadaLanFW_firewallConfigControl;
  SystemSV<float> *CorpLAN_networkAnomalyDetectionStrength;
  SystemSV<float> *SCADALAN_rogueDeviceDetection;
  SystemSV<float> *LinuxOS_credentialMonitoring;
  SystemSV<float> *EngrLAN_rogueDeviceControl;
  SystemSV<float> *hourlyRateAdversary;
  SystemSV<char> *CorpLanScadaLanFW_userAuthenticationType;
  SystemSV<float> *CorpLanEngrLanFW_credentialMonitoring;
  SystemSV<float> *CorpLanScadaLanFW_physicalAttackAttribution;
  SystemSV<float> *HMI_physicalAttackAttribution;
  SystemSV<float> *LinuxOS_remoteAccessHardening;
  SystemSV<float> *SCADALAN_physicalNetworkProtection;
  SystemSV<bool> *SCADALAN_networkWhiteList;
  SystemSV<float> *EngrLanScadaLanFW_firewallConfigDetection;
  SystemSV<float> *EngrLAN_networkAnomalyResponseStrength;
  SystemSV<float> *CorpLAN_rogueDeviceControl;
  SystemSV<float> *EngrLanScadaLanFW_credentialMonitoring;
  SystemSV<float> *EngrWorkstation_physicalAttackAttribution;
  SystemSV<char> *CorpLanEngrLanFW_userAuthenticationType;
  SystemSV<float> *EngrLAN_physicalAttackAttribution;
  SystemSV<float> *CorpLanEngrLanFW_firewallConfigControl;
  SystemSV<float> *CorpLAN_physicalNetworkProtection;
  SystemSV<float> *EngrLanScadaLanFW_physicalAttackAttribution;
  SystemSV<float> *cyberAttackAttribution;
  SystemSV<float> *CorpLanScadaLanFW_firewallConfigDetection;
  SystemSV<float> *SCADALAN_networkAnomalyDetectionStrength;
  SystemSV<char> *EngrWorkstation_userAuthenticationType;
  SystemSV<float> *CorpLanScadaLanFW_firewallConfigControl;
  //List of attack step weight state variables
  StepWeight *CorpLAN_GainNetworkAccessViaNetworkNodeWeight;
  StepWeight *CorpLanScadaLanFW_GainUserCredentialsWeight;
  StepWeight *CorpLanEngrLanFW_GainRemoteUIAccessDeviceWeight;
  StepWeight *LinuxOS_GainUserCredentialsWeight;
  StepWeight *CorpLanScadaLanFW_AdminModifyFWOpenWeight;
  StepWeight *CorpLAN_GainNetworkAccessViaConnectedNetworkWeight;
  StepWeight *CorpLanEngrLanFW_GainLocalUIAccessDeviceWeight;
  StepWeight *EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  StepWeight *LinuxOS_GainRemoteUIAccessOSWeight;
  StepWeight *SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  StepWeight *LinuxOS_GainLocalUIAccessOSWeight;
  StepWeight *CorpLanScadaLanFW_GainLogicalAccessWeight;
  StepWeight *HMI_GainLocalUIAccessDeviceWeight;
  StepWeight *EngrLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  StepWeight *EngrLanScadaLanFW_CircumventFWRulesWeight;
  StepWeight *SCADALAN_GainNetworkAccessViaNetworkNodeWeight;
  StepWeight *CorpLanEngrLanFW_CircumventFWRulesWeight;
  StepWeight *EngrLanScadaLanFW_GainUserCredentialsWeight;
  StepWeight *DoNothingWeight;
  StepWeight *SSHServer_GainLogicalAccessWeight;
  StepWeight *CorpLanEngrLanFW_GainUserCredentialsWeight;
  StepWeight *HMI_GainLogicalAccessWeight;
  StepWeight *EngrWorkstation_GainUserCredentialsWeight;
  StepWeight *EngrLAN_GainNetworkAccessViaConnectedNetworkWeight;
  StepWeight *EngrWorkstation_GainLogicalAccessWeight;
  StepWeight *CorpLanEngrLanFW_AdminModifyFWOpenWeight;
  StepWeight *EngrWorkstation_GainLocalUIAccessDeviceWeight;
  StepWeight *SSHServer_GainUserCredentialsWeight;
  StepWeight *HMI_GainUserCredentialsWeight;
  StepWeight *CorpLAN_PlaceRogueHostOnNetworkWeight;
  StepWeight *CorpLanEngrLanFW_GainLogicalAccessWeight;
  StepWeight *CorpLanScadaLanFW_GainRemoteUIAccessDeviceWeight;
  StepWeight *EngrLAN_PlaceRogueHostOnNetworkWeight;
  StepWeight *EngrLanScadaLanFW_AdminModifyFWOpenWeight;
  StepWeight *EngrLAN_GainNetworkAccessViaNetworkNodeWeight;
  StepWeight *LinuxOS_GainLogicalAccessWeight;
  StepWeight *SCADALAN_PlaceRogueHostOnNetworkWeight;
  StepWeight *EngrLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  StepWeight *EngrWorkstation_GainRemoteUIAccessDeviceWeight;
  StepWeight *EngrLanScadaLanFW_GainLogicalAccessWeight;
  StepWeight *CorpLanScadaLanFW_CircumventFWRulesWeight;
  StepWeight *HMI_GainRemoteUIAccessDeviceWeight;
  StepWeight *SCADALAN_GainNetworkAccessViaConnectedNetworkWeight;
  StepWeight *CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkWeight;
  StepWeight *CorpLanScadaLanFW_GainLocalUIAccessDeviceWeight;
  //List of attack step chosen state variables
  StepChosen *CorpLAN_GainNetworkAccessViaNetworkNodeChosen;
  StepChosen *CorpLanScadaLanFW_GainUserCredentialsChosen;
  StepChosen *CorpLanEngrLanFW_GainRemoteUIAccessDeviceChosen;
  StepChosen *LinuxOS_GainUserCredentialsChosen;
  StepChosen *CorpLanScadaLanFW_AdminModifyFWOpenChosen;
  StepChosen *CorpLAN_GainNetworkAccessViaConnectedNetworkChosen;
  StepChosen *CorpLanEngrLanFW_GainLocalUIAccessDeviceChosen;
  StepChosen *EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkChosen;
  StepChosen *LinuxOS_GainRemoteUIAccessOSChosen;
  StepChosen *SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkChosen;
  StepChosen *LinuxOS_GainLocalUIAccessOSChosen;
  StepChosen *CorpLanScadaLanFW_GainLogicalAccessChosen;
  StepChosen *HMI_GainLocalUIAccessDeviceChosen;
  StepChosen *EngrLanScadaLanFW_GainRemoteUIAccessDeviceChosen;
  StepChosen *EngrLanScadaLanFW_CircumventFWRulesChosen;
  StepChosen *SCADALAN_GainNetworkAccessViaNetworkNodeChosen;
  StepChosen *CorpLanEngrLanFW_CircumventFWRulesChosen;
  StepChosen *EngrLanScadaLanFW_GainUserCredentialsChosen;
  StepChosen *DoNothingChosen;
  StepChosen *SSHServer_GainLogicalAccessChosen;
  StepChosen *CorpLanEngrLanFW_GainUserCredentialsChosen;
  StepChosen *HMI_GainLogicalAccessChosen;
  StepChosen *EngrWorkstation_GainUserCredentialsChosen;
  StepChosen *EngrLAN_GainNetworkAccessViaConnectedNetworkChosen;
  StepChosen *EngrWorkstation_GainLogicalAccessChosen;
  StepChosen *CorpLanEngrLanFW_AdminModifyFWOpenChosen;
  StepChosen *EngrWorkstation_GainLocalUIAccessDeviceChosen;
  StepChosen *SSHServer_GainUserCredentialsChosen;
  StepChosen *HMI_GainUserCredentialsChosen;
  StepChosen *CorpLAN_PlaceRogueHostOnNetworkChosen;
  StepChosen *CorpLanEngrLanFW_GainLogicalAccessChosen;
  StepChosen *CorpLanScadaLanFW_GainRemoteUIAccessDeviceChosen;
  StepChosen *EngrLAN_PlaceRogueHostOnNetworkChosen;
  StepChosen *EngrLanScadaLanFW_AdminModifyFWOpenChosen;
  StepChosen *EngrLAN_GainNetworkAccessViaNetworkNodeChosen;
  StepChosen *LinuxOS_GainLogicalAccessChosen;
  StepChosen *SCADALAN_PlaceRogueHostOnNetworkChosen;
  StepChosen *EngrLanScadaLanFW_GainLocalUIAccessDeviceChosen;
  StepChosen *EngrWorkstation_GainRemoteUIAccessDeviceChosen;
  StepChosen *EngrLanScadaLanFW_GainLogicalAccessChosen;
  StepChosen *CorpLanScadaLanFW_CircumventFWRulesChosen;
  StepChosen *HMI_GainRemoteUIAccessDeviceChosen;
  StepChosen *SCADALAN_GainNetworkAccessViaConnectedNetworkChosen;
  StepChosen *CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkChosen;
  StepChosen *CorpLanScadaLanFW_GainLocalUIAccessDeviceChosen;
  //List of attack steps
  CorpLAN_GainNetworkAccessViaNetworkNodeFailureStep CorpLAN_GainNetworkAccessViaNetworkNodeFailure;
  CorpLAN_GainNetworkAccessViaNetworkNodeSuccessStep CorpLAN_GainNetworkAccessViaNetworkNodeSuccess;
  CorpLanScadaLanFW_GainUserCredentialsFailureStep CorpLanScadaLanFW_GainUserCredentialsFailure;
  CorpLanScadaLanFW_GainUserCredentialsSuccessStep CorpLanScadaLanFW_GainUserCredentialsSuccess;
  CorpLanEngrLanFW_GainRemoteUIAccessDeviceFailureStep CorpLanEngrLanFW_GainRemoteUIAccessDeviceFailure;
  CorpLanEngrLanFW_GainRemoteUIAccessDeviceSuccessStep CorpLanEngrLanFW_GainRemoteUIAccessDeviceSuccess;
  LinuxOS_GainUserCredentialsFailureStep LinuxOS_GainUserCredentialsFailure;
  LinuxOS_GainUserCredentialsSuccessStep LinuxOS_GainUserCredentialsSuccess;
  CorpLanScadaLanFW_AdminModifyFWOpenFailureStep CorpLanScadaLanFW_AdminModifyFWOpenFailure;
  CorpLanScadaLanFW_AdminModifyFWOpenSuccessStep CorpLanScadaLanFW_AdminModifyFWOpenSuccess;
  CorpLAN_GainNetworkAccessViaConnectedNetworkFailureStep CorpLAN_GainNetworkAccessViaConnectedNetworkFailure;
  CorpLAN_GainNetworkAccessViaConnectedNetworkSuccessStep CorpLAN_GainNetworkAccessViaConnectedNetworkSuccess;
  CorpLanEngrLanFW_GainLocalUIAccessDeviceFailureStep CorpLanEngrLanFW_GainLocalUIAccessDeviceFailure;
  CorpLanEngrLanFW_GainLocalUIAccessDeviceSuccessStep CorpLanEngrLanFW_GainLocalUIAccessDeviceSuccess;
  EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkFailureStep EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkFailure;
  EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkSuccessStep EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkSuccess;
  LinuxOS_GainRemoteUIAccessOSFailureStep LinuxOS_GainRemoteUIAccessOSFailure;
  LinuxOS_GainRemoteUIAccessOSSuccessStep LinuxOS_GainRemoteUIAccessOSSuccess;
  SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkFailureStep SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkFailure;
  SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkSuccessStep SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkSuccess;
  LinuxOS_GainLocalUIAccessOSFailureStep LinuxOS_GainLocalUIAccessOSFailure;
  LinuxOS_GainLocalUIAccessOSSuccessStep LinuxOS_GainLocalUIAccessOSSuccess;
  CorpLanScadaLanFW_GainLogicalAccessFailureStep CorpLanScadaLanFW_GainLogicalAccessFailure;
  CorpLanScadaLanFW_GainLogicalAccessSuccessStep CorpLanScadaLanFW_GainLogicalAccessSuccess;
  HMI_GainLocalUIAccessDeviceFailureStep HMI_GainLocalUIAccessDeviceFailure;
  HMI_GainLocalUIAccessDeviceSuccessStep HMI_GainLocalUIAccessDeviceSuccess;
  EngrLanScadaLanFW_GainRemoteUIAccessDeviceFailureStep EngrLanScadaLanFW_GainRemoteUIAccessDeviceFailure;
  EngrLanScadaLanFW_GainRemoteUIAccessDeviceSuccessStep EngrLanScadaLanFW_GainRemoteUIAccessDeviceSuccess;
  EngrLanScadaLanFW_CircumventFWRulesFailureStep EngrLanScadaLanFW_CircumventFWRulesFailure;
  EngrLanScadaLanFW_CircumventFWRulesSuccessStep EngrLanScadaLanFW_CircumventFWRulesSuccess;
  SCADALAN_GainNetworkAccessViaNetworkNodeFailureStep SCADALAN_GainNetworkAccessViaNetworkNodeFailure;
  SCADALAN_GainNetworkAccessViaNetworkNodeSuccessStep SCADALAN_GainNetworkAccessViaNetworkNodeSuccess;
  CorpLanEngrLanFW_CircumventFWRulesFailureStep CorpLanEngrLanFW_CircumventFWRulesFailure;
  CorpLanEngrLanFW_CircumventFWRulesSuccessStep CorpLanEngrLanFW_CircumventFWRulesSuccess;
  EngrLanScadaLanFW_GainUserCredentialsFailureStep EngrLanScadaLanFW_GainUserCredentialsFailure;
  EngrLanScadaLanFW_GainUserCredentialsSuccessStep EngrLanScadaLanFW_GainUserCredentialsSuccess;
  DoNothingOutcome1Step DoNothingOutcome1;
  SSHServer_GainLogicalAccessFailureStep SSHServer_GainLogicalAccessFailure;
  SSHServer_GainLogicalAccessSuccessStep SSHServer_GainLogicalAccessSuccess;
  CorpLanEngrLanFW_GainUserCredentialsFailureStep CorpLanEngrLanFW_GainUserCredentialsFailure;
  CorpLanEngrLanFW_GainUserCredentialsSuccessStep CorpLanEngrLanFW_GainUserCredentialsSuccess;
  HMI_GainLogicalAccessFailureStep HMI_GainLogicalAccessFailure;
  HMI_GainLogicalAccessSuccessStep HMI_GainLogicalAccessSuccess;
  EngrWorkstation_GainUserCredentialsFailureStep EngrWorkstation_GainUserCredentialsFailure;
  EngrWorkstation_GainUserCredentialsSuccessStep EngrWorkstation_GainUserCredentialsSuccess;
  EngrLAN_GainNetworkAccessViaConnectedNetworkFailureStep EngrLAN_GainNetworkAccessViaConnectedNetworkFailure;
  EngrLAN_GainNetworkAccessViaConnectedNetworkSuccessStep EngrLAN_GainNetworkAccessViaConnectedNetworkSuccess;
  EngrWorkstation_GainLogicalAccessFailureStep EngrWorkstation_GainLogicalAccessFailure;
  EngrWorkstation_GainLogicalAccessSuccessStep EngrWorkstation_GainLogicalAccessSuccess;
  CorpLanEngrLanFW_AdminModifyFWOpenFailureStep CorpLanEngrLanFW_AdminModifyFWOpenFailure;
  CorpLanEngrLanFW_AdminModifyFWOpenSuccessStep CorpLanEngrLanFW_AdminModifyFWOpenSuccess;
  EngrWorkstation_GainLocalUIAccessDeviceFailureStep EngrWorkstation_GainLocalUIAccessDeviceFailure;
  EngrWorkstation_GainLocalUIAccessDeviceSuccessStep EngrWorkstation_GainLocalUIAccessDeviceSuccess;
  SSHServer_GainUserCredentialsFailureStep SSHServer_GainUserCredentialsFailure;
  SSHServer_GainUserCredentialsSuccessStep SSHServer_GainUserCredentialsSuccess;
  HMI_GainUserCredentialsFailureStep HMI_GainUserCredentialsFailure;
  HMI_GainUserCredentialsSuccessStep HMI_GainUserCredentialsSuccess;
  CorpLAN_PlaceRogueHostOnNetworkFailureStep CorpLAN_PlaceRogueHostOnNetworkFailure;
  CorpLAN_PlaceRogueHostOnNetworkSuccessStep CorpLAN_PlaceRogueHostOnNetworkSuccess;
  CorpLanEngrLanFW_GainLogicalAccessFailureStep CorpLanEngrLanFW_GainLogicalAccessFailure;
  CorpLanEngrLanFW_GainLogicalAccessSuccessStep CorpLanEngrLanFW_GainLogicalAccessSuccess;
  CorpLanScadaLanFW_GainRemoteUIAccessDeviceFailureStep CorpLanScadaLanFW_GainRemoteUIAccessDeviceFailure;
  CorpLanScadaLanFW_GainRemoteUIAccessDeviceSuccessStep CorpLanScadaLanFW_GainRemoteUIAccessDeviceSuccess;
  EngrLAN_PlaceRogueHostOnNetworkFailureStep EngrLAN_PlaceRogueHostOnNetworkFailure;
  EngrLAN_PlaceRogueHostOnNetworkSuccessStep EngrLAN_PlaceRogueHostOnNetworkSuccess;
  EngrLanScadaLanFW_AdminModifyFWOpenFailureStep EngrLanScadaLanFW_AdminModifyFWOpenFailure;
  EngrLanScadaLanFW_AdminModifyFWOpenSuccessStep EngrLanScadaLanFW_AdminModifyFWOpenSuccess;
  EngrLAN_GainNetworkAccessViaNetworkNodeFailureStep EngrLAN_GainNetworkAccessViaNetworkNodeFailure;
  EngrLAN_GainNetworkAccessViaNetworkNodeSuccessStep EngrLAN_GainNetworkAccessViaNetworkNodeSuccess;
  LinuxOS_GainLogicalAccessFailureStep LinuxOS_GainLogicalAccessFailure;
  LinuxOS_GainLogicalAccessSuccessStep LinuxOS_GainLogicalAccessSuccess;
  SCADALAN_PlaceRogueHostOnNetworkFailureStep SCADALAN_PlaceRogueHostOnNetworkFailure;
  SCADALAN_PlaceRogueHostOnNetworkSuccessStep SCADALAN_PlaceRogueHostOnNetworkSuccess;
  EngrLanScadaLanFW_GainLocalUIAccessDeviceFailureStep EngrLanScadaLanFW_GainLocalUIAccessDeviceFailure;
  EngrLanScadaLanFW_GainLocalUIAccessDeviceSuccessStep EngrLanScadaLanFW_GainLocalUIAccessDeviceSuccess;
  EngrWorkstation_GainRemoteUIAccessDeviceFailureStep EngrWorkstation_GainRemoteUIAccessDeviceFailure;
  EngrWorkstation_GainRemoteUIAccessDeviceSuccessStep EngrWorkstation_GainRemoteUIAccessDeviceSuccess;
  EngrLanScadaLanFW_GainLogicalAccessFailureStep EngrLanScadaLanFW_GainLogicalAccessFailure;
  EngrLanScadaLanFW_GainLogicalAccessSuccessStep EngrLanScadaLanFW_GainLogicalAccessSuccess;
  CorpLanScadaLanFW_CircumventFWRulesFailureStep CorpLanScadaLanFW_CircumventFWRulesFailure;
  CorpLanScadaLanFW_CircumventFWRulesSuccessStep CorpLanScadaLanFW_CircumventFWRulesSuccess;
  HMI_GainRemoteUIAccessDeviceFailureStep HMI_GainRemoteUIAccessDeviceFailure;
  HMI_GainRemoteUIAccessDeviceSuccessStep HMI_GainRemoteUIAccessDeviceSuccess;
  SCADALAN_GainNetworkAccessViaConnectedNetworkFailureStep SCADALAN_GainNetworkAccessViaConnectedNetworkFailure;
  SCADALAN_GainNetworkAccessViaConnectedNetworkSuccessStep SCADALAN_GainNetworkAccessViaConnectedNetworkSuccess;
  CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkFailureStep CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkFailure;
  CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkSuccessStep CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkSuccess;
  CorpLanScadaLanFW_GainLocalUIAccessDeviceFailureStep CorpLanScadaLanFW_GainLocalUIAccessDeviceFailure;
  CorpLanScadaLanFW_GainLocalUIAccessDeviceSuccessStep CorpLanScadaLanFW_GainLocalUIAccessDeviceSuccess;
  CorpLAN_GainNetworkAccessViaNetworkNodeAdversaryDecision CorpLAN_GainNetworkAccessViaNetworkNodeAD;
  CorpLanScadaLanFW_GainUserCredentialsAdversaryDecision CorpLanScadaLanFW_GainUserCredentialsAD;
  CorpLanEngrLanFW_GainRemoteUIAccessDeviceAdversaryDecision CorpLanEngrLanFW_GainRemoteUIAccessDeviceAD;
  LinuxOS_GainUserCredentialsAdversaryDecision LinuxOS_GainUserCredentialsAD;
  CorpLanScadaLanFW_AdminModifyFWOpenAdversaryDecision CorpLanScadaLanFW_AdminModifyFWOpenAD;
  CorpLAN_GainNetworkAccessViaConnectedNetworkAdversaryDecision CorpLAN_GainNetworkAccessViaConnectedNetworkAD;
  CorpLanEngrLanFW_GainLocalUIAccessDeviceAdversaryDecision CorpLanEngrLanFW_GainLocalUIAccessDeviceAD;
  EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkAdversaryDecision EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkAD;
  LinuxOS_GainRemoteUIAccessOSAdversaryDecision LinuxOS_GainRemoteUIAccessOSAD;
  SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkAdversaryDecision SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkAD;
  LinuxOS_GainLocalUIAccessOSAdversaryDecision LinuxOS_GainLocalUIAccessOSAD;
  CorpLanScadaLanFW_GainLogicalAccessAdversaryDecision CorpLanScadaLanFW_GainLogicalAccessAD;
  HMI_GainLocalUIAccessDeviceAdversaryDecision HMI_GainLocalUIAccessDeviceAD;
  EngrLanScadaLanFW_GainRemoteUIAccessDeviceAdversaryDecision EngrLanScadaLanFW_GainRemoteUIAccessDeviceAD;
  EngrLanScadaLanFW_CircumventFWRulesAdversaryDecision EngrLanScadaLanFW_CircumventFWRulesAD;
  SCADALAN_GainNetworkAccessViaNetworkNodeAdversaryDecision SCADALAN_GainNetworkAccessViaNetworkNodeAD;
  CorpLanEngrLanFW_CircumventFWRulesAdversaryDecision CorpLanEngrLanFW_CircumventFWRulesAD;
  EngrLanScadaLanFW_GainUserCredentialsAdversaryDecision EngrLanScadaLanFW_GainUserCredentialsAD;
  DoNothingAdversaryDecision DoNothingAD;
  SSHServer_GainLogicalAccessAdversaryDecision SSHServer_GainLogicalAccessAD;
  CorpLanEngrLanFW_GainUserCredentialsAdversaryDecision CorpLanEngrLanFW_GainUserCredentialsAD;
  HMI_GainLogicalAccessAdversaryDecision HMI_GainLogicalAccessAD;
  EngrWorkstation_GainUserCredentialsAdversaryDecision EngrWorkstation_GainUserCredentialsAD;
  EngrLAN_GainNetworkAccessViaConnectedNetworkAdversaryDecision EngrLAN_GainNetworkAccessViaConnectedNetworkAD;
  EngrWorkstation_GainLogicalAccessAdversaryDecision EngrWorkstation_GainLogicalAccessAD;
  CorpLanEngrLanFW_AdminModifyFWOpenAdversaryDecision CorpLanEngrLanFW_AdminModifyFWOpenAD;
  EngrWorkstation_GainLocalUIAccessDeviceAdversaryDecision EngrWorkstation_GainLocalUIAccessDeviceAD;
  SSHServer_GainUserCredentialsAdversaryDecision SSHServer_GainUserCredentialsAD;
  HMI_GainUserCredentialsAdversaryDecision HMI_GainUserCredentialsAD;
  CorpLAN_PlaceRogueHostOnNetworkAdversaryDecision CorpLAN_PlaceRogueHostOnNetworkAD;
  CorpLanEngrLanFW_GainLogicalAccessAdversaryDecision CorpLanEngrLanFW_GainLogicalAccessAD;
  CorpLanScadaLanFW_GainRemoteUIAccessDeviceAdversaryDecision CorpLanScadaLanFW_GainRemoteUIAccessDeviceAD;
  EngrLAN_PlaceRogueHostOnNetworkAdversaryDecision EngrLAN_PlaceRogueHostOnNetworkAD;
  EngrLanScadaLanFW_AdminModifyFWOpenAdversaryDecision EngrLanScadaLanFW_AdminModifyFWOpenAD;
  EngrLAN_GainNetworkAccessViaNetworkNodeAdversaryDecision EngrLAN_GainNetworkAccessViaNetworkNodeAD;
  LinuxOS_GainLogicalAccessAdversaryDecision LinuxOS_GainLogicalAccessAD;
  SCADALAN_PlaceRogueHostOnNetworkAdversaryDecision SCADALAN_PlaceRogueHostOnNetworkAD;
  EngrLanScadaLanFW_GainLocalUIAccessDeviceAdversaryDecision EngrLanScadaLanFW_GainLocalUIAccessDeviceAD;
  EngrWorkstation_GainRemoteUIAccessDeviceAdversaryDecision EngrWorkstation_GainRemoteUIAccessDeviceAD;
  EngrLanScadaLanFW_GainLogicalAccessAdversaryDecision EngrLanScadaLanFW_GainLogicalAccessAD;
  CorpLanScadaLanFW_CircumventFWRulesAdversaryDecision CorpLanScadaLanFW_CircumventFWRulesAD;
  HMI_GainRemoteUIAccessDeviceAdversaryDecision HMI_GainRemoteUIAccessDeviceAD;
  SCADALAN_GainNetworkAccessViaConnectedNetworkAdversaryDecision SCADALAN_GainNetworkAccessViaConnectedNetworkAD;
  CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkAdversaryDecision CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkAD;
  CorpLanScadaLanFW_GainLocalUIAccessDeviceAdversaryDecision CorpLanScadaLanFW_GainLocalUIAccessDeviceAD;
  //Groups for attack steps
  PreselectGroup ImmediateGroup;
  PostselectGroup CorpLAN_GainNetworkAccessViaNetworkNodeGroup;
  PostselectGroup CorpLanScadaLanFW_GainUserCredentialsGroup;
  PostselectGroup CorpLanEngrLanFW_GainRemoteUIAccessDeviceGroup;
  PostselectGroup LinuxOS_GainUserCredentialsGroup;
  PostselectGroup CorpLanScadaLanFW_AdminModifyFWOpenGroup;
  PostselectGroup CorpLAN_GainNetworkAccessViaConnectedNetworkGroup;
  PostselectGroup CorpLanEngrLanFW_GainLocalUIAccessDeviceGroup;
  PostselectGroup EngrLAN_GainNetworkAccessViaNodeOnConnectedNetworkGroup;
  PostselectGroup LinuxOS_GainRemoteUIAccessOSGroup;
  PostselectGroup SCADALAN_GainNetworkAccessViaNodeOnConnectedNetworkGroup;
  PostselectGroup LinuxOS_GainLocalUIAccessOSGroup;
  PostselectGroup CorpLanScadaLanFW_GainLogicalAccessGroup;
  PostselectGroup HMI_GainLocalUIAccessDeviceGroup;
  PostselectGroup EngrLanScadaLanFW_GainRemoteUIAccessDeviceGroup;
  PostselectGroup EngrLanScadaLanFW_CircumventFWRulesGroup;
  PostselectGroup SCADALAN_GainNetworkAccessViaNetworkNodeGroup;
  PostselectGroup CorpLanEngrLanFW_CircumventFWRulesGroup;
  PostselectGroup EngrLanScadaLanFW_GainUserCredentialsGroup;
  PostselectGroup SSHServer_GainLogicalAccessGroup;
  PostselectGroup CorpLanEngrLanFW_GainUserCredentialsGroup;
  PostselectGroup HMI_GainLogicalAccessGroup;
  PostselectGroup EngrWorkstation_GainUserCredentialsGroup;
  PostselectGroup EngrLAN_GainNetworkAccessViaConnectedNetworkGroup;
  PostselectGroup EngrWorkstation_GainLogicalAccessGroup;
  PostselectGroup CorpLanEngrLanFW_AdminModifyFWOpenGroup;
  PostselectGroup EngrWorkstation_GainLocalUIAccessDeviceGroup;
  PostselectGroup SSHServer_GainUserCredentialsGroup;
  PostselectGroup HMI_GainUserCredentialsGroup;
  PostselectGroup CorpLAN_PlaceRogueHostOnNetworkGroup;
  PostselectGroup CorpLanEngrLanFW_GainLogicalAccessGroup;
  PostselectGroup CorpLanScadaLanFW_GainRemoteUIAccessDeviceGroup;
  PostselectGroup EngrLAN_PlaceRogueHostOnNetworkGroup;
  PostselectGroup EngrLanScadaLanFW_AdminModifyFWOpenGroup;
  PostselectGroup EngrLAN_GainNetworkAccessViaNetworkNodeGroup;
  PostselectGroup LinuxOS_GainLogicalAccessGroup;
  PostselectGroup SCADALAN_PlaceRogueHostOnNetworkGroup;
  PostselectGroup EngrLanScadaLanFW_GainLocalUIAccessDeviceGroup;
  PostselectGroup EngrWorkstation_GainRemoteUIAccessDeviceGroup;
  PostselectGroup EngrLanScadaLanFW_GainLogicalAccessGroup;
  PostselectGroup CorpLanScadaLanFW_CircumventFWRulesGroup;
  PostselectGroup HMI_GainRemoteUIAccessDeviceGroup;
  PostselectGroup SCADALAN_GainNetworkAccessViaConnectedNetworkGroup;
  PostselectGroup CorpLAN_GainNetworkAccessViaNodeOnConnectedNetworkGroup;
  PostselectGroup CorpLanScadaLanFW_GainLocalUIAccessDeviceGroup;
  PostselectGroup AdversaryDecisionGroup;
  SystemConfiguration_StrongFirewallsADVISE();
  ~SystemConfiguration_StrongFirewallsADVISE();
  void assignSVsToAttackSteps();
  double convertCostToUtility(double cost);
  double convertDetectionToUtility(double detections);
  double convertPayoffToUtility(double payoff);
  void customInitialization();

protected:
}; // end SystemConfiguration_StrongFirewallsADVISE

#endif // SystemConfiguration_StrongFirewallsADVISE_H_
